// 3DOEditor.h : main header file for the 3DOEDITOR application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

class CMainFrame;

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorApp:
// See 3DOEditor.cpp for the implementation of this class
//
class CObjectTree;

class CMy3DOEditorApp : public CWinApp
{
public:
	CMultiDocTemplate* pDatTemplate;
	CMultiDocTemplate* pDocTemplate;
	CMultiDocTemplate* pLpTemplate;
	CMultiDocTemplate* pPckTemplate;
	CMultiDocTemplate* pTrkTemplate;
	CMultiDocTemplate* pTrkInfoTemplate;

	CMy3DOEditorApp();

	~CMy3DOEditorApp()
	{
		if (pImageList)
		{
			delete pImageList;
			pImageList = NULL;
		}
	}

	void LoadImages();
	CImageList* pImageList;

	CImageList* getSharedImageList()
	{
		return pImageList;
	}

	CObjectTree *m_MainTree;
	CMainFrame  *pMainFrame;

	CString getWinMipLocation();
	CString getGPLLocation();

	void OnTablesTrackview(CDocument *pDoc) ;

	BOOL CheckCurrentEditorVersion();

	
	CView * OnC3doView(CDocument *pDoc);
	void OnLpView(CDocument *pDoc);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMy3DOEditorApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CMy3DOEditorApp)
	afx_msg void OnAppAbout();
	afx_msg void OnHelpCredits();
	afx_msg void OnStartwinmip();
	afx_msg void OnStartgpl();
	afx_msg void OnEditWinMipLocation();
	afx_msg void OnEditGPLLocation();
	afx_msg void OnFileImportpalette();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void ShowTipAtStartup(void);
private:
	void ShowTipOfTheDay(void);
};


/////////////////////////////////////////////////////////////////////////////
