// 3DOEditorDoc.cpp : implementation of the CMy3DOEditorDoc class
//

#include "stdafx.h"
#include "3DOEditor.h"

#include "3DOEditorDoc.h"
#include "EditOneSVar.h"
#include "PolygonColorChanger.h"

#include <fstream.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorDoc

IMPLEMENT_DYNCREATE(CMy3DOEditorDoc, CDocument)

BEGIN_MESSAGE_MAP(CMy3DOEditorDoc, CDocument)
	//{{AFX_MSG_MAP(CMy3DOEditorDoc)
	ON_COMMAND(ID_NEWPOINT, OnNewpoint)
	ON_COMMAND(ID_NEWPLANE, OnNewplane)
	ON_COMMAND(ID_NEWNORMAL, OnNewnormal)
	ON_COMMAND(ID_NEWSTRING, OnNewstring)
	ON_COMMAND(ID_EDIT_FINDNODEBYOFFSET, OnEditFindnodebyoffset)
	ON_COMMAND(ID_EDIT_CHANGECOLOR, OnEditChangecolor)
	ON_COMMAND(ID_FILE_EXPORTT15LIST, OnFileExportt15list)
	ON_COMMAND(ID_FILE_EXPORT3DOTEXT, OnFileExport3dotext)
	ON_COMMAND(ID_FILE_IMPORT3DOTEXT, OnFileImport3dotext)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_EXPORT3DOOBJ, OnFileExport3doobj)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorDoc construction/destruction
#define PROFILE(x,y,b) x = AfxGetApp()->GetProfileInt(CString(#y), CString(#x),b);
#define WR_PROFILE(x,y) AfxGetApp()->WriteProfileInt(CString(#y), #x,x);

CMy3DOEditorDoc::CMy3DOEditorDoc()
{
	object = NULL;
	FileNode = NULL;
	singleDocument = FALSE;

	PROFILE(showPoints,3doPreferences,FALSE);
	PROFILE(showTextures,3doPreferences,FALSE);
	PROFILE(showAxis,3doPreferences,TRUE);
	PROFILE(showRandomColors,3doPreferences,FALSE);
	int DefaultColor = RGB(255,255,255);
	PROFILE(backgroundColor,3doPreferences,DefaultColor);
	
	PROFILE(showSubObjectLocations,3doPreferences,TRUE);
	PROFILE(showCameras,3doPreferences,TRUE);
	

	int DefaultviewType = t_Polygon;
	int CurrentViewType; 
	PROFILE(CurrentViewType,3doPreferences,DefaultviewType);
	viewType = (e_ViewType)CurrentViewType;
	
	PROFILE(showPointNumbers,3doPreferences,FALSE);
	PROFILE(showObjects,3doPreferences,FALSE);
	PROFILE(showSrbs,3doPreferences,FALSE);
	//showPointNumbers = FALSE;
	//showObjects = FALSE;
	
	drawDistance = -1;
	showSrbs = FALSE;
	show3do = TRUE;	
	dist=50.0;

	PROFILE(showRoads,3doPreferences,TRUE);
	PROFILE(showGrass,3doPreferences,TRUE);
	PROFILE(showWalls,3doPreferences,TRUE);

	PROFILE(showCar,3doPreferences,TRUE);
	PROFILE(showHorizon,3doPreferences,TRUE);
	PROFILE(showCrowds,3doPreferences,TRUE);
	PROFILE(showClouds,3doPreferences,TRUE);
	PROFILE(showTrees,3doPreferences,TRUE);
	PROFILE(showBillboard,3doPreferences,TRUE);
	PROFILE(showBrakeMarks,3doPreferences,TRUE);
	PROFILE(showVehicles,3doPreferences,TRUE);
	PROFILE(showInfield,3doPreferences,TRUE);
	PROFILE(showGrandstand,3doPreferences,TRUE);
	PROFILE(showPeople,3doPreferences,TRUE);
	PROFILE(showFence,3doPreferences,TRUE);

	PROFILE(showCameraNumbers,3doPreferences,TRUE);
	PROFILE(showPlanes,3doPreferences,FALSE);
	PROFILE(showTrk,3doPreferences,TRUE);
	PROFILE(showRooms,3doPreferences,TRUE);
	PROFILE(showSubObjects,3doPreferences,TRUE);
	PROFILE(showVertexNormals,3doPreferences,FALSE);
	PROFILE(showFiftenBoxes,3doPreferences,FALSE);
	PROFILE(showFilled,3doPreferences,FALSE);


	int normalSizeSC;
	PROFILE(normalSizeSC,3doPreferences,200);
	normalSize = ((float)normalSizeSC/1000.0f);

	int normalScaleSC;
	PROFILE(normalScaleSC,3doPreferences,1000);
	normalScale = ((float)normalScaleSC/1000.0f);
}

CMy3DOEditorDoc::~CMy3DOEditorDoc()
{
	if (object && object->FileNode) {
		if (singleDocument)
		{
		((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->m_ObjectTree.DeleteItem(object->FileNode);
		object->FileNode = NULL; 
		}
	}
	if (singleDocument && object) {
		delete object;
	    object = NULL;
	}


	WR_PROFILE(showPoints,3doPreferences);
	WR_PROFILE(showTextures,3doPreferences);
	WR_PROFILE(showAxis,3doPreferences);
	int CurrentViewType = (int)viewType;
	WR_PROFILE(CurrentViewType,3doPreferences);
	WR_PROFILE(showPointNumbers,3doPreferences);
	WR_PROFILE(showObjects,3doPreferences);
	WR_PROFILE(showSrbs,3doPreferences);
	WR_PROFILE(backgroundColor,3doPreferences);
	
	WR_PROFILE(showSubObjectLocations,3doPreferences);
	WR_PROFILE(showCameraNumbers,3doPreferences);

	WR_PROFILE(showCar,3doPreferences);
	WR_PROFILE(showHorizon,3doPreferences);
	WR_PROFILE(showCrowds,3doPreferences);
	WR_PROFILE(showClouds,3doPreferences);
	WR_PROFILE(showTrees,3doPreferences);
	WR_PROFILE(showBillboard,3doPreferences);
	WR_PROFILE(showBrakeMarks,3doPreferences);
	WR_PROFILE(showVehicles,3doPreferences);
	WR_PROFILE(showInfield,3doPreferences);
	WR_PROFILE(showGrandstand,3doPreferences);
	WR_PROFILE(showPeople,3doPreferences);
	WR_PROFILE(showFence,3doPreferences);

	WR_PROFILE(showFiftenBoxes,3doPreferences);
	WR_PROFILE(showFilled,3doPreferences);
	

	WR_PROFILE(showCameras,3doPreferences);
	WR_PROFILE(showVertexNormals,3doPreferences);

	int normalSizeSC;
	int normalScaleSC;
	
	normalScaleSC = (int)(normalScale*1000.0);
	normalSizeSC  = (int)(normalSize*1000.0);

	WR_PROFILE(normalSizeSC,3doPreferences);
	WR_PROFILE(normalScaleSC,3doPreferences);
	
}

BOOL CMy3DOEditorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorDoc serialization

void CMy3DOEditorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorDoc diagnostics

#ifdef _DEBUG
void CMy3DOEditorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMy3DOEditorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorDoc commands

BOOL CMy3DOEditorDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here
	object = new C3do(this);
	object->filename = strdup(lpszPathName); 
	object->Read(lpszPathName);
	singleDocument = TRUE;
	HTREEITEM RootNode = ((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->m_ObjectTree.GetRootItem();

	CString buffer;
	buffer.Format("3DO File %s",lpszPathName);
	object->FileNode = ((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->insertInfoNode(RootNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OBJECT));
	((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->m_ObjectTree.SetItemData(object->FileNode,(DWORD)object);
	object->LoadTree(object->FileNode,((CMy3DOEditorApp*)AfxGetApp())->m_MainTree);
	
	return TRUE;
}

BOOL CMy3DOEditorDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	// TODO: Add your specialized code here and/or call the base class
	//
	//return CDocument::OnSaveDocument(lpszPathName);
	if (object == NULL)
	{
	 AfxMessageBox("You Must Save the TrackFile that this 3do object is part of");
	}
	else
	{
		  CGplFile * file = (CGplFile*)object;
		  if (file)
		  {
			  file->GetFile();
		      file->SaveAs(lpszPathName);
		  }
		  else
		  {
			  AfxMessageBox("Cannot Find File to Save");
		  }
	}
	return FALSE;
}

void CMy3DOEditorDoc::OnFileSaveAs() 
{
	if (object)
	{
		  CGplFile * file = (CGplFile*)object;
		  if (file)
		  {
			  file->GetFile();
		      file->SaveAs(NULL);
		  }
		  else
		  {
			  AfxMessageBox("Cannot Find File to Save");
		  }
	}
	else
	{
		AfxMessageBox("Don't know how to save this file");
	}
}

void CMy3DOEditorDoc::OnNewpoint() 
{
	if (object)
	{
		Point3D *newpt = new Point3D();
		object->addPoint(newpt);
		newpt->Explore(NULL);
		object->UpdateTree(NULL);
	}
	else
	{
		AfxMessageBox("No Object Present");
	}
}

void CMy3DOEditorDoc::OnNewplane() 
{
	if (object)
	{
		CPlanes *newpt = new CPlanes();
		object->addPlane(newpt);
		newpt->Explore();
		object->UpdateTree(NULL);
	}
	else
	{
		AfxMessageBox("No Object Present");
	}
}

void CMy3DOEditorDoc::OnNewnormal() 
{
	if (object)
	{
		CNormals *newpt = new CNormals();
		object->addNormal(newpt);
		newpt->Explore();
		object->UpdateTree(NULL);
	}
	else
	{
		AfxMessageBox("No Object Present");
	}
}

void CMy3DOEditorDoc::OnNewstring() 
{
	if (object)
	{
		CImageFile *newstr = object->addString("unknown");
	    newstr->Rename();
		object->UpdateTree(NULL);
	}
	else
	{
		AfxMessageBox("No 3DO Object Present");
	}
}

void CMy3DOEditorDoc::OnEditFindnodebyoffset() 
{
	CEditOneSVar *dlg = new CEditOneSVar();

	dlg->m_VarVal1.Format("0x0");
	dlg->m_Var1.Format("Node Offset");
	dlg->m_Desc.Format("Node Offset in hex the number in [value]");
	
	int result = dlg->DoModal();

	if (result == IDOK)
	{
		int val=0;
		sscanf(dlg->m_VarVal1,"%x",&val);
		int offsetToFind = val+object->primTree->getOffset();
		Node *updateNode = object->theNodeRepository.FindNode(offsetToFind);
		if (object && updateNode)
		{
			object->UpdateTree(updateNode);
		}
	}

	if (dlg) delete dlg;
}

void CMy3DOEditorDoc::OnEditChangecolor() 
{
	CPolygonColorChanger * dlg = new CPolygonColorChanger();

	dlg->m_FromAlpha = 0;
	dlg->m_FromRed = 0;
	dlg->m_FromGreen = 0;
	dlg->m_FromBlue = 0;
	dlg->m_ToAlpha = 0;
	dlg->m_ToRed = 0;
	dlg->m_ToGreen = 0;
	dlg->m_ToBlue = 0;
	int result = dlg->DoModal();
	

	if (result == IDOK)
	{
	   POSITION pos = object->theNodeRepository.repository->GetStartPosition();

	   int fcolor = (dlg->m_FromAlpha << 24) +(dlg->m_FromRed << 16) + (dlg->m_FromGreen << 8) + (dlg->m_FromBlue);
	   int tcolor = (dlg->m_ToAlpha << 24) +(dlg->m_ToRed << 16) + (dlg->m_ToGreen << 8) + (dlg->m_ToBlue);
		
		while(pos !=NULL)
		{
		 int key;
		 Node *ptr;
		 object->theNodeRepository.repository->GetNextAssoc(pos,key,ptr);
		 if (ptr->type >= 0x81b && ptr->type <= 0x821) 
		 {
			 BOOL change = FALSE;
			 NodePolygon *poly = (NodePolygon*)ptr;
			 			 
			 if (poly->color  == fcolor) change = TRUE;			 
			 if (dlg->m_ChangeAll) change = TRUE;
			 if (change)
			 {
				 cerr << "Changing Polygon - " << ptr->toString() << endl;
				 poly->color = tcolor;
			 }
		 }
		}	
	}
}

void CMy3DOEditorDoc::OnFileExportt15list() 
{
	POSITION pos = object->theNodeRepository.repository->GetStartPosition();
	ofstream file("t15out.txt");

	while(pos !=NULL)
	{
		 int key;
		 Node *ptr;
		 object->theNodeRepository.repository->GetNextAssoc(pos,key,ptr);
		 if (ptr->type == 0xF)
		 {
			 NodeFifteen *node = (NodeFifteen*)ptr;
			 node->DisplayNodeAndChildren(file);
		 }
	}
}

static char lpszImportInFilter[] = "3DO Export Data (*.txt)|*.txt|";


	
	
void CMy3DOEditorDoc::OnFileExport3dotext() 
{
	char fileName[256];
	strcpy(fileName,"*.txt");
	CFileDialog *fdlg = new CFileDialog(FALSE,"txt",(LPCSTR)&fileName,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,lpszImportInFilter);
	int result = fdlg->DoModal();

	if (result != IDCANCEL)
	{
	   CString filename = fdlg->GetFileName();
	   
	   object->ExportDataTxt(filename);
	}
	delete fdlg;
}

void CMy3DOEditorDoc::OnFileImport3dotext() 
{
	char fileName[256];
	strcpy(fileName,"*.txt");

	CFileDialog *fdlg = new CFileDialog(TRUE,"txt",(LPCSTR)&fileName,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,lpszImportInFilter);
	int result = fdlg->DoModal();
	
	if (result != IDCANCEL)
	{
	   CString filename = fdlg->GetFileName();
	   object->ImportDataTxt(filename);
	}
	delete fdlg;
}


static char lpszImportInObjFilter[] = "WaveFront Export Data (*.obj)|*.obj|";

void CMy3DOEditorDoc::OnFileExport3doobj() 
{
	char fileName[256];
	strcpy(fileName,"*.obj");
	CFileDialog *fdlg = new CFileDialog(FALSE,"obj",(LPCSTR)&fileName,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,lpszImportInObjFilter);
	int result = fdlg->DoModal();

	if (result != IDCANCEL)
	{
	   CString filename = fdlg->GetFileName();
	   
	   object->ExportDataObj(filename);
	}
	delete fdlg;
}
