// 3DOEditorDoc.h : interface of the CMy3DOEditorDoc class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef _INCLUDED_DOC_H_
#define _INCLUDED_DOC_H_
#include "C3do.h"

typedef enum 
{
	t_WireFrame,t_Polygon,t_Texture,t_PolygonOutlines
} e_ViewType;


class CMy3DOEditorDoc : public CDocument
{
public: // create from serialization only
	CMy3DOEditorDoc();
protected:
	DECLARE_DYNCREATE(CMy3DOEditorDoc)

// Attributes
public:
	C3do *object;
	HTREEITEM FileNode;
		int showPoints;
	int showTextures;
	int showAxis;
	BOOL showPointNumbers;
	BOOL showObjects;
	BOOL showSrbs;
	
	BOOL showSubObjectLocations;
	int drawDistance;	
	BOOL show3do;
	BOOL showTrk;
	BOOL showPlanes;
	BOOL showRoads;
	BOOL showWalls;
	BOOL showGrass;
	BOOL showSubObjects;
	BOOL showCar;
	BOOL showHorizon;
	BOOL showCrowds;
	BOOL showClouds;
	BOOL showTrees;
	BOOL showBillboard;
	BOOL showBrakeMarks;
	BOOL showVehicles;
	BOOL showInfield;
	BOOL showGrandstand;
	BOOL showPeople;
	BOOL showFence;
	BOOL showCameras;
	BOOL showCameraNumbers;
	BOOL showRooms;
	BOOL showVertexNormals;
	BOOL showRandomColors;
	BOOL showFiftenBoxes;
	BOOL showFilled;
	COLORREF backgroundColor;
	double dist;

	float  normalSize;
	float  normalScale;
	e_ViewType viewType;

	void setObject(C3do *obj)
	{
		object = obj;
	}

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMy3DOEditorDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMy3DOEditorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	BOOL singleDocument;

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMy3DOEditorDoc)
	afx_msg void OnViewMiplist();
	afx_msg void OnNewpoint();
	afx_msg void OnNewplane();
	afx_msg void OnNewnormal();
	afx_msg void OnNewstring();
	afx_msg void OnEditFindnodebyoffset();
	afx_msg void OnEditChangecolor();
	afx_msg void OnFileExportt15list();
	afx_msg void OnFileExport3dotext();
	afx_msg void OnFileImport3dotext();
	afx_msg void OnFileExport3doobj();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


	afx_msg void OnFileSaveAs();
};

/////////////////////////////////////////////////////////////////////////////

#endif
