// 3DOEditorView.cpp : implementation of the CMy3DOEditorView class
//

#include "stdafx.h"
#include "3DOEditor.h"

#include "3DOEditorDoc.h"
#include "3DOEditorView.h"
#include "PtsEdit.h"
#include "math.h"
#include "Cam.h"
#include "EditTwoFVar.h"
#include "EditOneFVar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <gl\glaux.h>
#include <gl\gl.h>
#include <gl\glu.h>

void setGLColor(float r,float g,float b);

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorView

IMPLEMENT_DYNCREATE(CMy3DOEditorView, COpenGLView)

BEGIN_MESSAGE_MAP(CMy3DOEditorView, COpenGLView)
	//{{AFX_MSG_MAP(CMy3DOEditorView)
	ON_COMMAND(ID_SHOW_AXIS, OnShowAxis)
	ON_COMMAND(ID_SHOW_POINTS, OnShowPoints)
	ON_COMMAND(ID_SHOW_TEXTURES, OnShowTextures)
	ON_UPDATE_COMMAND_UI(ID_SHOW_AXIS, OnUpdateShowAxis)
	ON_UPDATE_COMMAND_UI(ID_SHOW_POINTS, OnUpdateShowPoints)
	ON_UPDATE_COMMAND_UI(ID_SHOW_TEXTURES, OnUpdateShowTextures)
	ON_COMMAND(ID_ZOOMIN, OnZoomin)
	ON_COMMAND(ID_ZOOMOUT, OnZoomout)
	ON_COMMAND(ID_OPTIONS_FILLEDPOLYGONS, OnOptionsFilledpolygons)
	ON_COMMAND(ID_OPTIONS_TEXTUREPOLYGONS, OnOptionsTexturepolygons)
	ON_COMMAND(ID_OPTIONS_USERANDOMPOLYGONCOLORS, OnOptionsUserandompolygoncolors)
	ON_COMMAND(ID_OPTIONS_WIREFRAME, OnOptionsWireframe)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_WIREFRAME, OnUpdateOptionsWireframe)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_USERANDOMPOLYGONCOLORS, OnUpdateOptionsUserandompolygoncolors)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_TEXTUREPOLYGONS, OnUpdateOptionsTexturepolygons)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_FILLEDPOLYGONS, OnUpdateOptionsFilledpolygons)
	ON_COMMAND(ID_OPTIONS_BLACKBACKGROUND, OnOptionsBlackbackground)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_BLACKBACKGROUND, OnUpdateOptionsBlackbackground)
	ON_COMMAND(ID_OPTIONS_WHITEBACKGROUND, OnOptionsWhitebackground)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_WHITEBACKGROUND, OnUpdateOptionsWhitebackground)
	ON_WM_CREATE()
	ON_COMMAND(ID_SHOWPOINTNUMBERS, OnShowpointnumbers)
	ON_UPDATE_COMMAND_UI(ID_SHOWPOINTNUMBERS, OnUpdateShowpointnumbers)
	ON_COMMAND(ID_SHOWOBJECTS, OnShowobjects)
	ON_UPDATE_COMMAND_UI(ID_SHOWOBJECTS, OnUpdateShowobjects)
	ON_COMMAND(ID_EDIT_UPDATETRACK, OnEditUpdatetrack)
	ON_COMMAND(ID_EDIT_SELECTVIEWPOINT, OnEditSelectviewpoint)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_OPTIONS_GREYBACKGROUND, OnOptionsGreybackground)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_OPTIONS_OUTLINEDPOLYGONS, OnOptionsOutlinedpolygons)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_OUTLINEDPOLYGONS, OnUpdateOptionsOutlinedpolygons)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_DRAWLASTONLY, OnOptionsDrawdistancesDrawlastonly)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_DRAWLASTONLY, OnUpdateOptionsDrawdistancesDrawlastonly)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_DRAWALL, OnOptionsDrawdistancesDrawall)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_DRAWALL, OnUpdateOptionsDrawdistancesDrawall)
	ON_COMMAND(ID_VIEWSRB, OnViewsrb)
	ON_UPDATE_COMMAND_UI(ID_VIEWSRB, OnUpdateViewsrb)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONDOWN()
	ON_WM_MBUTTONUP()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_100METERS, OnOptionsDrawdistances100meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_100METERS, OnUpdateOptionsDrawdistances100meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_150METERS, OnOptionsDrawdistances150meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_150METERS, OnUpdateOptionsDrawdistances150meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_50METERS, OnOptionsDrawdistances50meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_50METERS, OnUpdateOptionsDrawdistances50meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_30METERS, OnOptionsDrawdistances30meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_30METERS, OnUpdateOptionsDrawdistances30meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_20METERS, OnOptionsDrawdistances20meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_20METERS, OnUpdateOptionsDrawdistances20meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_10METERS, OnOptionsDrawdistances10meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_10METERS, OnUpdateOptionsDrawdistances10meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_5METERS, OnOptionsDrawdistances5meters)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_5METERS, OnUpdateOptionsDrawdistances5meters)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_LASTINVIEWDISTANCEARRAYS, OnOptionsDrawdistancesLastinviewdistancearrays)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_LASTINVIEWDISTANCEARRAYS, OnUpdateOptionsDrawdistancesLastinviewdistancearrays)
	ON_COMMAND(ID_OPTIONS_DRAWDISTANCES_EVERYTHINGVSLOW, OnOptionsDrawdistancesEverythingvslow)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDISTANCES_EVERYTHINGVSLOW, OnUpdateOptionsDrawdistancesEverythingvslow)
	ON_COMMAND(ID_OPTIONS_DOUBLEBUFFERING, OnOptionsDoublebuffering)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DOUBLEBUFFERING, OnUpdateOptionsDoublebuffering)
	ON_COMMAND(ID_OPTIONS_SORTNODEREPOSITORY_BYOFFSET, OnOptionsSortnoderepositoryByoffset)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SORTNODEREPOSITORY_BYOFFSET, OnUpdateOptionsSortnoderepositoryByoffset)
	ON_COMMAND(ID_OPTIONS_SORTNODEREPOSITORY_BYTYPE, OnOptionsSortnoderepositoryBytype)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SORTNODEREPOSITORY_BYTYPE, OnUpdateOptionsSortnoderepositoryBytype)
	ON_COMMAND(ID_OPTIONS_SHOWSUBOBJECTLOCATIONS, OnOptionsShowsubobjectlocations)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SHOWSUBOBJECTLOCATIONS, OnUpdateOptionsShowsubobjectlocations)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_ASPHALT, OnViewDisplayclassesAsphalt)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_ASPHALT, OnUpdateViewDisplayclassesAsphalt)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_FENCE, OnViewDisplayclassesFence)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_FENCE, OnUpdateViewDisplayclassesFence)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_BILLBOARD, OnViewDisplayclassesBillboard)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_BILLBOARD, OnUpdateViewDisplayclassesBillboard)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_BRAKEMARKER, OnViewDisplayclassesBrakemarker)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_BRAKEMARKER, OnUpdateViewDisplayclassesBrakemarker)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_CAR, OnViewDisplayclassesCar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_CAR, OnUpdateViewDisplayclassesCar)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_CLOUDS, OnViewDisplayclassesClouds)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_CLOUDS, OnUpdateViewDisplayclassesClouds)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_CROWDDD, OnViewDisplayclassesCrowddd)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_CROWDDD, OnUpdateViewDisplayclassesCrowddd)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_GRANDSTAND, OnViewDisplayclassesGrandstand)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_GRANDSTAND, OnUpdateViewDisplayclassesGrandstand)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_GRASS, OnViewDisplayclassesGrass)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_GRASS, OnUpdateViewDisplayclassesGrass)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_HORIZON, OnViewDisplayclassesHorizon)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_HORIZON, OnUpdateViewDisplayclassesHorizon)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_INFIELD, OnViewDisplayclassesInfield)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_INFIELD, OnUpdateViewDisplayclassesInfield)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_OBJECT, OnViewDisplayclassesObject)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_OBJECT, OnUpdateViewDisplayclassesObject)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_PEOPLE, OnViewDisplayclassesPeople)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_PEOPLE, OnUpdateViewDisplayclassesPeople)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_TREE, OnViewDisplayclassesTree)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_TREE, OnUpdateViewDisplayclassesTree)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_VECHICLE, OnViewDisplayclassesVechicle)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_VECHICLE, OnUpdateViewDisplayclassesVechicle)
	ON_COMMAND(ID_VIEW_DISPLAYCLASSES_WALL, OnViewDisplayclassesWall)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DISPLAYCLASSES_WALL, OnUpdateViewDisplayclassesWall)
	ON_COMMAND(ID_SHOWCAMERAS, OnShowcameras)
	ON_UPDATE_COMMAND_UI(ID_SHOWCAMERAS, OnUpdateShowcameras)
	ON_COMMAND(ID_OPTIONS_SHOWCAMERANUMBERS, OnOptionsShowcameranumbers)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SHOWCAMERANUMBERS, OnUpdateOptionsShowcameranumbers)
	ON_COMMAND(ID_RIGHTPOP_SETTOPDRAWLOCATION, OnRightpopSettopdrawlocation)
	ON_COMMAND(ID_RIGHTPOP_ADDTOPDRAWLOCATION, OnRightpopAddtopdrawlocation)	
	ON_COMMAND(ID_EDIT_DEVELOPMENT_REPLACEYS, OnEditDevelopmentReplaceys)
	ON_COMMAND(ID_EDIT_DEVELOPMENT_REPLACEXS, OnEditDevelopmentReplacexs)
	ON_COMMAND(ID_EDIT_DEVELOPMENT_REPLACEZS, OnEditDevelopmentReplacezs)
	ON_COMMAND(ID_SHOWTRACK, OnShowtrack)
	ON_UPDATE_COMMAND_UI(ID_SHOWTRACK, OnUpdateShowtrack)
	ON_UPDATE_COMMAND_UI(ID_DRAWPLANES, OnUpdateDrawplanes)
	ON_COMMAND(ID_SHOWTHREEDO, OnShowthreedo)
	ON_UPDATE_COMMAND_UI(ID_SHOWTHREEDO, OnUpdateShowthreedo)
	ON_COMMAND(ID_DRAWPLANES, OnDrawplanes)
	ON_COMMAND(ID_OPTIONS_SETNORMALSQUARESIZE, OnOptionsSetnormalsquaresize)
	ON_COMMAND(ID_SHOWROOMS, OnShowrooms)
	ON_UPDATE_COMMAND_UI(ID_SHOWROOMS, OnUpdateShowrooms)
	ON_COMMAND(ID_SHOWNORMALS, OnShownormals)
	ON_UPDATE_COMMAND_UI(ID_SHOWNORMALS, OnUpdateShownormals)
	ON_COMMAND(ID_OPTIONS_SETNORMALSCALEVALUE, OnOptionsSetnormalscalevalue)
	ON_COMMAND(ID_VIEW_ELEVATIONS_TOPVIEW, OnViewElevationsTopview)
	ON_COMMAND(ID_DRAW_FIFTEENBOXES, OnDrawFifteenboxes)
	ON_UPDATE_COMMAND_UI(ID_DRAW_FIFTEENBOXES, OnUpdateDrawFifteenboxes)
	ON_COMMAND(ID_SHOWFILLED, OnShowfilled)
	ON_UPDATE_COMMAND_UI(ID_SHOWFILLED, OnUpdateShowfilled)
	ON_COMMAND(ID_ROTATETOOL, OnRotatetool)
	ON_UPDATE_COMMAND_UI(ID_ROTATETOOL, OnUpdateRotatetool)
	ON_COMMAND(ID_POINTTOOL, OnPointtool)
	ON_UPDATE_COMMAND_UI(ID_POINTTOOL, OnUpdatePointtool)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, COpenGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, COpenGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, COpenGLView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorView construction/destruction
#define PROFILE(x,y,b) x = AfxGetApp()->GetProfileInt(CString(#y), CString(#x),b);
#define WR_PROFILE(x,y) AfxGetApp()->WriteProfileInt(CString(#y), #x,x);

CMy3DOEditorView::CMy3DOEditorView()
{
	selection = FALSE;
	renderMode = GL_RENDER;
	dragging = FALSE;

	PROFILE(doubleBuffered,3doPreferences,TRUE);

	viewDirection = t_XYZ;
	currentTool = NULL;

	OnRotatetool();
}

CMy3DOEditorView::~CMy3DOEditorView()
{
	WR_PROFILE(doubleBuffered,3doPreferences);
}

BOOL CMy3DOEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
	return COpenGLView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorView drawing

void CMy3DOEditorView::OnDraw(CDC* pDC)
{
	CMy3DOEditorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorView printing

BOOL CMy3DOEditorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMy3DOEditorView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CMy3DOEditorView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorView diagnostics

#ifdef _DEBUG
void CMy3DOEditorView::AssertValid() const
{
	COpenGLView::AssertValid();
}

void CMy3DOEditorView::Dump(CDumpContext& dc) const
{
	COpenGLView::Dump(dc);
}

CMy3DOEditorDoc* CMy3DOEditorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMy3DOEditorDoc)));
	return (CMy3DOEditorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMy3DOEditorView message handlers
#define BUFSIZE 512

void CMy3DOEditorView::processHits (GLint hits, GLuint buffer[]) 
{     
	int i;     
	GLuint names;      
	//printf ("hits = %d\n", hits);     
	//ptr = (GLuint *) buffer;  
	
	if (hits > 1)
	{
	 for (i = 1; i < hits; i++) 
	 {    /*  for each hit  */         
		names = buffer[(i-1)*4+3];   
		Node *ptr = (Node*)names;
		cerr << " number of names for hit = " << ptr->toString() << endl;
		if (i == 1)
		{
			CMy3DOEditorDoc* pDoc = GetDocument();
			pDoc->object->selection = ptr;
		}
	 }
	}
	else
	{
		 CMy3DOEditorDoc* pDoc = GetDocument();
		 pDoc->object->selection = NULL;
	}
}


void CMy3DOEditorView::OpenGLDrawScene(HDC hdc)
{
	    CMy3DOEditorDoc *pDoc = GetDocument();
	    

		renderMode = GL_RENDER;
		if (pDoc)
		{
			if (pDoc->object)
			{
				pDoc->object->DrawGL(hdc,this,-1);
			}
		}

		float v = 10.0f;

		if (GetDocument()->showAxis)
		{
		// draw carthesian axes
	    glBegin(GL_LINES);
		// red x axis
		setGLColor(1.0f,0.f,0.f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(v,0.0f,0.0f);
		glEnd();

		glPushMatrix();
		glTranslated(v+0.5,0.0f,0.0f);
		glBegin(GL_LINES);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glEnd();
		glPopMatrix();
		
		// green y axis
		setGLColor(0.f,1.f,0.f);
		glBegin(GL_LINES);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,v,0.0f);
		glEnd();

		glPushMatrix();
		glTranslated(0.0,v + 0.5f,0.0f);
		glBegin(GL_LINES);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.5f,0.5f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(0.5f,0.5f,0.0f);
		glVertex3f(0.5f,0.5f,0.0f);
		glVertex3f(0.5f,1.0f,0.0f);
		glEnd();
		glPopMatrix();

		// blue z axis
		setGLColor(0.f,0.f,1.f);
		glBegin(GL_LINES);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,v);
		glEnd();

		glPushMatrix();
		glTranslated(0.0,0.0, v + 0.5f);
		glBegin(GL_LINES);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glEnd();
		glPopMatrix();

		}

		
		if (selection)
		{
		setGLColor(1.f,0.f,1.f);
		glBegin(GL_LINES);
		glVertex3d(sx,sy,sz);
		glVertex3d(sxf,syf,szf);
		glEnd();
		setGLColor(0.f,0.0f,0.0f);
		}
		

		SwapAnyBuffers(hdc);

		if (pDoc && pDoc->object)
		{
			pDoc->object->DrawGLText(hdc,this);
		}

		if (pDoc && pDoc->object && pDoc->object->datFileParent)
		{
	       CCam *cam = pDoc->object->datFileParent->GetMainCameraFile();
	       if (cam)
		   {
		      cam->DrawGLText(hdc,this);
		   }
		}

}

void CMy3DOEditorView::OnShowAxis() 
{
	GetDocument()->showAxis = !GetDocument()->showAxis;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnShowPoints() 
{
	GetDocument()->showPoints = !GetDocument()->showPoints;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnShowTextures() 
{
	GetDocument()->showTextures = !GetDocument()->showTextures;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowAxis(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showAxis);
}

void CMy3DOEditorView::OnUpdateShowPoints(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showPoints);
}

void CMy3DOEditorView::OnUpdateShowTextures(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showTextures);
}

void CMy3DOEditorView::OnZoomin() 
{
	angleView*=0.9;
	/*
	if (m_ShiftDown)
	{
		GetDocument()->dist = GetDocument()->dist*0.8;
		GetDocument()->dist = GetDocument()->dist*0.8;
		GetDocument()->dist = GetDocument()->dist*0.8;
		GetDocument()->dist = GetDocument()->dist*0.8;
		GetDocument()->dist = GetDocument()->dist*0.8;
		GetDocument()->dist = GetDocument()->dist*0.8;
	}
	else
	{
		GetDocument()->dist = GetDocument()->dist*0.92;
	}
	*/

    GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnZoomout() 
{
	angleView*=1.1;
	/*
	if (m_ShiftDown)
	{
		GetDocument()->dist = GetDocument()->dist*1.2;
		GetDocument()->dist = GetDocument()->dist*1.2;
		GetDocument()->dist = GetDocument()->dist*1.2;
		GetDocument()->dist = GetDocument()->dist*1.2;
		GetDocument()->dist = GetDocument()->dist*1.2;
		GetDocument()->dist = GetDocument()->dist*1.2;
	}
	else
	{
	   GetDocument()->dist = GetDocument()->dist*1.05;
	}
	*/
    GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnOptionsFilledpolygons() 
{
	GetDocument()->viewType     = t_Polygon;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnOptionsTexturepolygons() 
{
	GetDocument()->viewType     = t_Texture;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnOptionsUserandompolygoncolors() 
{
	GetDocument()->showRandomColors = !GetDocument()->showRandomColors;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnOptionsWireframe() 
{
	GetDocument()->viewType     = t_WireFrame;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsWireframe(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->viewType == t_WireFrame);
}

void CMy3DOEditorView::OnUpdateOptionsUserandompolygoncolors(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showRandomColors);
	
}

void CMy3DOEditorView::OnUpdateOptionsTexturepolygons(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->viewType == t_Texture);
}

void CMy3DOEditorView::OnUpdateOptionsFilledpolygons(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->viewType == t_Polygon);
}

void CMy3DOEditorView::OnOptionsBlackbackground() 
{
	GetDocument()->backgroundColor = RGB(0,0,0);
	float r = ((float)GetRValue(GetDocument()->backgroundColor))/255.0f;
	float g = ((float)GetGValue(GetDocument()->backgroundColor))/255.0f;
	float b = ((float)GetBValue(GetDocument()->backgroundColor))/255.0f;

	glClearColor(r,g,b,1.0f);
	/*
	whiteBackground = FALSE;
	if (whiteBackground)
	{
		glClearColor(1.0f,1.0f,1.0f,1.0f);
	}
	else
	{
		glClearColor(0.0f,0.0f,0.0f,1.0f);
	}
	*/
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsBlackbackground(CCmdUI* pCmdUI) 
{
	//pCmdUI->SetCheck(!whiteBackground);
}

void CMy3DOEditorView::OnOptionsWhitebackground() 
{
	GetDocument()->backgroundColor = RGB(255,255,255);
	float r = ((float)GetRValue(GetDocument()->backgroundColor))/255.0f;
	float g = ((float)GetGValue(GetDocument()->backgroundColor))/255.0f;
	float b = ((float)GetBValue(GetDocument()->backgroundColor))/255.0f;

	glClearColor(r,g,b,1.0f);
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsWhitebackground(CCmdUI* pCmdUI) 
{
	//pCmdUI->SetCheck(whiteBackground);
}

int CMy3DOEditorView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COpenGLView::OnCreate(lpCreateStruct) == -1)
		return -1;

	float r = ((float)GetRValue(GetDocument()->backgroundColor))/255.0f;
	float g = ((float)GetGValue(GetDocument()->backgroundColor))/255.0f;
	float b = ((float)GetBValue(GetDocument()->backgroundColor))/255.0f;

	glClearColor(r,g,b,1.0f);
	return 0;
}

void DrawText2D(HDC hdc,CScrollView *scview,GLdouble wx,GLdouble wy,GLdouble wz,int idx)
{
        GLdouble sx;
		GLdouble sy;
		GLdouble sz;
		GLdouble model[16];
		GLdouble projection[16];
		GLint view[4];

		glPushMatrix();
		glMatrixMode(GL_MODELVIEW);
		glGetDoublev(GL_MODELVIEW_MATRIX,model);
		glGetDoublev(GL_PROJECTION_MATRIX,projection);
		glGetIntegerv(GL_VIEWPORT,view);
		gluProject(wx,wy,wz,model,projection,view,&sx,&sy,&sz);

		char buffer[10];
		wsprintf(buffer,"%d",idx);
		SelectObject(hdc,GetStockObject(ANSI_VAR_FONT));
		//if (!((CObjectEditorView*)(scview))->showFilled)
		//{
		SetBkMode(hdc,TRANSPARENT);
		//}

		RECT rect;
		scview->GetClientRect(&rect);

		int midy = (rect.top+rect.bottom)/2;
		int midx = (rect.left+rect.right)/2;

		int winx = (int)(sx-midx);
		int winy = (int)(sy-midy);
		
		::TextOut(hdc,(int)(midx+winx),(int)(midy-winy),buffer,strlen(buffer));
		glPopMatrix();
}

void CMy3DOEditorView::OnShowpointnumbers() 
{
	GetDocument()->showPointNumbers = !GetDocument()->showPointNumbers;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowpointnumbers(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showPointNumbers);
}

void CMy3DOEditorView::OnShowobjects() 
{
	GetDocument()->showObjects = !GetDocument()->showObjects;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowobjects(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showObjects);
}

void CMy3DOEditorView::OnInitialUpdate() 
{
	COpenGLView::OnInitialUpdate();
	int sortRepositoryType;

	PROFILE(sortRepositoryType,3doPreferences,0);
	
	CMy3DOEditorDoc *pDoc = GetDocument(); 

		if (pDoc)
		{
			if (pDoc->object)
			{
				pDoc->object->GetDist(this);
				pDoc->object->sortRepositoryType = sortRepositoryType;
				
			}
		}
}

void CMy3DOEditorView::OnEditUpdatetrack() 
{
	CMy3DOEditorDoc *pDoc = GetDocument(); 
	if (pDoc)
	{
		if (pDoc->object)
		{
				pDoc->object->ReMaxMin();
		}
	}
}

void CMy3DOEditorView::OnEditSelectviewpoint() 
{
	CMy3DOEditorDoc *pDoc = GetDocument(); 
	if (pDoc)
	{
		if (pDoc->object)
		{
				CPtsEdit *dlg = new CPtsEdit(NULL,NULL);
				dlg->m_X = (float)pDoc->object->midx;
				dlg->m_Y = (float)pDoc->object->midy;
				dlg->m_Z = (float)pDoc->object->midz;

				int result = dlg->DoModal();

				if (result==IDOK)
				{
				   pDoc->object->midx = dlg->m_X;	
				   pDoc->object->midy = dlg->m_Y;	
				   pDoc->object->midz = dlg->m_Z;	
				}
		}
	}
	

	
}

void CMy3DOEditorView::OnMButtonDown(UINT nFlags, CPoint point) 
{
	
	dragFromPoint = point;
	dragging = TRUE;
	COpenGLView::OnMButtonDown(nFlags, point);
}

void CMy3DOEditorView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (currentTool)
	{
		currentTool->OnLButtonUp(this,nFlags,point);
	}
	if (viewDirection != t_XYZ)
	{
		//OnMButtonUp(nFlags,point);
		//return;
	}
	COpenGLView::OnLButtonUp(nFlags, point);
}

void CMy3DOEditorView::OnLButtonDown(UINT nFlags, CPoint point) 
{

	if (currentTool)
	{
		currentTool->OnLButtonDown(this,nFlags,point);
	}
	COpenGLView::OnLButtonDown(nFlags, point);
	/*
	if (viewDirection != t_XYZ)
	{
		//OnMButtonDown(nFlags,point);
	}
	if (nFlags & MK_SHIFT)
	{
	CMy3DOEditorDoc *pDoc = GetDocument();
	GLdouble model[16];
	GLdouble projection[16];
	GLint view[4];
	CRect rect;
	GetClientRect(&rect);
	CDC *pDC = GetDC();
	HDC hdc = pDC->m_hDC;

	glPushMatrix();

	
	glMatrixMode(GL_PROJECTION);
	OnSize(0,rect.Width(),rect.Height());
	int selectedIdx = -1;
	double selectedDist = 10E8;

	int midy = (rect.top+rect.bottom)/2;
	int midx = (rect.left+rect.right)/2;

	if (pDoc)
	{
	  if (pDoc->object)
	  {
		float scale = 3.0f;
	    getLookPoint();
		glScalef(scale,scale,scale);
	    glTranslated(-pDoc->object->midx,-pDoc->object->midy,-pDoc->object->midz);
		
		
	    glMatrixMode(GL_MODELVIEW);	
	    glGetDoublev(GL_MODELVIEW_MATRIX,model);
	    glGetDoublev(GL_PROJECTION_MATRIX,projection);
	    glGetIntegerv(GL_VIEWPORT,view);
		gluPickMatrix(point.x, point.y, 1, 1, view);

	    for(int i=0;i<pDoc->object->numPts;i++)
		{
	     GLdouble sx,sy,sz;
	     Point3D *pts = pDoc->object->ptsArray[i];
	     GLdouble wx = pts->getX();
	     GLdouble wy = pts->getY();
	     GLdouble wz = pts->getZ();
	     gluProject(wx,wy,wz,model,projection,view,&sx,&sy,&sz);
		 //int winx = (int)(sx-midx);
		 int winy = (int)(sy-midy);
		 int ssx = (int)(sx);
		 int ssy = (midy-winy);
		 double dx = ssx-point.x;
	     double dy = ssy-point.y;
	     double dist = sqrt((dx*dx)+(dy*dy));
	     if (dist < selectedDist)
		 {
		  selectedDist = dist;
		  selectedIdx = i;
		 }
		}
	  }
	}

	if (selectedIdx!=-1)
	{
		CString msg;
		msg.Format("Closest Point %d",selectedIdx);
		pDoc->object->selectedPt = pDoc->object->ptsArray[selectedIdx];
	}
	else
	{
		pDoc->object->selectedPt = NULL;
		
	}	
	glPopMatrix();
	GetDocument()->UpdateAllViews(NULL);
	}
	*/
	
}

void CMy3DOEditorView::OnOptionsGreybackground() 
{
	GetDocument()->backgroundColor = RGB(128,128,128);
	float r = ((float)GetRValue(GetDocument()->backgroundColor))/255.0f;
	float g = ((float)GetGValue(GetDocument()->backgroundColor))/255.0f;
	float b = ((float)GetBValue(GetDocument()->backgroundColor))/255.0f;
	glClearColor(r,g,b,1.0f);
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	COpenGLView::OnRButtonDown(nFlags, point);
}



void CMy3DOEditorView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CMy3DOEditorDoc *pDoc = GetDocument();

	if (pDoc)
	{
		if (pDoc->object)
		{
			if (pDoc->object->selectedPt)
			{
			   pDoc->object->selectedPt->Explore(pDoc);
			   pDoc->UpdateAllViews(NULL);
			}
		}	
	}	

	COpenGLView::OnLButtonDblClk(nFlags, point);
}

void CMy3DOEditorView::OnOptionsOutlinedpolygons() 
{
	GetDocument()->viewType = t_PolygonOutlines;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsOutlinedpolygons(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->viewType == t_PolygonOutlines);
}

void CMy3DOEditorView::OnOptionsDrawdistancesDrawlastonly() 
{
	GetDocument()->drawDistance = 200;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistancesDrawlastonly(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 200);
}

void CMy3DOEditorView::OnOptionsDrawdistancesDrawall() 
{
	GetDocument()->drawDistance = 0;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistancesDrawall(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 0);
}

void CMy3DOEditorView::OnViewsrb() 
{
	GetDocument()->showSrbs = !GetDocument()->showSrbs;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewsrb(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showSrbs == TRUE);
}

void CMy3DOEditorView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (currentTool)
	{
		currentTool->OnMouseMove(this,nFlags,point);
	}

	
	COpenGLView::OnMouseMove(nFlags, point);
}



void CMy3DOEditorView::OnMButtonUp(UINT nFlags, CPoint point) 
{
	if (currentTool)
	{
		//currentTool->OnMButtonUp(this,nFlags,point);
	}
	dragging = FALSE;
	COpenGLView::OnMButtonUp(nFlags, point);
}

BOOL CMy3DOEditorView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	//return COpenGLView::OnEraseBkgnd(pDC);
	return TRUE;
}

void CMy3DOEditorView::OnOptionsDrawdistances100meters() 
{
	GetDocument()->drawDistance = 100;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances100meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 100);
}

void CMy3DOEditorView::OnOptionsDrawdistances150meters() 
{
	GetDocument()->drawDistance = 150;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances150meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 150);
}

void CMy3DOEditorView::OnOptionsDrawdistances50meters() 
{
	GetDocument()->drawDistance = 50;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances50meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 50);
}

void CMy3DOEditorView::OnOptionsDrawdistances30meters() 
{
	GetDocument()->drawDistance = 30;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances30meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 30);
}

void CMy3DOEditorView::OnOptionsDrawdistances20meters() 
{
	GetDocument()->drawDistance = 20;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances20meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 20);
}

void CMy3DOEditorView::OnOptionsDrawdistances10meters() 
{
	GetDocument()->drawDistance = 10;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances10meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 10);
}

void CMy3DOEditorView::OnOptionsDrawdistances5meters() 
{
	GetDocument()->drawDistance = 5;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistances5meters(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == 5);
}

void CMy3DOEditorView::OnOptionsDrawdistancesLastinviewdistancearrays() 
{
	GetDocument()->drawDistance = -1;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistancesLastinviewdistancearrays(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == -1);
}

void CMy3DOEditorView::OnOptionsDrawdistancesEverythingvslow() 
{
	GetDocument()->drawDistance = -2;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsDrawdistancesEverythingvslow(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->drawDistance == -2);
}

void CMy3DOEditorView::OnOptionsDoublebuffering() 
{
	doubleBuffered = !doubleBuffered;
	WR_PROFILE(doubleBuffered,3doPreferences);
	AfxMessageBox("you must reopen a new display for this setting will to effect");
}

void CMy3DOEditorView::OnUpdateOptionsDoublebuffering(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(doubleBuffered == TRUE);
}

void CMy3DOEditorView::OnOptionsSortnoderepositoryByoffset() 
{
	CMy3DOEditorDoc *pDoc = GetDocument();

	if (pDoc)
	{
		if (pDoc->object)
		{
			pDoc->object->sortRepositoryType = 0;
			int sortRepositoryType = pDoc->object->sortRepositoryType;
			WR_PROFILE(sortRepositoryType,3doPreferences);
		}
	}
}

void CMy3DOEditorView::OnUpdateOptionsSortnoderepositoryByoffset(CCmdUI* pCmdUI) 
{
	CMy3DOEditorDoc *pDoc = GetDocument();

	if (pDoc)
	{
		if (pDoc->object)
		{
			pCmdUI->SetCheck(pDoc->object->sortRepositoryType == 0);
		}
	}
}

void CMy3DOEditorView::OnOptionsSortnoderepositoryBytype() 
{
	CMy3DOEditorDoc *pDoc = GetDocument();

	if (pDoc)
	{
		if (pDoc->object)
		{
			pDoc->object->sortRepositoryType = 1;
			int sortRepositoryType = pDoc->object->sortRepositoryType;
			WR_PROFILE(sortRepositoryType,3doPreferences);
		}
	}
	
	
}

void CMy3DOEditorView::OnUpdateOptionsSortnoderepositoryBytype(CCmdUI* pCmdUI) 
{
	CMy3DOEditorDoc *pDoc = GetDocument();

	if (pDoc)
	{
		if (pDoc->object)
		{
			pCmdUI->SetCheck(pDoc->object->sortRepositoryType == 1);
			int sortRepositoryType = pDoc->object->sortRepositoryType;
			
		}
	}
}

void CMy3DOEditorView::OnOptionsShowsubobjectlocations() 
{
	GetDocument()->showSubObjectLocations = !GetDocument()->showSubObjectLocations;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsShowsubobjectlocations(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showSubObjectLocations);
}

void CMy3DOEditorView::OnViewDisplayclassesAsphalt() 
{
	GetDocument()->showRoads = !GetDocument()->showRoads;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesAsphalt(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showRoads);
}

void CMy3DOEditorView::OnViewDisplayclassesFence() 
{
	GetDocument()->showFence = !GetDocument()->showFence;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesFence(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showFence);
}

void CMy3DOEditorView::OnViewDisplayclassesBillboard() 
{
	GetDocument()->showBillboard = !GetDocument()->showBillboard;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesBillboard(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showBillboard);
}

void CMy3DOEditorView::OnViewDisplayclassesBrakemarker() 
{
	GetDocument()->showBrakeMarks = !GetDocument()->showBrakeMarks;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesBrakemarker(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showBrakeMarks);
}

void CMy3DOEditorView::OnViewDisplayclassesCar() 
{
	GetDocument()->showCar = !GetDocument()->showCar;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesCar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showCar);
}

void CMy3DOEditorView::OnViewDisplayclassesClouds() 
{
	GetDocument()->showClouds = !GetDocument()->showClouds;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesClouds(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showClouds);
}

void CMy3DOEditorView::OnViewDisplayclassesCrowddd() 
{
	GetDocument()->showCrowds = !GetDocument()->showCrowds;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesCrowddd(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showCrowds);
}

void CMy3DOEditorView::OnViewDisplayclassesGrandstand() 
{
	GetDocument()->showGrandstand = !GetDocument()->showGrandstand;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesGrandstand(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showGrandstand);
}

void CMy3DOEditorView::OnViewDisplayclassesGrass() 
{
	GetDocument()->showGrass = !GetDocument()->showGrass;
	GetDocument()->UpdateAllViews(NULL);
	
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesGrass(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showGrass);
}

void CMy3DOEditorView::OnViewDisplayclassesHorizon() 
{
	GetDocument()->showHorizon = !GetDocument()->showHorizon;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesHorizon(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showHorizon);
}

void CMy3DOEditorView::OnViewDisplayclassesInfield() 
{
	GetDocument()->showInfield = !GetDocument()->showInfield;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesInfield(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showInfield);
}

void CMy3DOEditorView::OnViewDisplayclassesObject() 
{
	GetDocument()->showSubObjects = !GetDocument()->showSubObjects;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesObject(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showSubObjects);
}

void CMy3DOEditorView::OnViewDisplayclassesPeople() 
{
	GetDocument()->showPeople = !GetDocument()->showPeople;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesPeople(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showPeople);
}

void CMy3DOEditorView::OnViewDisplayclassesTree() 
{
	GetDocument()->showTrees = !GetDocument()->showTrees;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesTree(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showTrees);
}

void CMy3DOEditorView::OnViewDisplayclassesVechicle() 
{
	GetDocument()->showVehicles = !GetDocument()->showVehicles;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesVechicle(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showVehicles);
}

void CMy3DOEditorView::OnViewDisplayclassesWall() 
{
	GetDocument()->showWalls = !GetDocument()->showWalls;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateViewDisplayclassesWall(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showWalls);
}

void CMy3DOEditorView::OnShowcameras() 
{
	GetDocument()->showCameras = !GetDocument()->showCameras;
    GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowcameras(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showCameras);
}

void CMy3DOEditorView::OnOptionsShowcameranumbers() 
{
	GetDocument()->showCameraNumbers=!GetDocument()->showCameraNumbers;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateOptionsShowcameranumbers(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showCameraNumbers);
}

void CMy3DOEditorView::OnRightpopSettopdrawlocation() 
{
	//AfxMessageBox("Set Top");
	((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->OnTopDrawingTree();
}

void CMy3DOEditorView::OnRightpopAddtopdrawlocation() 
{
	//AfxMessageBox("Set Top");
	((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->OnAddTopDrawingTree();
}

void CMy3DOEditorView::OnEditDevelopmentReplaceys() 
{
	CMy3DOEditorDoc *pDoc = GetDocument();
	    
    CEditTwoFVar *dlg = new CEditTwoFVar();

	dlg->m_VarVal1 = 0.0;
	dlg->m_VarVal2 = 0.0;
	dlg->m_Var1.Format("Old Y Value");
	dlg->m_Var2.Format("New Y Value");

	int result = dlg->DoModal();
	
	if (result == IDOK)
	{
	 if (pDoc)
	 {
		
		if (pDoc->object)
		{
			    float oldv = dlg->m_VarVal1;
				float newv = dlg->m_VarVal2;
				for(int i=0;i<pDoc->object->numPts;i++)
				{
					float diff = (float)fabs(pDoc->object->ptsArray[i]->pt.y - oldv);
					if (diff <= 0.01)
					{
					   pDoc->object->ptsArray[i]->pt.y = newv;
					}
				}
		}
	}
	}
}

void CMy3DOEditorView::OnEditDevelopmentReplacexs() 
{
	CMy3DOEditorDoc *pDoc = GetDocument();
	    
    CEditTwoFVar *dlg = new CEditTwoFVar();

	dlg->m_VarVal1 = 0.0;
	dlg->m_VarVal2 = 0.0;
	dlg->m_Var1.Format("Old X Value");
	dlg->m_Var2.Format("New X Value");

	int result = dlg->DoModal();
	
	if (result == IDOK)
	{
	 if (pDoc)
	 {
		
		if (pDoc->object)
		{
			    float oldv = dlg->m_VarVal1;
				float newv = dlg->m_VarVal2;
				for(int i=0;i<pDoc->object->numPts;i++)
				{
					float diff = (float)fabs(pDoc->object->ptsArray[i]->pt.x - oldv);
					if (diff <= 0.01)
					{
					   pDoc->object->ptsArray[i]->pt.x = newv;
					}
				}
		}
	}
	}
}

void CMy3DOEditorView::OnEditDevelopmentReplacezs() 
{
	CMy3DOEditorDoc *pDoc = GetDocument();
	    
    CEditTwoFVar *dlg = new CEditTwoFVar();

	dlg->m_VarVal1 = 0.0;
	dlg->m_VarVal2 = 0.0;
	dlg->m_Var1.Format("Old Z Value");
	dlg->m_Var2.Format("New Z Value");

	int result = dlg->DoModal();
	
	if (result == IDOK)
	{
	 if (pDoc)
	 {
		
		if (pDoc->object)
		{
			    float oldv = dlg->m_VarVal1;
				float newv = dlg->m_VarVal2;
				for(int i=0;i<pDoc->object->numPts;i++)
				{
					float diff = (float)fabs(pDoc->object->ptsArray[i]->pt.z - oldv);
					if (diff <= 0.01)
					{
					   pDoc->object->ptsArray[i]->pt.z = newv;
					}
				}
		}
	}
	}
}

void CMy3DOEditorView::OnShowtrack() 
{
	GetDocument()->showTrk = !GetDocument()->showTrk;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowtrack(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showTrk);
}

void CMy3DOEditorView::OnUpdateDrawplanes(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showPlanes);
}

void CMy3DOEditorView::OnShowthreedo() 
{
	GetDocument()->show3do = !GetDocument()->show3do;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowthreedo(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->show3do);
}

void CMy3DOEditorView::OnDrawplanes() 
{
	GetDocument()->showPlanes = !GetDocument()->showPlanes;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnOptionsSetnormalsquaresize() 
{
	CEditOneFVar *dlg = new CEditOneFVar();

	dlg->m_VarVal1 = GetDocument()->normalSize;
	dlg->m_Var1.Format("Plane Square Size");
	dlg->m_Desc.Format("Change this value to make the square that represents the Plane smaller");
	int result = dlg->DoModal();

	if (result == IDOK)
	{
		GetDocument()->normalSize = dlg->m_VarVal1;
	}

	delete dlg;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnShowrooms() 
{
	GetDocument()->showRooms = !GetDocument()->showRooms;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowrooms(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showRooms);
}

void CMy3DOEditorView::OnShownormals() 
{GetDocument()->showVertexNormals = !GetDocument()->showVertexNormals;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShownormals(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showVertexNormals);
}

void CMy3DOEditorView::OnOptionsSetnormalscalevalue() 
{
	CEditOneFVar *dlg = new CEditOneFVar();

	dlg->m_VarVal1 = GetDocument()->normalScale;
	dlg->m_Var1.Format("Normal Scale Value");
	dlg->m_Desc.Format("Change this value to make normals shorter/longer");
	int result = dlg->DoModal();

	if (result == IDOK)
	{
		GetDocument()->normalScale = dlg->m_VarVal1;
	}

	delete dlg;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnViewElevationsTopview() 
{
	CView *activeViewXY = ((CMy3DOEditorApp*)AfxGetApp())->OnC3doView(GetDocument());
	CView *activeViewYZ = ((CMy3DOEditorApp*)AfxGetApp())->OnC3doView(GetDocument());
	CView *activeViewXZ = ((CMy3DOEditorApp*)AfxGetApp())->OnC3doView(GetDocument());
	((CMy3DOEditorView *)activeViewXY)->viewDirection = t_XY;
	((CMy3DOEditorView *)activeViewYZ)->viewDirection = t_YZ;
	((CMy3DOEditorView *)activeViewXZ)->viewDirection = t_XZ;
	((CMDIFrameWnd*)((CMy3DOEditorApp*)AfxGetApp())->pMainFrame)->MDITile(MDITILE_HORIZONTAL);
}

void CMy3DOEditorView::getLookPoint()
{
   glTranslated(0.0,0.0,-GetDocument()->dist);

   switch(viewDirection)
   {
   case t_XY:
    //glRotated(0, 1.0, 0.0, 0.0);
    //glRotated(0, 0.0, 1.0, 0.0);
	glRotated(-90, 1.0, 0.0, 0.0);
   break;
   case t_YZ:
    //glRotated(0, 0.0, 1.0, 0.0);
	//glRotated(-90, 0.0, 0.0, 1.0);
	//glRotated(90, 1.0, 0.0, 0.0);
   break;
   case t_XZ:
    glRotated(-90, 1.0, 0.0, 0.0);
    //glRotated(0, 0.0, 1.0, 0.0);
	glRotated(90, 0.0, 0.0, 1.0);
   break;
   case t_XYZ:
    glRotated(m_xRotate, 1.0, 0.0, 0.0);
    glRotated(m_yRotate, 0.0, 1.0, 0.0);
    glRotated(m_zRotate, 0.0, 0.0, 1.0);
   break;
   }
}


void CMy3DOEditorView::OnDrawFifteenboxes() 
{GetDocument()->showFiftenBoxes = !GetDocument()->showFiftenBoxes;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateDrawFifteenboxes(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showFiftenBoxes);
}

void CMy3DOEditorView::OnShowfilled() 
{
	GetDocument()->showFilled = !GetDocument()->showFilled;
	GetDocument()->UpdateAllViews(NULL);
}

void CMy3DOEditorView::OnUpdateShowfilled(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(GetDocument()->showFilled);
}

void CMy3DOEditorView::OnRotatetool() 
{
	if (currentTool)
		delete currentTool;

	currentTool = new RotateTool();
}

void CMy3DOEditorView::OnUpdateRotatetool(CCmdUI* pCmdUI) 
{
	if (currentTool) pCmdUI->SetCheck(currentTool->type == t_RotateTool);
}

void CMy3DOEditorView::OnPointtool() 
{
	if (currentTool)
		delete currentTool;

	currentTool = new PointTool();
}

void CMy3DOEditorView::OnUpdatePointtool(CCmdUI* pCmdUI) 
{
	if (currentTool) pCmdUI->SetCheck(currentTool->type == t_PointTool);
}
