// 3DOEditorView.h : interface of the CMy3DOEditorView class
//
////////////////////////////////////////////////////////////////////////////
#include "OpenGLView.h"
#include "3DOEditorDoc.h"

#include <gl\glaux.h>
#include <gl\gl.h>
#include <gl\glu.h>

#include "Tool.h"



typedef enum
{
	t_XY,t_YZ,t_XZ,t_XYZ
} t_ViewType;

extern void DrawText2D(HDC hdc,CScrollView *scview,double wx,double wy,double wz,int idx);

class CMy3DOEditorView : public COpenGLView
{
protected: // create from serialization only
	CMy3DOEditorView();
	DECLARE_DYNCREATE(CMy3DOEditorView)

	CPoint dragFromPoint;
	BOOL dragging;
/*
	int showPoints;
	int showTextures;
	int showAxis;
	BOOL showPointNumbers;
	BOOL showObjects;
	BOOL showSrbs;
	BOOL dragging;
	BOOL showSubObjectLocations;
	int drawDistance;	
	BOOL show3do;
	BOOL showTrk;
	BOOL showPlanes;
	BOOL showRoads;
	BOOL showWalls;
	BOOL showGrass;
	BOOL showSubObjects;
	BOOL showCar;
	BOOL showHorizon;
	BOOL showCrowds;
	BOOL showClouds;
	BOOL showTrees;
	BOOL showBillboard;
	BOOL showBrakeMarks;
	BOOL showVehicles;
	BOOL showInfield;
	BOOL showGrandstand;
	BOOL showPeople;
	BOOL showFence;
	BOOL showCameras;
	BOOL showCameraNumbers;
	BOOL showRooms;
	BOOL showVertexNormals;
	BOOL showRandomColors;
	COLORREF backgroundColor;

	float  normalSize;
	float  normalScale;
*/

	t_ViewType viewDirection;


	Tool *currentTool;
	
	

    double sx,sy,sz;
	double sxf,syf,szf;

	BOOL selection;
	int  renderMode;

	void processHits (GLint hits, GLuint buffer[]) ;

// Attributes
public:
	CMy3DOEditorDoc* GetDocument();

	void OpenGLDrawScene(HDC hdc);

	void getLookPoint();

	

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMy3DOEditorView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMy3DOEditorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMy3DOEditorView)
	afx_msg void OnShowAxis();
	afx_msg void OnShowPoints();
	afx_msg void OnShowTextures();
	afx_msg void OnUpdateShowAxis(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowPoints(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowTextures(CCmdUI* pCmdUI);
	afx_msg void OnZoomin();
	afx_msg void OnZoomout();
	afx_msg void OnOptionsFilledpolygons();
	afx_msg void OnOptionsTexturepolygons();
	afx_msg void OnOptionsUserandompolygoncolors();
	afx_msg void OnOptionsWireframe();
	afx_msg void OnUpdateOptionsWireframe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsUserandompolygoncolors(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsTexturepolygons(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsFilledpolygons(CCmdUI* pCmdUI);
	afx_msg void OnOptionsBlackbackground();
	afx_msg void OnUpdateOptionsBlackbackground(CCmdUI* pCmdUI);
	afx_msg void OnOptionsWhitebackground();
	afx_msg void OnUpdateOptionsWhitebackground(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnShowpointnumbers();
	afx_msg void OnUpdateShowpointnumbers(CCmdUI* pCmdUI);
	afx_msg void OnShowobjects();
	afx_msg void OnUpdateShowobjects(CCmdUI* pCmdUI);
	afx_msg void OnEditUpdatetrack();
	afx_msg void OnEditSelectviewpoint();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnOptionsGreybackground();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnOptionsOutlinedpolygons();
	afx_msg void OnUpdateOptionsOutlinedpolygons(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistancesDrawlastonly();
	afx_msg void OnUpdateOptionsDrawdistancesDrawlastonly(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistancesDrawall();
	afx_msg void OnUpdateOptionsDrawdistancesDrawall(CCmdUI* pCmdUI);
	afx_msg void OnViewsrb();
	afx_msg void OnUpdateViewsrb(CCmdUI* pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnOptionsDrawdistances100meters();
	afx_msg void OnUpdateOptionsDrawdistances100meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistances150meters();
	afx_msg void OnUpdateOptionsDrawdistances150meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistances50meters();
	afx_msg void OnUpdateOptionsDrawdistances50meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistances30meters();
	afx_msg void OnUpdateOptionsDrawdistances30meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistances20meters();
	afx_msg void OnUpdateOptionsDrawdistances20meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistances10meters();
	afx_msg void OnUpdateOptionsDrawdistances10meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistances5meters();
	afx_msg void OnUpdateOptionsDrawdistances5meters(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistancesLastinviewdistancearrays();
	afx_msg void OnUpdateOptionsDrawdistancesLastinviewdistancearrays(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdistancesEverythingvslow();
	afx_msg void OnUpdateOptionsDrawdistancesEverythingvslow(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDoublebuffering();
	afx_msg void OnUpdateOptionsDoublebuffering(CCmdUI* pCmdUI);
	afx_msg void OnOptionsSortnoderepositoryByoffset();
	afx_msg void OnUpdateOptionsSortnoderepositoryByoffset(CCmdUI* pCmdUI);
	afx_msg void OnOptionsSortnoderepositoryBytype();
	afx_msg void OnUpdateOptionsSortnoderepositoryBytype(CCmdUI* pCmdUI);
	afx_msg void OnOptionsShowsubobjectlocations();
	afx_msg void OnUpdateOptionsShowsubobjectlocations(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesAsphalt();
	afx_msg void OnUpdateViewDisplayclassesAsphalt(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesFence();
	afx_msg void OnUpdateViewDisplayclassesFence(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesBillboard();
	afx_msg void OnUpdateViewDisplayclassesBillboard(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesBrakemarker();
	afx_msg void OnUpdateViewDisplayclassesBrakemarker(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesCar();
	afx_msg void OnUpdateViewDisplayclassesCar(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesClouds();
	afx_msg void OnUpdateViewDisplayclassesClouds(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesCrowddd();
	afx_msg void OnUpdateViewDisplayclassesCrowddd(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesGrandstand();
	afx_msg void OnUpdateViewDisplayclassesGrandstand(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesGrass();
	afx_msg void OnUpdateViewDisplayclassesGrass(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesHorizon();
	afx_msg void OnUpdateViewDisplayclassesHorizon(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesInfield();
	afx_msg void OnUpdateViewDisplayclassesInfield(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesObject();
	afx_msg void OnUpdateViewDisplayclassesObject(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesPeople();
	afx_msg void OnUpdateViewDisplayclassesPeople(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesTree();
	afx_msg void OnUpdateViewDisplayclassesTree(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesVechicle();
	afx_msg void OnUpdateViewDisplayclassesVechicle(CCmdUI* pCmdUI);
	afx_msg void OnViewDisplayclassesWall();
	afx_msg void OnUpdateViewDisplayclassesWall(CCmdUI* pCmdUI);
	afx_msg void OnShowcameras();
	afx_msg void OnUpdateShowcameras(CCmdUI* pCmdUI);
	afx_msg void OnOptionsShowcameranumbers();
	afx_msg void OnUpdateOptionsShowcameranumbers(CCmdUI* pCmdUI);
	afx_msg void OnRightpopSettopdrawlocation();
	afx_msg void OnRightpopAddtopdrawlocation();	
	afx_msg void OnEditDevelopmentReplaceys();
	afx_msg void OnEditDevelopmentReplacexs();
	afx_msg void OnEditDevelopmentReplacezs();
	afx_msg void OnShowtrack();
	afx_msg void OnUpdateShowtrack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDrawplanes(CCmdUI* pCmdUI);
	afx_msg void OnShowthreedo();
	afx_msg void OnUpdateShowthreedo(CCmdUI* pCmdUI);
	afx_msg void OnDrawplanes();
	afx_msg void OnOptionsSetnormalsquaresize();
	afx_msg void OnShowrooms();
	afx_msg void OnUpdateShowrooms(CCmdUI* pCmdUI);
	afx_msg void OnShownormals();
	afx_msg void OnUpdateShownormals(CCmdUI* pCmdUI);
	afx_msg void OnOptionsSetnormalscalevalue();
	afx_msg void OnViewElevationsTopview();
	afx_msg void OnDrawFifteenboxes();
	afx_msg void OnUpdateDrawFifteenboxes(CCmdUI* pCmdUI);
	afx_msg void OnShowfilled();
	afx_msg void OnUpdateShowfilled(CCmdUI* pCmdUI);
	afx_msg void OnRotatetool();
	afx_msg void OnUpdateRotatetool(CCmdUI* pCmdUI);
	afx_msg void OnPointtool();
	afx_msg void OnUpdatePointtool(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in 3DOEditorView.cpp
inline CMy3DOEditorDoc* CMy3DOEditorView::GetDocument()
   { return (CMy3DOEditorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
