// AlltitudeEditor.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "AlltitudeEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlltitudeEditor dialog


CAlltitudeEditor::CAlltitudeEditor(CWnd* pParent /*=NULL*/)
	: CDialog(CAlltitudeEditor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAlltitudeEditor)
	m_Delta1 = 0;
	m_Delta2 = 0;
	m_Delta3 = 0;
	m_Start = 0;
	m_Delta4 = 0;
	m_Delta5 = 0;
	m_X = 0;
	m_Y = 0;
	m_NextStart = 0;
	m_CalcNextStart = 0;
	//}}AFX_DATA_INIT
	Delta4NeedsCalc = FALSE;
	Delta5NeedsCalc = FALSE;
}


void CAlltitudeEditor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlltitudeEditor)
	DDX_Text(pDX, IDC_DELTA1, m_Delta1);
	DDX_Text(pDX, IDC_DELTA2, m_Delta2);
	DDX_Text(pDX, IDC_DELTA3, m_Delta3);
	DDX_Text(pDX, IDC_ESTART, m_Start);
	DDX_Text(pDX, IDC_DELTA4, m_Delta4);
	DDX_Text(pDX, IDC_DELTA5, m_Delta5);
	DDX_Text(pDX, IDC_X, m_X);
	DDX_Text(pDX, IDC_Y, m_Y);
	DDX_Text(pDX, IDC_NEXTSTART, m_NextStart);
	DDX_Text(pDX, IDC_CALCNEXTSTART, m_CalcNextStart);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlltitudeEditor, CDialog)
	//{{AFX_MSG_MAP(CAlltitudeEditor)
	ON_BN_CLICKED(IDC_CALC_DELTA4, OnCalcDelta4)
	ON_BN_CLICKED(IDC_CALC_DELTA5, OnCalcDelta5)
	ON_EN_CHANGE(IDC_DELTA3, OnChangeHeight)
	ON_EN_CHANGE(IDC_DELTA1, OnChangeDelta1)
	ON_EN_CHANGE(IDC_DELTA2, OnChangeDelta2)
	ON_EN_CHANGE(IDC_ESTART, OnChangeHeight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlltitudeEditor message handlers

void CAlltitudeEditor::OnCalcDelta4() 
{
	UpdateData(TRUE);
	m_Delta4 = m_Delta1 *3;
	UpdateData(FALSE);
	Delta4NeedsCalc = FALSE;
}

void CAlltitudeEditor::OnCalcDelta5() 
{
	UpdateData(TRUE);
	m_Delta5 = m_Delta2 *2;
	UpdateData(FALSE);
	Delta5NeedsCalc = FALSE;
}

void CAlltitudeEditor::OnChangeHeight() 
{
	UpdateData(TRUE);
	m_CalcNextStart = m_Delta1 + m_Delta2 + m_Delta3 + m_Start;
	UpdateData(FALSE);
}

void CAlltitudeEditor::OnChangeDelta1() 
{
	OnChangeHeight();
	Delta4NeedsCalc = TRUE;

}

void CAlltitudeEditor::OnChangeDelta2() 
{
	OnChangeHeight();
	Delta5NeedsCalc = TRUE;
}

void CAlltitudeEditor::OnOK() 
{
	if (Delta4NeedsCalc)
	{
		AfxMessageBox("Delta 4 must be recalculated");
		return;
	}

	if (Delta5NeedsCalc)
	{
		AfxMessageBox("Delta 5 must be recalculated");
		return;
	}
	
	CDialog::OnOK();
}

BOOL CAlltitudeEditor::OnInitDialog() 
{
	

	CDialog::OnInitDialog();
	
	m_CalcNextStart = m_Delta1 + m_Delta2 + m_Delta3 + m_Start;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
