
#ifndef _INLUCDED_GPL_H_
#define _INLUCDED_GPL_H_

#include "iostream.h"

extern int ReadPCWord(FILE *fp);
extern int ReadPCDWord(FILE *fp);
extern float ReadPCFloat(FILE *fp);
extern void WritePCFloat(FILE *fp,float data);


#include "Observer.h"
#include "Dat.h"

extern int GetFileLength(FILE *fp);

static char lpszGPLFilter[] = "3DO File(*.3do)|*.3do|CAM File(*.cam)|*.cam|TRK File(*.trk)|*.trk|MIP File(*.mip)|*.mip|SRB File(*.srb)|*.srb|PBF File(*.pbf)|*.pbf|LP File(*.lp)|*.lp|All Files (*.*)|*.*|";

class CGplFile: public Observer
{
public:   
   HTREEITEM      FileNode;   
   BOOL           dataLoaded;
   CDat          *datFileParent;
   CString        filename;
   int            filepos;
   int            length;
   int            length1;
   short          id;
   BOOL           Modified;
   BOOL			  verbose;

   CGplFile(e_obtype type):Observer(type)
   {
		datFileParent = NULL;
		dataLoaded = FALSE;
		FileNode = NULL;
		Modified = FALSE;
   }

   virtual ~CGplFile()
   {
   }
      

   void Copy(FILE *fpout)
   {				
	   CString tempDir;
	   tempDir.Format("%s%sTemp\\%s",datFileParent->DatDrive,datFileParent->DatDir,filename);
		  
	   FILE *fpin = FOPEN(tempDir,"rb");
	   if (fpin==NULL)
	   {
		   CString msg;
		   msg.Format("Cannot Open %s for copying",tempDir);
		   AfxMessageBox(msg);
		   return;
	   }
	   int len = GetFileLength(fpin);
	   

	   int count=0;
	   while(len)
	   {
	     char c = fgetc(fpin);
	     fputc(c,fpout);
		 len--;
	   }
	   FCLOSE(fpin);
   }

   void ExportToFile()
   {				
	   CString tempDir;
	   tempDir.Format("%s%sTemp\\%s",datFileParent->DatDrive,datFileParent->DatDir,filename);
		  
	   FILE *fpout = FOPEN(tempDir,"wb");
	   if (fpout==NULL)
	   {
		   CString msg;
		   msg.Format("Cannot Open %s for writing",tempDir);
		   AfxMessageBox(msg);
		   return;
	   }
	   Write(fpout);
	   fflush(fpout);
	   FCLOSE(fpout);
   }

   virtual CString GetDefaultExtension() = 0;
   
   void SaveAs(LPCSTR filename=NULL);

   

   BOOL isModified()
   {
	   return Modified;
   }

   void SetModified(BOOL set=TRUE)
   {
	   Modified=set;
   }


   void setFileInfo(int _id,int _length,int _length1,char *_filename,int _offset)
   {
	   id      = _id;
	   length  = _length;
	   length1 = _length1;
	   filename.Format("%s",_filename);
	   filepos  = _offset;
   }

   virtual BOOL Read(const char * filename)
   {
	   return FALSE;
   }

   virtual BOOL Read(FILE *fp)
   {
	   return FALSE;
   }

   virtual BOOL Write(FILE *fp)
   {
	   AfxMessageBox("No Writer Exists for this file type");
	   return FALSE;
   }

   //virtual void Explore(){}


   void GetFile(BOOL _verbose=TRUE)
   {	   
	   verbose = _verbose;

	   if (dataLoaded==FALSE && datFileParent != NULL)
	   {
	      int filep = filepos;
		  if (verbose) cout << filename << " loading.....";
		  if (!datFileParent->isPackFile())
		  {
	      datFileParent->SetFilePosition(filep);
	      dataLoaded = Read(datFileParent->GetFileHandle());
	      datFileParent->SetFilePosition(filep);
		  }
		  else
		  {
		  CString tempDir;
	      tempDir.Format("%s%sTemp\\%s",datFileParent->DatDrive,datFileParent->DatDir,filename);
		  dataLoaded = Read(tempDir);
		  }
		  if (verbose) cout << "done" << endl;
	   }
   }

   	virtual void UnPack()
   {
	   int filep = filepos;
	   datFileParent->SetFilePosition(filep);

	   FILE *fpout = FOPEN(filename,"wb");
	   if (fpout == NULL)
	   {
		   AfxMessageBox("Cannot open file for output");
		   return;
	   }
	   for(int i=0;i<length;i++)
	   {
		   char c = fgetc(datFileParent->GetFileHandle());
		   fputc(c,fpout);
	   }
	   FCLOSE(fpout);
   }

   virtual void UnPack(FILE *fpOut)
   {
	   int filep = filepos;
	   datFileParent->SetFilePosition(filep);

	   for(int i=0;i<length;i++)
	   {
		   char c = fgetc(datFileParent->GetFileHandle());
		   fputc(c,fpOut);
	   }
   }

   virtual void LoadTree(HTREEITEM parent,CObjectTree *tree)
   {
   }

   BOOL is3do() { return (objtype == t_tdo);}
   BOOL isMip() { return (objtype == t_mip);}
   BOOL isMi4() { return (objtype == t_mi4);}
   BOOL isSrb() { return (objtype == t_srb);}
   BOOL isPbf() { return (objtype == t_pbf);}
   BOOL isPcx() { return (objtype == t_pcx);}
   BOOL isWav() { return (objtype == t_wav);}

   BOOL isSetup() 
   {
	   if (!filename.Find("setup"))
	   {
		   return TRUE;
	   }
	   return FALSE;
   }

   
};

#endif