
#ifndef _INCLUDED_MIP_H_
#define _INCLUDED_MIP_H_

#include "BMP.h"
#include "CGPLFile.h"

// ok this time I'm going to start with 
// with a class

typedef enum { t_MIPGPL, t_MIPN2, t_MIPICR2 } t_MipVersion;

typedef struct
{
	char id[8];	//MIP
	unsigned long fileSize;
	char id2[8]; // MPHD
	unsigned long hsize;
} t_Mip_Header;

typedef struct
{	
	unsigned char b;	
	unsigned char g;	
	unsigned char r;
	unsigned char a;
} t_RGB;

typedef struct
{	
	char id[8];	//CMAP
	unsigned long fileSize;
	t_RGB palette[16];
} t_CMap_Header;

typedef struct
{
	char id[8];	//CMAP
	unsigned long fileSize;
} t_BMap;


typedef struct
{
	char id[8];	//DHMB
	unsigned long fileSize;
	unsigned long hsize;   // padding occurs
	unsigned char ver;
	unsigned long x;
	unsigned long y;
	unsigned long width;
	int unknown;
} t_BMPH;

typedef struct
{
	char id[8];	//DATA
	unsigned long fileSize;
} t_DATA;


class CMip: public CGplFile
{
public:
	

	CMip():CGplFile(t_mip)
	{
		//bitmapData = NULL;
		cmap       = TRUE;
		bits       = NULL;
	}

	virtual ~CMip()
	{
		//if (bitmapData) delete bitmapData;
		//if (bits)       delete bits;
	}

	BMP bitmapData;

	BOOL Read(const char *filename);
	BOOL Read(FILE *fp);
	BOOL ReadICR2Mip(FILE *fp);
	BOOL cmap;

	CBitmap cbmp;
	CBitmap output; // 128x128 bitmap for texture mapping
	unsigned char *bits;   // raw image for texture mapping

	CString GetDefaultExtension()
	{
		return CString("mip");
	}
	

	BMP *getBitmap()
	{
		return &bitmapData;
	}

	int ver;
	int logx;
	int logy;
	int numimages;
	int color;
	int unknown;

	void Explore();

	t_MipVersion version;

	BOOL isN2Version()
	{
		return (version == t_MIPN2) ? true : false;
	}

	BOOL isICR2Version()
	{
		return (version == t_MIPICR2) ? true : false;
	}
};


#endif