
#include "stdafx.h"
#include "CPbf.h"
#include "stdio.h"
#include "MipPreview.h"

BOOL CPbf::Read(const char *filename)
{
	FILE *fp = FOPEN(filename,"rb");

	if (fp == NULL)
	{
		return FALSE;
	}
	Read(fp);
	return TRUE;
}

BOOL CPbf::Read(FILE *fp)
{
	int foff = ftell(fp);
	{
		cmip = new CMip();

		t_BMap BHeader;
		fread(&BHeader,1,sizeof(t_BMap),fp);
		t_BMPH IHeader;
		fread(&IHeader,1,12,fp);
		IHeader.ver       = getc(fp);
	    IHeader.x         = ReadPCDWord(fp);
	    IHeader.y         = ReadPCDWord(fp);
	    IHeader.width     = ReadPCDWord(fp);
        IHeader.unknown   = getc(fp);		
		IHeader.unknown   = getc(fp);		
		IHeader.unknown   = getc(fp);
		t_DATA DHeader;
		fread(&DHeader,1,sizeof(t_DATA),fp);
		int dataSize = (IHeader.width*IHeader.y);
		unsigned short *image = new unsigned short[dataSize];
		fread(image,1,dataSize,fp);
		unsigned char *image8 = new unsigned char[3*dataSize];

		RGBQUAD *pal = new RGBQUAD[256];
		int  numPal = 0;
		int  imageSize = (IHeader.width/2*IHeader.y);

		int count = 0;
		//If type is 3, number format is: rrrrrggggggbbbbb (6 green, 5 red & blue) 
		//If type is 5, number format is aaaarrrrggggbbbb (4 alpha, 4 red, green & blue) 
		for(unsigned int i=0;i<IHeader.y;i++)
		{
			for(unsigned int j=0;j<IHeader.x;j++)
			{
			int value = image[j+(i*IHeader.x)];

			if (IHeader.ver == 3)
			{
				int r = 0x1F & (value >> 11);
				int g = 0x3F & (value >> 5);
				int b = 0x1F & (value);
				
				image8[count]   = r*8;
				image8[count+1] = g*4;
				image8[count+2] = b*8;
				if (count >= (3*dataSize)) break;
				
			}
			else
			{
				int r = 0x0F & (value >> 8);
				int g = 0x0F & (value >> 4);
				int b = 0x0F & (value);
			    image8[count]   = r*16;
				image8[count+1] = g*16;
				image8[count+2] = b*16;
				if (count >= (3*dataSize)) break;
			}			
			count+=3;
			}
		}
		int pad   = IHeader.x%4;
		int width = IHeader.x+pad;

		cmip->bitmapData.Create((unsigned short)width,(unsigned short)IHeader.y,image8,TRUE);
	}

	
	return TRUE;
}

void CPbf::Explore()
{
	GetFile();

    if (dataLoaded)
	{
	   CMipPreview *dlg = new CMipPreview();
	   dlg->nWidth  = cmip->bitmapData.ImageWidth();
	   dlg->nHeight = cmip->bitmapData.ImageHeight();
	   cmip->bitmapData.CreateDIB(dlg->bmp);
	   dlg->DoModal();
	}
	else
	{
	   AfxMessageBox("File Cannot be Loaded");
	}
}