
#include "stdafx.h"
#include "CSrb.h"
#include "stdio.h"
#include "MipPreview.h"

void CSrb::ReadHeader(FILE *fp)
{
		fread(Sid,8,sizeof(char),fp);
		Slen = ReadPCDWord(fp);

		fread(SDid,8,sizeof(char),fp);
		SDLen = ReadPCDWord(fp);
		SXY[0] = ReadPCFloat(fp);
		SXY[1] = ReadPCFloat(fp);
		SXY[2] = ReadPCFloat(fp);
		SXY[3] = ReadPCFloat(fp);
		SXY[4] = ReadPCFloat(fp);
		SXY[5] = ReadPCFloat(fp);

		fread(SD2id,8,sizeof(char),fp);
		SD2Len = ReadPCDWord(fp);
}

BOOL CSrb::Read(const char *filename)
{
	FILE *fp = FOPEN(filename,"rb");

	if (fp == NULL)
	{
		return FALSE;
	}
	Read(fp);
	return TRUE;
}

BOOL CSrb::Read(FILE *fp)
{
	int foff = ftell(fp);
	int num = 4-(foff%4);
	for(int i=0;i<num;i++)
	{
		//int unk = fgetc(fp);
	}
	ReadHeader(fp);
	
	if (SD2Len!=36)
	{
	 for(i=0;i<SD2Len;i++)
	 {
		fgetc(fp);
	 }
	 //AfxMessageBox("Not 35 in SRB");
	}
	else
	{
		SHXY[0] = ReadPCFloat(fp);
		SHXY[1] = ReadPCFloat(fp);
		SHXY[2] = ReadPCFloat(fp);
		SHXY[3] = ReadPCFloat(fp);
		SHXY[4] = ReadPCFloat(fp);
		SHXY[5] = ReadPCFloat(fp);
		SHXY[6] = ReadPCFloat(fp);
		SHXY[7] = ReadPCFloat(fp);
		SHXY[8] = ReadPCFloat(fp);
	}
	

	cmip = new CMip();
	cmip->cmap = TRUE;
	cmip->Read(fp);
	return TRUE;
}

void CSrb::Explore()
{
	GetFile();

    if (dataLoaded)
	{
	   CMipPreview *dlg = new CMipPreview();
	   dlg->nWidth  = cmip->bitmapData.ImageWidth();
	   dlg->nHeight = cmip->bitmapData.ImageHeight();
	   cmip->bitmapData.CreateDIB(dlg->bmp);
	   dlg->DoModal();
	}
	else
	{
	   AfxMessageBox("File Cannot be Loaded");
	}
}

void CSrb::LoadTree(HTREEITEM parent,CObjectTree *tree)
{
		GetFile();
	    CString buffer;

		buffer.Format("SXY");
	    HTREEITEM sxyp = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_UNK));

		for(int i=0;i<6;i++)
		{
			buffer.Format("SXY[%d] = %f",i,SXY[i]);
			HTREEITEM sxy = tree->insertInfoNode(sxyp, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
		}

		buffer.Format("SHXY");
	    HTREEITEM shxyp = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_UNK));

		for(i=0;i<9;i++)
		{
			buffer.Format("SHXY[%d] = %f",i,SHXY[i]);
			HTREEITEM sxy = tree->insertInfoNode(shxyp, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
		}


}