

#include "stdafx.h"
#include "Cam.h"
#include "stdio.h"
#include "ObjectTree.h"
#include "resource.h"
#include "Trk.h"
#include "math.h"
#include "3DOEditor.h"
#include "3DOEditorView.h"

#include <gl\glaux.h>
#include <gl\gl.h>
#include <gl\glu.h>


void WritePCDWord(FILE *fp,int value);
extern void WritePCFloat(FILE *fp,float value);
extern double CurvatureToDegrees(long orientation);

extern double DegToRad(double angle);
extern CPoint GetTrackPoint(double currrad,double angle,double length);
void setGLColor(float r,float g,float b);

CCam::~CCam()
	{  
		if (CamerasTV1) delete[] CamerasTV1;
		if (CamerasTV2) delete[] CamerasTV2;
		
		/*
		for(int i=0;i<numCameraTV1;i++)
		{
			CCamera *ptr = (CCamera*)((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->m_ObjectTree.GetItemData(CamerasTV1Node[i]);
			if (ptr) delete ptr;
		}
		for(i=0;i<numCameraTV2;i++)
		{
			CCamera *ptr = (CCamera*)((CMy3DOEditorApp*)AfxGetApp())->m_MainTree->m_ObjectTree.GetItemData(CamerasTV2Node[i]);
			if (ptr) delete ptr;
		}
		*/

	    if (CamerasTV1Node) delete[] CamerasTV1Node;
		if (CamerasTV2Node) delete[] CamerasTV2Node;
	}

BOOL CCam::Read(const char *filename)
{
	FILE *fp = FOPEN(filename,"rb");

	if (fp == NULL)
	{
		return FALSE;
	}
	Read(fp);
	FCLOSE(fp);
	return TRUE;
}

BOOL CCam::Read(FILE *fp)
{
	BOOL isN2Version=FALSE;
	if (dataLoaded) return TRUE;
	offset = ftell(fp);
	fread(&Header,1,sizeof(t_Cam_Header),fp);

	if (!strcmp(Header.id,"MACC"))
	{
	    //car cam
		CarCam=TRUE;
		return ReadCar(fp);
	}
	else
	{
	  //track cam
	  if (strcmp(Header.id,"MACT"))
	  {
		  isN2Version = TRUE;
		  fseek(fp,offset,SEEK_SET);
		  //AfxMessageBox("Error Reading Camera File: Unknown format");
		  numCameraTV1 = 0;
		  numCameraTV2 = 0;
	  }
	}

	if (isN2Version)
		return ReadN2(fp);
	else
		return ReadGPL(fp);
}

BOOL CCam::ReadCar(FILE *fp)
{
	numCameraTV1 = 6;
	CamerasTV1 = new Camera[numCameraTV1];
	for(int i=0;i<numCameraTV1;i++)
	{
	   CamerasTV1[i].name.Format("Car Camera(%d)",i);
	   CamerasTV1[i].c1 = ReadPCFloat(fp);
	   CamerasTV1[i].c2 = ReadPCFloat(fp);
	   CamerasTV1[i].c3 = ReadPCFloat(fp);
	   CamerasTV1[i].c4 = ReadPCFloat(fp);
	   CamerasTV1[i].c5 = ReadPCDWord(fp);
	   CamerasTV1[i].c6 = ReadPCFloat(fp);
	   CamerasTV1[i].c7 = ReadPCFloat(fp);
	   CamerasTV1[i].c8 = ReadPCFloat(fp);
	   CamerasTV1[i].c9 = ReadPCFloat(fp);
	}
	numCameraTV2 = 0;
	return TRUE;
}

BOOL CCam::WriteCar(FILE *fp)
{
	for(int i=0;i<numCameraTV1;i++)
	{
	   CamerasTV1[i].name.Format("Car Camera(%d)",i);
	   WritePCFloat(fp,CamerasTV1[i].c1);
	   WritePCFloat(fp,CamerasTV1[i].c2);
	   WritePCFloat(fp,CamerasTV1[i].c3);
	   WritePCFloat(fp,CamerasTV1[i].c4);
	   WritePCDWord(fp,CamerasTV1[i].c5);
	   WritePCFloat(fp,CamerasTV1[i].c6);
	   WritePCFloat(fp,CamerasTV1[i].c7);
	   WritePCFloat(fp,CamerasTV1[i].c8);
	   WritePCFloat(fp,CamerasTV1[i].c9);
	}
	return TRUE;
}

BOOL CCam::ReadGPL(FILE *fp)
{
	  numCameraTV1 = ReadPCDWord(fp);
	
	  CamerasTV1 = new Camera[numCameraTV1];

	  
	  for(int i=0;i<numCameraTV1;i++)
	  {
	   CamerasTV1[i].name.Format("TV1(%d)",i);
       //fread(&CamerasTV1[i],1,sizeof(t_Camera),fp);	   
	   CamerasTV1[i].c1 = ReadPCFloat(fp);
	   CamerasTV1[i].c2 = ReadPCFloat(fp);
	   CamerasTV1[i].c3 = ReadPCFloat(fp);
	   CamerasTV1[i].c4 = ReadPCFloat(fp);
	   //CamerasTV1[i].c5 = ReadPCFloat(fp);
	   CamerasTV1[i].c5 = ReadPCDWord(fp);
	   CamerasTV1[i].c6 = ReadPCFloat(fp);
	   CamerasTV1[i].c7 = ReadPCFloat(fp);
	   CamerasTV1[i].c8 = ReadPCFloat(fp);
	   CamerasTV1[i].c9 = ReadPCFloat(fp);
	   CamerasTV1[i].c10 = ReadPCFloat(fp);
	   CamerasTV1[i].c11 = ReadPCFloat(fp);
	   CamerasTV1[i].c12 = ReadPCFloat(fp);
	   CamerasTV1[i].c13 = ReadPCDWord(fp);
	   CamerasTV1[i].c14 = ReadPCDWord(fp);

	  }

	  numCameraTV2 = ReadPCDWord(fp);
	  CamerasTV2 = new Camera[numCameraTV2];

	  for(i=0;i<numCameraTV2;i++)
	  {
	   CamerasTV2[i].name.Format("TV2(%d)",i);
	   //fread(&CamerasTV2[i],1,sizeof(t_Camera),fp);
	   CamerasTV2[i].c1 = ReadPCFloat(fp);
	   CamerasTV2[i].c2 = ReadPCFloat(fp);
	   CamerasTV2[i].c3 = ReadPCFloat(fp);
	   CamerasTV2[i].c4 = ReadPCFloat(fp);
	   //CamerasTV2[i].c5 = ReadPCFloat(fp);
	   CamerasTV2[i].c5 = ReadPCDWord(fp);
	   CamerasTV2[i].c6 = ReadPCFloat(fp);
	   CamerasTV2[i].c7 = ReadPCFloat(fp);
	   CamerasTV2[i].c8 = ReadPCFloat(fp);
	   CamerasTV2[i].c9 = ReadPCFloat(fp);
	   CamerasTV2[i].c10 = ReadPCFloat(fp);
	   CamerasTV2[i].c11 = ReadPCFloat(fp);
	   CamerasTV2[i].c12 = ReadPCFloat(fp);
	   CamerasTV2[i].c13 = ReadPCDWord(fp);
	   CamerasTV2[i].c14 = ReadPCDWord(fp);
	  }
	  

	  PitCamera.name.Format("Pit(%d)",i);
	  //fread(&PitCamera,1,sizeof(Camera),fp);
	  PitCamera.c1 = ReadPCFloat(fp);
	  PitCamera.c2 = ReadPCFloat(fp);
	  PitCamera.c3 = ReadPCFloat(fp);
	  PitCamera.c4 = ReadPCFloat(fp);
	  //PitCamera.c5 = ReadPCFloat(fp);
	  PitCamera.c5 = ReadPCDWord(fp);
	  PitCamera.c6 = ReadPCFloat(fp);
	  PitCamera.c7 = ReadPCFloat(fp);
	  PitCamera.c8 = ReadPCFloat(fp);
	  PitCamera.c9 = ReadPCFloat(fp);
	  PitCamera.c10 = ReadPCFloat(fp);
	  PitCamera.c11 = ReadPCFloat(fp);
	  PitCamera.c12 = ReadPCFloat(fp);
	  PitCamera.c13 = ReadPCDWord(fp);
	  PitCamera.c14 = 0;
	  dataLoaded = TRUE;
	  return TRUE;
}

BOOL CCam::ReadN2(FILE *fp)
{
	  numCameraTV1 = ReadPCDWord(fp);
	
	  CamerasTV1 = new Camera[numCameraTV1];
	  
	  for(int i=0;i<numCameraTV1;i++)
	  {
	   CamerasTV1[i].name.Format("TV1(%d)",i);	   
	   CamerasTV1[i].c1 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c2 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c3 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c4 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c5 = ReadPCDWord(fp);
	   CamerasTV1[i].c6 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c7 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c8 = (float)ReadPCDWord(fp);
	   CamerasTV1[i].c9 = (float)ReadPCDWord(fp);
	  }

	  numCameraTV2 = ReadPCDWord(fp);
	  //numCameraTV2 = numCameraTV1;
	  CamerasTV2 = new Camera[numCameraTV2];

	  for(i=0;i<numCameraTV2;i++)
	  {
	   CamerasTV2[i].name.Format("TV2(%d)",i);
	   CamerasTV2[i].c1 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c2 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c3 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c4 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c5 = ReadPCDWord(fp);
	   CamerasTV2[i].c6 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c7 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c8 = (float)ReadPCDWord(fp);
	   CamerasTV2[i].c9 = (float)ReadPCDWord(fp);
	  }
	  
	  numCameraTV2 = ReadPCDWord(fp);

	  PitCamera.name.Format("Pit(%d)",i);
	  PitCamera.c1 = (float)ReadPCDWord(fp);
	  PitCamera.c2 = (float)ReadPCDWord(fp);
	  PitCamera.c3 = (float)ReadPCDWord(fp);
	  PitCamera.c4 = (float)ReadPCDWord(fp);
	  PitCamera.c5 = ReadPCDWord(fp);
	  PitCamera.c6 = (float)ReadPCDWord(fp);
	  PitCamera.c7 = (float)ReadPCDWord(fp);
	  PitCamera.c8 = (float)ReadPCDWord(fp);
	  PitCamera.c9 = (float)ReadPCDWord(fp);
	  dataLoaded = TRUE;
	  return TRUE;
}

BOOL CCam::Write(FILE *fp)
{
	if (!datFileParent->isPackFile())
	{
	  fseek(fp,offset,SEEK_SET);
	}

	fwrite(&Header,1,sizeof(t_Cam_Header),fp);

	if (CarCam)
	{
		return WriteCar(fp);
	}

	WritePCDWord(fp,numCameraTV1);
	int foff = ftell(fp);

	for(int i=0;i<numCameraTV1;i++)
	{
	   
       //fwrite(&CamerasTV1[i],sizeof(t_Camera),1,fp);  
	   WritePCFloat(fp,CamerasTV1[i].c1);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c2);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c3);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c4);
	   foff = ftell(fp);
	   //WritePCFloat(fp,CamerasTV1[i].c5);
	   WritePCDWord(fp,CamerasTV1[i].c5);
	   foff = ftell(fp);
	   fflush(fp);
	   WritePCFloat(fp,CamerasTV1[i].c6);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c7);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c8);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c9);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c10);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c11);
	   foff = ftell(fp);
	   WritePCFloat(fp,CamerasTV1[i].c12);
	   foff = ftell(fp);
	   WritePCDWord(fp,CamerasTV1[i].c13);
	   foff = ftell(fp);
	   WritePCDWord(fp,CamerasTV1[i].c14);
	   foff = ftell(fp);
	}

	WritePCDWord(fp,numCameraTV2);

	for(i=0;i<numCameraTV2;i++)
	{
		
	   //fwrite(&CamerasTV2[i],sizeof(t_Camera),1,fp);
	   WritePCFloat(fp,CamerasTV2[i].c1);
	   WritePCFloat(fp,CamerasTV2[i].c2);
	   WritePCFloat(fp,CamerasTV2[i].c3);
	   WritePCFloat(fp,CamerasTV2[i].c4);
	   //WritePCFloat(fp,CamerasTV2[i].c5);
	   WritePCDWord(fp,CamerasTV2[i].c5);
	   WritePCFloat(fp,CamerasTV2[i].c6);
	   WritePCFloat(fp,CamerasTV2[i].c7);
	   WritePCFloat(fp,CamerasTV2[i].c8);
	   WritePCFloat(fp,CamerasTV2[i].c9);
	   WritePCFloat(fp,CamerasTV2[i].c10);
	   WritePCFloat(fp,CamerasTV2[i].c11);
	   WritePCFloat(fp,CamerasTV2[i].c12);
	   WritePCDWord(fp,CamerasTV2[i].c13);
	   WritePCDWord(fp,CamerasTV2[i].c14);
    }

	
	//fwrite(&PitCamera,1,sizeof(t_Camera),fp);
	   WritePCFloat(fp,PitCamera.c1);
	   WritePCFloat(fp,PitCamera.c2);
	   WritePCFloat(fp,PitCamera.c3);
	   WritePCFloat(fp,PitCamera.c4);
	   //WritePCFloat(fp,PitCamera.c5);
	   WritePCDWord(fp,PitCamera.c5);
	   WritePCFloat(fp,PitCamera.c6);
	   WritePCFloat(fp,PitCamera.c7);
	   WritePCFloat(fp,PitCamera.c8);
	   WritePCFloat(fp,PitCamera.c9);
	   WritePCFloat(fp,PitCamera.c10);
	   WritePCFloat(fp,PitCamera.c11);
	   WritePCFloat(fp,PitCamera.c12);
	   WritePCDWord(fp,PitCamera.c13);
	   //WritePCDWord(fp,PitCamera.c14);

	fflush(fp);
	
	return TRUE;
}

void CCam::LoadTree(HTREEITEM parent,CObjectTree *tree)
{
	GetFile();
	CString buffer;

	if (CarCam)
	{
		buffer.Format("Car Cameras (Unknown Format)");
	    HTREEITEM camerap = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
		CamerasTV1Node = new HTREEITEM[numCameraTV1];
		for(int i=0;i<numCameraTV1;i++)
		{
	   buffer.Format("Car Camera[%d]",i);
	   CamerasTV1Node[i] = tree->insertInfoNode(camerap, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
	   tree->m_ObjectTree.SetItemData(CamerasTV1Node[i],(DWORD)new CCamera(this,&(CamerasTV1[i])));

	   buffer.Format("Car -> arg1? = %f",CamerasTV1[i].c1);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg2? = %f",CamerasTV1[i].c2);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg3? = %f",CamerasTV1[i].c3);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg4? = %f",CamerasTV1[i].c4);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg5? = %d",CamerasTV1[i].c5);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg6? = %f",CamerasTV1[i].c6);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg7? = %f",CamerasTV1[i].c7);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg8? = %f",CamerasTV1[i].c8);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("Car -> arg9? = %f",CamerasTV1[i].c9);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
	}
	}
	else
	{
	buffer.Format("Cameras TV1 %d",numCameraTV1);
	HTREEITEM camerap = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
	CamerasTV1Node = new HTREEITEM[numCameraTV1];
	

	for(int i=0;i<numCameraTV1;i++)
	{
	   buffer.Format("TV1 Camera[%d]",i);
	   CamerasTV1Node[i] = tree->insertInfoNode(camerap, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
	   tree->m_ObjectTree.SetItemData(CamerasTV1Node[i],(DWORD)new CCamera(this,&(CamerasTV1[i])));

	   buffer.Format("TV1 -> arg1? = %f",CamerasTV1[i].c1);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg2? = %f",CamerasTV1[i].c2);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg3? = %f",CamerasTV1[i].c3);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg4? = %f",CamerasTV1[i].c4);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg5? = %d",CamerasTV1[i].c5);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg6? = %f",CamerasTV1[i].c6);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg7? = %f",CamerasTV1[i].c7);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg8? = %f",CamerasTV1[i].c8);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg9? = %f",CamerasTV1[i].c9);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg10? = %f",CamerasTV1[i].c10);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg11? = %f",CamerasTV1[i].c11);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg12? = %f",CamerasTV1[i].c12);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg13? = %f",CamerasTV1[i].c13);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV1 -> arg14? = %f",CamerasTV1[i].c14);
	   tree->insertInfoNode(CamerasTV1Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	}

	buffer.Format("Cameras TV2 %d",numCameraTV2);
	HTREEITEM camerap2 = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
	CamerasTV2Node = new HTREEITEM[numCameraTV2];

	for(i=0;i<numCameraTV2;i++)
	{
	   buffer.Format("TV2 Camera[%d]",i);
	   CamerasTV2Node[i] = tree->insertInfoNode(camerap2, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
	   tree->m_ObjectTree.SetItemData(CamerasTV2Node[i],(DWORD)new CCamera(this,&CamerasTV2[i]));
	   
	   buffer.Format("TV2 -> arg1? = %f",CamerasTV2[i].c1);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg2? = %f",CamerasTV2[i].c2);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg3? = %f",CamerasTV2[i].c3);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg4? = %f",CamerasTV2[i].c4);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg5? = %d",CamerasTV2[i].c5);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg6? = %f",CamerasTV2[i].c6);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg7? = %f",CamerasTV2[i].c7);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg8? = %f",CamerasTV2[i].c8);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg9? = %f",CamerasTV2[i].c9);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg10? = %f",CamerasTV2[i].c10);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg11? = %f",CamerasTV2[i].c11);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg12? = %f",CamerasTV2[i].c12);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg13? = %f",CamerasTV2[i].c13);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("TV2 -> arg14? = %f",CamerasTV2[i].c14);
	   tree->insertInfoNode(CamerasTV2Node[i], (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	}

	{
	   buffer.Format("PitLane Camera");
	   PitCameraNode = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_CAMERA));
	   tree->m_ObjectTree.SetItemData(PitCameraNode,(DWORD)new CCamera(this,&PitCamera));
	   
	   buffer.Format("PitCamera -> arg1? = %f",PitCamera.c1);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg2? = %f",PitCamera.c2);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg3? = %f",PitCamera.c3);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg4? = %f",PitCamera.c4);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg5? = %d",PitCamera.c5);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg6? = %f",PitCamera.c6);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg7? = %f",PitCamera.c7);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg8? = %f",PitCamera.c8);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg9? = %f",PitCamera.c9);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg10? = %f",PitCamera.c10);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg11? = %f",PitCamera.c11);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg12? = %f",PitCamera.c12);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg13? = %f",PitCamera.c13);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	   buffer.Format("PitCamera -> arg14? = %f",PitCamera.c14);
	   tree->insertInfoNode(PitCameraNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	 }
    }

}


void CCam::ExportCSV(FILE *fp)
{
	for(int i=0;i<numCameraTV1;i++)
	{
		CamerasTV1[i].ExportCSV(fp);		
	}

	for(i=0;i<numCameraTV1;i++)
	{
		CamerasTV2[i].ExportCSV(fp);		
	}

	PitCamera.ExportCSV(fp);
}

void Camera::DrawCamera(Display *dpy,CTrk *track)
{
	double distance = c1;
	TrackSection *TrackSectionIn = track->SectorForLength(distance);
	CPoint trkPt;

	if (TrackSectionIn)
	{
	 double distance_to_section_begin   = track->ToMeters(track->LengthToTrackSector(TrackSectionIn));
	 double remainder = distance-distance_to_section_begin;

	  
		 

	 //double x=TrackSectionIn->startX-dpy->ofx;
     //double y=TrackSectionIn->startY-dpy->ofy;
	 double x=TrackSectionIn->startX;
     double y=TrackSectionIn->startY;

	 if (TrackSectionIn->isCorner())
	 {
		 if (remainder > 0)
		 {
		   double TrackAngle = CurvatureToDegrees(TrackSectionIn->data.unk4);
		   trkPt = GetTrackPoint(TrackSectionIn->startAngle,TrackAngle,remainder);
		   x +=  trkPt.x;
		   y +=  trkPt.y;
		 }
	 }
	 else
	 {
		 if (remainder > 0)
		 {
		   x += remainder*cos(TrackSectionIn->startAngle);
		   y += remainder*sin(TrackSectionIn->startAngle);
		 }		 
	 }


	 double distFromCenter = c2;
	 double Cx,Cy;

	 if (distFromCenter < 0)
	 {
	 Cx = x+getRightSideX(TrackSectionIn->startAngle,distFromCenter);
	 Cy = y+getRightSideY(TrackSectionIn->startAngle,distFromCenter);
	 }
	 else
	 {
	 Cx = x+getRightSideX(TrackSectionIn->startAngle,distFromCenter);
	 Cy = y+getRightSideY(TrackSectionIn->startAngle,distFromCenter);
	 }

	 //x = (x*dpy->getScale());
	 //y = (y*dpy->getScale());
	 dpy->drawBitmap(IDB_CAMERA,Cx,Cy);
	 dpy->drawLine(x,y,Cx,Cy);
	 {
		 //CString str;
		 //str.Format("%s",name);
		 dpy->drawText(Cx+20,Cy+16,name);
	 }
	}
}

void CCam::DrawGL(HDC hdc,CView *view)
{
	if (CarCam)
	{
		glPointSize(5.0f);
		glBegin(GL_POINTS);
		
		for(int i=0;i<numCameraTV1;i++)
		{
	       setGLColor(0.0f,1.0f,0.0f);
	       GLdouble wx,wy,wz;
	       wx = (double)CamerasTV1[i].c1;
	       wy = (double)CamerasTV1[i].c2;
	       wz = (double)CamerasTV1[i].c3;
	       glVertex3d(wx,wy,wz);
		}
		glEnd();
	}
}

void CCam::DrawGLText(HDC hdc,CView *view)
{
	if (CarCam)
	{
		CMy3DOEditorView *doview = (CMy3DOEditorView*)view;
		CMy3DOEditorDoc  *pDoc = (CMy3DOEditorDoc*)doview->GetDocument();
		if (pDoc && pDoc->object)
		{
		 glPushMatrix();
		 float scale = 3.0f;
		 glScalef(scale,scale,scale);
	     glTranslated(-pDoc->object->midx,-pDoc->object->midy,-pDoc->object->midz);

         if (doview->GetDocument()->showCameraNumbers)
		 {
		  for(int i=0;i<numCameraTV1;i++)
		  {
		  GLdouble wx,wy,wz;
	      wx = (double)CamerasTV1[i].c1;
	      wy = (double)CamerasTV1[i].c2;
	      wz = (double)CamerasTV1[i].c3;
	      glVertex3d(wx,wy,wz);
		  DrawText2D(hdc,doview,wx,wy,wz,i);		
		  }
		 }
		 glPopMatrix();
		}
	}
}

void CCam::Draw(Display *dpy,CTrk *track)
{

	for(int i=0;i<numCameraTV1;i++)
	{
		CamerasTV1[i].DrawCamera(dpy,track);		
	}

	for(i=0;i<numCameraTV1;i++)
	{
		CamerasTV2[i].DrawCamera(dpy,track);		
	}

	PitCamera.DrawCamera(dpy,track);
}

