
#ifndef _CAM_H_INCLUDED_
#define _CAM_H_INCLUDED_

#include "CGPLFile.h"
#include "ObjectTree.h"
#include "CamEdit.h"
#include "Display.h"

// ok this time I'm going to start with 
// with a class

typedef struct
{
	char id[8]; // " BRS"
	int  dataSize;
} t_Cam_Header;

class Camera
{
  public:
	Camera()
	{
		c1 = c2 = c3 = c4 = c6 = c7 = c8 = c9 = c10 = c11 = c12 = 0.0f;
		c5 = c13 = c14 = 0;
	}

	float c1;
	float c2;
	float c3;
	float c4;
	int   c5;
	float c6;
	float c7;
	float c8;
	float c9;
	float c10;
	float c11;
	float c12;
	int   c13;
	int   c14;


	void ExportCSV(FILE *fp)
	{
		fprintf(fp,"%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%2.2f,%d,%d\n",
					c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14);
	}

	void DrawCamera(Display *dpy,CTrk *track);

	CString name;
} ;

class CCamera;

class CCam: public CGplFile
{
public:
	CCam():CGplFile(t_cam)
	{
		CarCam=FALSE;
		CamerasTV1 = NULL;
		CamerasTV2 = NULL;
		CamerasTV1Node = NULL;
		CamerasTV2Node = NULL;
	}

	~CCam();

	int offset;

	void DrawGL(HDC hdc,CView *view);
	void DrawGLText(HDC hdc,CView *view);
	
	CString GetDefaultExtension()
	{
		return CString("cam");
	}

	BOOL Read(const char *filename);
	BOOL Read(FILE *fp);
	BOOL ReadN2(FILE *fp);
	BOOL ReadGPL(FILE *fp);
	BOOL ReadCar(FILE *fp);
	BOOL WriteCar(FILE *fp);

	BOOL Write(FILE *fp);

	void LoadTree(HTREEITEM node,CObjectTree *tree);

	void ExportCSV(FILE *fp);

	void Draw(Display *dpy,CTrk *track);

	t_Cam_Header Header;
	int numCameraTV1;
	int numCameraTV2;
    Camera *CamerasTV1;
	Camera *CamerasTV2;
	Camera PitCamera;
	HTREEITEM *CamerasTV1Node;
	HTREEITEM *CamerasTV2Node;
	HTREEITEM PitCameraNode;
	BOOL CarCam;
};

class CCamera: public Observer
{
   public:
	CCam *parent;

	CCamera(CCam *parent,Camera *cam):cam(cam),Observer(t_cam),parent(parent)
	{
	}

	void Explore()
	{
		CCamEdit *dlg = new CCamEdit(parent->CarCam);
	
		dlg->m_Unk1 = cam->c1;
		dlg->m_Unk2 = cam->c2;
		dlg->m_Unk3 = cam->c3;
		dlg->m_Unk4 = cam->c4;
		dlg->m_Unk5 = cam->c5;
		dlg->m_Unk6 = cam->c6;
		dlg->m_Unk7 = cam->c7;
		dlg->m_Unk8 = cam->c8;
		dlg->m_Unk9 = cam->c9;
		dlg->m_Unk10 = cam->c10;
		dlg->m_Unk11 = cam->c11;
		dlg->m_Unk12 = cam->c12;
		dlg->m_Unk13 = cam->c13;
		dlg->m_Unk14 = cam->c14;

		int result = dlg->DoModal();

		if (result == IDOK)
		{
			cam->c1 = dlg->m_Unk1;
			cam->c2 = dlg->m_Unk2;
			cam->c3 = dlg->m_Unk3;
			cam->c4 = dlg->m_Unk4;
			cam->c5 = dlg->m_Unk5;
			cam->c6 = dlg->m_Unk6;
			cam->c7 = dlg->m_Unk7;
			cam->c8 = dlg->m_Unk8;
			cam->c9 = dlg->m_Unk9;
			cam->c10 = dlg->m_Unk10;
			cam->c11 = dlg->m_Unk11;
			cam->c12 = dlg->m_Unk12;
			cam->c13 = dlg->m_Unk13;
			cam->c14 = dlg->m_Unk14;
			parent->SetModified();
		}


		if (dlg) delete dlg;
	}

	Camera *cam;
};

#endif