

#include "stdafx.h"
#include "Dat.h"
#include "stdio.h"
#include "CGPLFile.h"
#include "resource.h"
#include "Progress.h"

#include "CMip.h"
#include "CSrb.h"
#include "C3do.h"
#include "Cam.h"
#include "Trk.h"
#include "CPbf.h"
#include "Ini.h"
#include "Lp.h"
#include "Wav.h"
#include "Setup.h"
#include "Unk.h"

#include "sys/stat.h"

int ReadPCWord(FILE *fp);
int ReadPCDWord(FILE *fp);
void WritePCWord(FILE *fp,int value);
void WritePCDWord(FILE *fp,int value);

int openFiles=0;
char *openFile[256];

CDat::~CDat()
	{
		delete files;
		//delete LpDocument;
		if (outputfile) free(outputfile);
		if (LpDocument)
		{
			if (LpDocument->raceLP) delete LpDocument->raceLP;
			if (LpDocument->pass1LP) delete LpDocument->pass1LP;
			if (LpDocument->pass2LP) delete LpDocument->pass2LP;
			if (LpDocument->minRaceLP) delete LpDocument->minRaceLP;
			if (LpDocument->maxRaceLP) delete LpDocument->maxRaceLP;
			if (LpDocument->pitLP) delete LpDocument->pitLP;
		}
		if (recordIni) delete recordIni;
		if (trackIni) delete trackIni;
	}

FILE * FOPEN(const char *x,char *r)
{
	FILE *fp = fopen(x,r);
	//openFile[openFiles] = strdup(x);
	//openFiles++;
	//TRACE("open %d %s %s\n",openFiles,x,r);
	return fp;
}

void FCLOSE(FILE *x)  
{
	fclose(x);
	//openFiles--;
	//TRACE("close %d\n",openFiles);
}


void EndFiles()
{
	//for(int i=0;i<openFiles;i++)
	//{
	//	cerr << "Still Open " << openFile[i] << endl;
	//}
}

BOOL CDat::isPackFileName(const char *filename)
{
	char  TDatDrive[256];
	char  TDatDir[256];
	char  TDatFile[256];
	char  TDatExt[256];

	 _splitpath(filename,TDatDrive,TDatDir,TDatFile,TDatExt);

	 if (!stricmp(TDatExt,".pck"))
	 {
		 return TRUE;
	 }
	 else
	 {
		 return FALSE;
	 }

	 return FALSE;
}

BOOL CDat::Read(const char *filename)
{
	if (Open(filename))
	{
	 
     _splitpath(filename,DatDrive,DatDir,DatFile,DatExt);

	 if (!stricmp(DatExt,".pck"))
	 {
		 SetPackFile(TRUE);
		 // strip the TEMP dir off
		 char *ptr = strrchr(DatDir,'\\');
		 *ptr = '\0';
		 ptr = strrchr(DatDir,'\\');
		 *ptr = '\0';
		 strcat(DatDir,"\\");
		 SetTrackFile(FALSE);
	 }
	 else if (!stricmp(DatExt,".trk"))
	 {
		 SetPackFile(FALSE);
		 SetTrackFile(TRUE);
	 }
	 else
	 {
		 SetPackFile(FALSE);
		 SetTrackFile(FALSE);
	 }

	 Read();

	 char trkini[256];
	 char recordini[256];

	 _makepath(trkini,DatDrive,DatDir,"track","ini");
	 trackIni = new CTrackIni();
	 trackIni->Read(trkini);

	 _makepath(recordini,DatDrive,DatDir,"record","ini");
	 recordIni = new CIni();
	 recordIni->Read(recordini);

	 char racelp[256];
	 char minracelp[256];
	 char maxracelp[256];
	 char pass1lp[256];
	 char pass2lp[256];
	 char pitlp[256];

	 cerr << "Reading LP files" << endl;

	 _makepath(racelp,DatDrive,DatDir,"race","lp");
	 LpDocument->raceLP = new CLp();
	 LpDocument->raceLP->Read(racelp);

	 _makepath(minracelp,DatDrive,DatDir,"minrace","lp");
	 LpDocument->minRaceLP = new CLp();
	 LpDocument->minRaceLP->Read(minracelp);

	 _makepath(maxracelp,DatDrive,DatDir,"maxrace","lp");
	 LpDocument->maxRaceLP = new CLp();
	 LpDocument->maxRaceLP->Read(maxracelp);

	 _makepath(pass1lp,DatDrive,DatDir,"pass1","lp");
	 LpDocument->pass1LP = new CLp();
	 LpDocument->pass1LP->Read(pass1lp);

	 _makepath(pass2lp,DatDrive,DatDir,"pass2","lp");
	 LpDocument->pass2LP = new CLp();
	 LpDocument->pass2LP->Read(pass2lp);

	 _makepath(pitlp,DatDrive,DatDir,"pit","lp");
	 LpDocument->pitLP = new CLp();
	 LpDocument->pitLP->Read(pitlp);

     cerr << "Done Reading LP files" << endl;

	 return TRUE;
	}
	return FALSE;
}

char *getExtension(char *name)
{
	char *ext = strrchr(name,'.');
	ext++;
	return ext;
}

char *getBaseFilename(char *name)
{
	char *fname = strdup(name);
	char *ext = strrchr(fname,'.');
	*ext='\0';
	return fname;
}

int FileNameToIcon(char *name)
{
	char *ext = getExtension(name);
	char *base = getBaseFilename(name);
	int   id = IDB_FILE;

	if (!stricmp(ext,"wav"))         id =  IDB_SND;
	else if (!stricmp(ext,"3do"))    id = IDB_OBJECT;
	else if (!stricmp(ext,"mip"))    id = IDB_MIP;
	else if (!stricmp(ext,"mi4"))    id = IDB_MIP;
	else if (!stricmp(ext,"srb"))    id = IDB_SRB;
	else if (!stricmp(ext,"pbf"))    id = IDB_PFB;
	else if (!stricmp(ext,"pcx"))    id = IDB_PFB;
	else if (!stricmp(ext,"cam"))    id = IDB_CAMERA;
	else if (!stricmp(ext,"trk"))    id = IDB_TRK;
	else if (!stricmp(base,"setup")) id = IDB_SETUP;
	free(base);

	return id;
}

CGplFile * FileNameToType(char *name)
{
	char *ext = getExtension(name);
	char *base = getBaseFilename(name);
	CGplFile *nfile;

	if (!stricmp(ext,"3do"))      nfile =  new C3do(NULL);
	else if (!stricmp(ext,"mip")) nfile = new CMip();
	else if (!stricmp(ext,"srb")) nfile = new CSrb();
	else if (!stricmp(ext,"cam")) nfile = new CCam();
	else if (!stricmp(ext,"trk")) nfile = new CTrk();
	else if (!stricmp(ext,"pbf")) nfile = new CPbf();
	else if (!stricmp(ext,"pcx")) nfile = new UnknownFile(t_pcx);
	else if (!stricmp(ext,"mi4")) nfile = new UnknownFile(t_mi4);
	else if (!stricmp(ext,"wav")) nfile = new CWav();
	else if (!stricmp(base,"setup")) nfile = new CSetup();
	else nfile = new UnknownFile();
	free(base);
	return nfile;
}

char * getline(FILE *fp)
{
	char *buffer = (char*)malloc(256*sizeof(char));
	memset(buffer,0,256);
	int count =0;

	while(!feof(fp))
	{
		char c = fgetc(fp);
		if (c == 10) continue;
		if (c == 13) break;
		if (c == -1) break;
		buffer[count++] = c;
	}
	buffer[count]='\0';
	return buffer;
}


BOOL CDat::Read()
{
	if (!isPackFile())
	{
		if (!isTrkFile())
		{
        Header.numFiles	= ReadPCWord(fpHandle);

	    for(int i=0;i<Header.numFiles;i++)
		{
	    char filename[13];
	    int id      = ReadPCWord(fpHandle);
	    int length  = ReadPCDWord(fpHandle);
	    int length1 =	ReadPCDWord(fpHandle);
	    memset(filename,0,13);
	    fread(filename,13,sizeof(char),fpHandle);
	    int offset  = ReadPCDWord(fpHandle);

	     CGplFile *file;

	     file = FileNameToType(filename);
		 if (file)
		 {
	      file->setFileInfo(id,length,length1,filename,offset);
	      file->datFileParent = this;
	      files->addElement(file);
		 }
		}
		}
		else
		{
		// TRK file
		CGplFile *file;
		CString filename;
		filename.Format("%s%s",DatFile,DatExt);
		file = FileNameToType((LPSTR)(LPCSTR)filename);
		file->setFileInfo(5,0,0,(LPSTR)(LPCSTR)filename,0);
	    file->datFileParent = this;
	    files->addElement(file);
		}

	}
	else
	{
		outputfile =getline(fpHandle);
		char *line = getline(fpHandle);

		Header.numFiles = atoi(line);
		free(line);

		for(int i=0;i<Header.numFiles;i++)
		{
			char* filename = getline(fpHandle);
			CGplFile *file;
            file = FileNameToType(filename);
	        file->setFileInfo(-1,1,-1,filename,0);
	        file->datFileParent = this;
	        files->addElement(file);
			free(filename);
		}
	}
	return TRUE;
}

int GetFileLength(FILE *fp)
   {
		struct _stat buf;
        int result;
   
        /* Get data associated with "stat.c": */
        result = _fstat( fileno(fp), &buf );

        /* Check if statistics are valid: */
        return (int)(buf.st_size );
   }

int GetFileLengthStr(CString filename)
{
	FILE *fp = FOPEN(filename,"rb");
	int size = GetFileLength(fp);
	FCLOSE(fp);
	return size;
}



BOOL CDat::Write(const char *filename)
{
	FILE *fpout = FOPEN(filename,"wb");
	if (fpout == NULL)
	{
		CString msg;
		msg.Format("Cannot open %s for writing : %s",filename,strerror( errno ));
		AfxMessageBox(msg);
		return FALSE;
	}
	WritePCWord(fpout,Header.numFiles);
	int beginOffset = 2+(Header.numFiles*27);

	for(int i=0;i<Header.numFiles;i++)
	{
	  CGplFile *file = (CGplFile*)files->elementAt(i);	  
	  if (isPackFile())
	  {
		CString tmpDir;
		tmpDir.Format("%s%sTemp\\%s",DatDrive,DatDir,file->filename);
		file->id = 5;
	    file->length = file->length1 = GetFileLengthStr(tmpDir);
		file->filepos=beginOffset;
		beginOffset+=file->length;
	  }

	  WritePCWord(fpout,file->id);
	  WritePCDWord(fpout,file->length);
	  WritePCDWord(fpout,file->length1);
	  char nfilename[13];
	  memset(nfilename,0,13);
	  strcpy(nfilename,file->filename);
	  fwrite(nfilename,13,sizeof(char),fpout);
	  WritePCDWord(fpout,file->filepos);
	  fflush(fpout);
	}

	if (!isPackFile())
	{
	 for(i=0;i<Header.numFiles;i++)
	 {
	  CGplFile *file = (CGplFile*)files->elementAt(i);
	  file->UnPack(fpout);
	 }

	 for(i=0;i<Header.numFiles;i++)
	 {
	  CGplFile *file = (CGplFile*)files->elementAt(i);

	  if (file->is3do())
	  {
	    if (file->dataLoaded)
		{
			C3do *obj = (C3do*)file;
			obj->Write(fpout);
		}
	  }
	 }
	
	 C3do *file = (C3do*)GetMainTrackFile();
	 file->Write(fpout);
	 CCam *cfile = (CCam*)GetMainCameraFile();
	 cfile->Write(fpout);
	 CTrk *tfile = (CTrk*)GetMainTrkFile();
	 tfile->Write(fpout);
	}
	else
	{
		//this is a pack file so
		//save all modified files out
		//now copy all files from Temp/file to the dat file
		//adjusting the length and position as we go!
		SaveModified();
		/*
		cout << "saving files..." << endl;

		for(i=0;i<Header.numFiles;i++)
	    {
	     CGplFile *file = (CGplFile*)files->elementAt(i);
		 if (file->isModified())
		 {
			 cout << file->filename << " is Modified..Saving" << endl;
			 file->ExportToFile();
			 cout.flush();

		 }
		} 

		cout << endl;
		*/

		HCURSOR hwait = LoadCursor(NULL,IDC_WAIT);
		SetCursor(hwait);
		cout << "Building Dat File..";
		cout.flush();	
		CProgress *dlg = new CProgress();
	    dlg->UpdateProgress("Building Dat File..",0);
		for(i=0;i<Header.numFiles;i++)
	    {
	     CGplFile *file = (CGplFile*)files->elementAt(i);
		 //cout << "linking.." << file->filename << endl;
		 //cout << "." ;
		 //cout.flush();
		 dlg->UpdateProgress(file->filename,(int)(100.0*((double)i/(double)Header.numFiles)));
	     file->Copy(fpout);
	    }
		dlg->UpdateProgress("Done",100);
	    cout << "Done" << endl;
	    if (dlg) delete dlg;
		cout.flush();
	}
	FCLOSE(fpout);

	CString msg;
	msg.Format("File Saved as %s",filename);
	AfxMessageBox(msg);
	EndFiles();
	return TRUE;
}



void CDat::LoadTree(CObjectTree *tree,HTREEITEM parent)
{
	HTREEITEM mipFiles,srbFiles,pbfFiles,tdoFiles,iniFiles,wavFiles,setupFiles,mi4Files,pcxFiles;
	cerr << "Loading Tree" << endl;
	if (getNumberOfFile(t_mip))  mipFiles = tree->insertInfoNode(parent, "Mip Files",TO_ID(IDB_MIP));
	if (getNumberOfFile(t_mi4))  mi4Files = tree->insertInfoNode(parent, "Mi4 Files",TO_ID(IDB_MIP));
	if (getNumberOfFile(t_srb))  srbFiles = tree->insertInfoNode(parent, "Srb Files",TO_ID(IDB_SRB));
	if (getNumberOfFile(t_pbf))  pbfFiles = tree->insertInfoNode(parent, "Pbf Files",TO_ID(IDB_PFB));
	if (getNumberOfFile(t_pcx))  pcxFiles = tree->insertInfoNode(parent, "Pcx Files",TO_ID(IDB_PFB));
	if (getNumberOfFile(t_tdo))  tdoFiles = tree->insertInfoNode(parent, "3do Files",TO_ID(IDB_OBJECT));
	if (getNumberOfFile(t_setup)) setupFiles = tree->insertInfoNode(parent, "Setup Files",TO_ID(IDB_SETUP));
	//unkFiles = tree->insertInfoNode(parent, "Unknown Files",TO_ID(IDB_UNK));
	HTREEITEM lpFiles  = tree->insertInfoNode(parent,  "Lp Files",TO_ID(IDB_LP));
	iniFiles = tree->insertInfoNode(parent, "Ini Files",TO_ID(IDB_INI));
	if (getNumberOfFile(t_wav))  wavFiles = tree->insertInfoNode(parent, "Sound Files (Wav)",TO_ID(IDB_SND));

	int numFiles = files->size();
	for(int i=0;i<numFiles;i++)
	{
	 CGplFile *file = (CGplFile *)files->elementAt(i);
	 CString buffer;
	 buffer.Format("%s",file->filename);
	 HTREEITEM tp = parent;

	 if      (file->is3do())   tp = tdoFiles;
	 else if (file->isMip())   tp = mipFiles;
	 else if (file->isMi4())   tp = mi4Files;
	 else if (file->isSrb())   tp = srbFiles;
	 else if (file->isPbf())   tp = pbfFiles;
	 else if (file->isPcx())   tp = pcxFiles;
	 else if (file->isSetup()) tp = setupFiles;
	 else if (file->isWav())   tp = wavFiles;

	 file->FileNode = tree->insertInfoNode(tp, (LPSTR)(LPCSTR)buffer,TO_ID(FileNameToIcon((LPSTR)(LPCSTR)file->filename)));
	 tree->m_ObjectTree.SetItemData(file->FileNode,(DWORD)file);
	 try {
	 file->LoadTree(file->FileNode,tree);
	 }
	 catch (CMemoryException e)
	 {
		 AfxMessageBox("Out of Memory Exception");
	 }
	}

	LpDocument->raceLP->LoadTree(lpFiles,tree);
	LpDocument->minRaceLP->LoadTree(lpFiles,tree);
	LpDocument->maxRaceLP->LoadTree(lpFiles,tree);
	LpDocument->pass1LP->LoadTree(lpFiles,tree);
	LpDocument->pass2LP->LoadTree(lpFiles,tree);
	LpDocument->pitLP->LoadTree(lpFiles,tree);

	trackIni->LoadTree(iniFiles,tree);
	recordIni->LoadTree(iniFiles,tree);
	cerr << "Done Loading Tree" << endl;

}

FILE *CDat::GetFileHandle()
{
	return fpHandle;
}

void CDat::SetFilePosition(int fileposition)
{
	fseek(fpHandle,fileposition,SEEK_SET);
}


C3do * CDat::GetMainTrackFile()
{
		CString buffer;
		buffer.Format("%s.3do",DatFile);

		for(int i=0;i<files->size();i++)
		{
			CGplFile *file = (CGplFile*)files->elementAt(i);
			if (file && file->filename)
			{
			   if (!stricmp(file->filename,buffer)) return (C3do*)file;	
			}
		}
		return NULL;
}


CCam * CDat::GetMainCameraFile()
{
		CString buffer;
		buffer.Format("%s.cam",DatFile);

		for(int i=0;i<files->size();i++)
		{
			CGplFile *file = (CGplFile*)files->elementAt(i);
			if (file && file->filename)
			{
			   if (!stricmp(file->filename,buffer)) return (CCam*)file;	
			}
		}
		return NULL;
}

CTrk * CDat::GetMainTrkFile()
{
	    CString buffer;
		buffer.Format("%s.trk",DatFile);

		for(int i=0;i<files->size();i++)
		{
			CGplFile *file = (CGplFile*)files->elementAt(i);
			if (file && file->filename)
			{
			   if (!stricmp(file->filename,buffer)) return (CTrk*)file;	
			}
		 }
		return NULL;
}



CGplFile *CDat::FindFile(LPCSTR filename)
{
	int fsize = files->size();
	for(int i=0;i<fsize;i++)
	{
		CGplFile *file = (CGplFile*)files->elementAt(i);
		if (file && file->filename)
		{
			int pos = file->filename.Find('.');
			CString newName = file->filename.Left(pos);
			if (!stricmp(newName,filename)) 
			{
				return file;	
			}
		}
	}
	return NULL;
}


CGplFile *CDat::FindSrbImageFile(LPCSTR filename)
{
	int fsize = files->size();
	for(int i=0;i<fsize;i++)
	{
		CGplFile *file = (CGplFile*)files->elementAt(i);
		if (file && file->filename)
		{
			int pos = file->filename.Find('.');
			
			CString newName = file->filename.Left(pos);			
			if (!stricmp(newName,filename)) 
			{
				CString ext = file->filename.Right(3);
				if (!stricmp(ext,"srb")) return file;	
			}
		}
	}
	return NULL;
}


CGplFile *CDat::FindImageFile(LPCSTR filename)
{
	int fsize = files->size();
	for(int i=0;i<fsize;i++)
	{
		CGplFile *file = (CGplFile*)files->elementAt(i);
		if (file && file->filename)
		{
			int pos = file->filename.Find('.');
			
			CString newName = file->filename.Left(pos);			
			if (!stricmp(newName,filename)) 
			{
				CString ext = file->filename.Right(3);
				if (!stricmp(ext,"mip")) return file;	
			}
		}
	}
	return NULL;
}

CGplFile *CDat::FindObjectFile(LPCSTR filename)
{
	int fsize = files->size();
	for(int i=0;i<fsize;i++)
	{
		CGplFile *file = (CGplFile*)files->elementAt(i);
		if (file && file->filename)
		{
			int pos = file->filename.Find('.');
			
			CString newName = file->filename.Left(pos);			
			if (!stricmp(newName,filename)) 
			{
				CString ext = file->filename.Right(3);
				if (!stricmp(ext,"3do")) return file;	
			}
		}
	}
	return NULL;
}


void CDat::UnPackAll()
{
	CString tempDir;
	tempDir.Format("%s%sTemp",DatDrive,DatDir);
	CreateDirectory(tempDir,NULL);
	CString fbuff;
	fbuff.Format("%s\\%s.pck",tempDir,DatFile);
	FILE *fpPck = FOPEN(fbuff,"w");

	if (fpPck == NULL)
	{
		AfxMessageBox("Failed to Unpack dat file, check permissions");
		return;
	}
    int fsize = files->size();
	fprintf(fpPck,"%s.dat\n",DatFile);
	fprintf(fpPck,"%d\n",fsize);
	cout << "Unpacking.";
	CProgress *dlg = new CProgress();
	dlg->UpdateProgress("Unpacking",0);
	for(int i=0;i<fsize;i++)
	{
		//cout << "." ;
		//cout.flush();
		
		CGplFile *file = (CGplFile*)files->elementAt(i);
		if (file && file->filename)
		{
			CString buffer;
			buffer.Format("Temp\\%s",file->filename);
			dlg->UpdateProgress(buffer,(int)(100.0*((double)i/(double)fsize)));
			FILE *fpout = FOPEN(buffer,"wb");
			if (fpout)
			{
			 file->UnPack(fpout);
			 FCLOSE(fpout);
			 fprintf(fpPck,"%s\n",file->filename);
			}
			else
			{
			 cerr << "Failed to unpack file " << buffer <<endl;
			}
			
		}
	}
	FCLOSE(fpPck);
	dlg->UpdateProgress("Done",100);
	cout << "Done" << endl;
	if (dlg) delete dlg;
	return;
}

int CDat::getNumberOfFile(int ftype)
{
	int count=0;
	int fsize = files->size();

	for(int i=0;i<fsize;i++)
	{
		CGplFile *file = (CGplFile*)files->elementAt(i);
		if (file && file->filename)
		{
			if (file->objtype == ftype) count++;
		}
	}
	return count;
}

void CDat::SaveModified()
{
	    cout << "saving files..." << endl;

		for(int i=0;i<Header.numFiles;i++)
	    {
	     CGplFile *file = (CGplFile*)files->elementAt(i);
		 if (file->isModified())
		 {
			 cout << file->filename << " is Modified..Saving" << endl;
			 file->ExportToFile();
			 cout.flush();
			 file->SetModified(FALSE);
		 }
		} 

		cout << endl;
}
