
#ifndef INCLUDED_DAT_H
#define INCLUDED_DAT_H

#include "Vector.h"
#include "ObjectTree.h"
#include "LpDocument.h"

class CGplFile;
class C3do;
class CCam;
class CTrk;
class CIni;
class CLp;
class CTrackIni;


extern int openFiles;
extern char *openFile[256];

FILE * FOPEN(const char *x,char *r);
void FCLOSE(FILE *x)  ;
 




typedef struct
{
	unsigned short numFiles;
} t_Dat_Header ;




class CDat: public CObject
{
public:
	CDat()
	{
		files = new Vector("Files",__LINE__);
		trackIni = NULL;
	    recordIni = NULL;
		packFile = NULL;
	    
		LpDocument = new CLpDocument();
		outputfile=NULL;
	}

	~CDat();

	BOOL packFile;
	BOOL trkFile;

	void SetPackFile(BOOL set)
	{
		packFile = set;
	}

	void SetTrackFile(BOOL set)
	{
		trkFile	= set;
	}

	BOOL isPackFile()
	{
		return packFile;
	}

	BOOL isTrkFile()
	{
		return trkFile;
	}

	BOOL Read(const char *filename);
	BOOL Read();
	BOOL Write(const char *filename);

	BOOL Open(const char *filename)
	{
		fpHandle = FOPEN(filename,"rb");

	    if (fpHandle == NULL)
	    {
		  return FALSE;
	    }
		return TRUE;
	}

	BOOL Close()
	{
		if (fpHandle){
			FCLOSE(fpHandle);
		    return TRUE;
		}
		return FALSE;
	}

	void SaveModified();
	BOOL isPackFileName(const char *filename);
	
	FILE *GetFileHandle();
	void SetFilePosition(int fileposition);
	void LoadTree(CObjectTree *tree,HTREEITEM parent);


	C3do * GetMainTrackFile();
	CCam * GetMainCameraFile();
	CTrk * GetMainTrkFile();

	CGplFile *FindFile(LPCSTR filename);
	CGplFile *FindImageFile(LPCSTR filename);
	CGplFile *FindSrbImageFile(LPCSTR filename);
	CGplFile *FindObjectFile(LPCSTR filename);

	void UnPackAll();

	t_Dat_Header Header;
	Vector      *files;

	CLpDocument *LpDocument;
	CTrackIni *trackIni;
	CIni *recordIni;


	int getNumberOfFile(int type);

	char DatDrive[256];
	char DatDir[256];
	char DatFile[256];
	char DatExt[256];
	char *outputfile;

    private:
	FILE        *fpHandle;

	
	
	


	
};

#endif