#ifndef _DAT_DOC_INCLUDED_
#define _DAT_DOC_INCLUDED_

// DatDocument.h : header file
//
#include "Dat.h"
#include "C3do.h"
#include "Cam.h"
#include "Trk.h"

/////////////////////////////////////////////////////////////////////////////
// CDatDocument document

class CDatDocument : public CDocument
{
protected:
	CDatDocument();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDatDocument)

// Attributes
public:
	HTREEITEM FileNode;
	CDat     *datFile;

	C3do     *trackFile;
	CCam     *cameraFile;
	CTrk     *trkFile;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDatDocument)
	public:
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	protected:
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDatDocument();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CDatDocument)
	afx_msg void OnViewMiplist();
	afx_msg void OnEditUnpackall();
	afx_msg void OnFileExporttrktoexcel();
	afx_msg void OnBuild();
	afx_msg void OnFileSaveall();
	afx_msg void OnBuildSettings();
	afx_msg void OnFileExportcamtoexcel();
	afx_msg void OnEditUpdatetrack();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
