// DatView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// DatView view

#ifndef _INCLUDED_DAT_VIEW_H
#define _INCLUDED_DAT_VIEW_H

class Point3D;

class DatView : public CScrollView
{
protected:
	DatView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(DatView)

// Attributes
public:
	Display *display;
	BOOL     dragging;

	BOOL     showLines;
	BOOL     showPoints;
	BOOL     showFilled;
	BOOL     showCameras;
	BOOL     showObjects;

	BOOL     showWalls;
	BOOL     showTrackNumbers;
	BOOL     showTrk;
	BOOL     show3do;
	BOOL     showAxis;

// Operations
public:

	void UpdateScroll();
	void FindSelection(CPoint point);
	Point3D *selected;
	int  selectedIndex;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DatView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnInitialUpdate();     // first time after construct
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~DatView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(DatView)
	afx_msg void OnZoomin();
	afx_msg void OnZoomout();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnShowPoints();
	afx_msg void OnShowlines();
	afx_msg void OnUpdateShowlines(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowPoints(CCmdUI* pCmdUI);
	afx_msg void OnShowfilled();
	afx_msg void OnUpdateShowfilled(CCmdUI* pCmdUI);
	afx_msg void OnZoomhome();
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnShowobjects();
	afx_msg void OnUpdateShowobjects(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnShowwalls();
	afx_msg void OnUpdateShowwalls(CCmdUI* pCmdUI);
	afx_msg void OnShowtracknumbers();
	afx_msg void OnUpdateShowtracknumbers(CCmdUI* pCmdUI);
	afx_msg void OnShowtrack();
	afx_msg void OnUpdateShowtrack(CCmdUI* pCmdUI);
	afx_msg void OnShowthreedo();
	afx_msg void OnUpdateShowthreedo(CCmdUI* pCmdUI);
	afx_msg void OnViewLpcharts();
	afx_msg void OnShowAxis();
	afx_msg void OnUpdateShowAxis(CCmdUI* pCmdUI);
	afx_msg void OnShowcameras();
	afx_msg void OnUpdateShowcameras(CCmdUI* pCmdUI);
	afx_msg void OnEditCreate3dofromtrk();
	afx_msg void OnTablesTrackview();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
