// DistanceSwitchEdit.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "DistanceSwitchEdit.h"
#include "Node.h"
#include "EditOneFVar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDistanceSwitchEdit dialog


CDistanceSwitchEdit::CDistanceSwitchEdit(NodeEleven *node,CWnd* pParent /*=NULL*/)
	: node(node),CDialog(CDistanceSwitchEdit::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDistanceSwitchEdit)
	m_Number1 = 0;
	m_Number2 = 0;
	m_Number3 = 0;
	//}}AFX_DATA_INIT
}


void CDistanceSwitchEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDistanceSwitchEdit)
	DDX_Control(pDX, IDC_LIST1, m_Scales);
	DDX_Text(pDX, IDC_EDIT1, m_Number1);
	DDX_Text(pDX, IDC_EDIT2, m_Number2);
	DDX_Text(pDX, IDC_EDIT3, m_Number3);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDistanceSwitchEdit, CDialog)
	//{{AFX_MSG_MAP(CDistanceSwitchEdit)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDistanceSwitchEdit message handlers

void CDistanceSwitchEdit::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL CDistanceSwitchEdit::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Scales.ResetContent();
	
	m_Number1 = node->number1;
	m_Number2 = node->number2;
	m_Number3 = node->number3;

	for(int i=0;i<node->numberOfChildren;i++)
	{
		float Scaleval = node->child_scales[i];
		//int offsetVal = node->children[i]->sectionOffset;

		CString msg;
		msg.Format("[%d] = %2.4f",i,Scaleval);
		m_Scales.AddString(msg);
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDistanceSwitchEdit::OnOK() 
{
	UpdateData(TRUE);

	node->number1 = m_Number1;
	node->number2 = m_Number2;
	node->number3 = m_Number3;
	
	CDialog::OnOK();
}

void CDistanceSwitchEdit::OnDblclkList1() 
{
	int idx =m_Scales.GetCurSel();

	CEditOneFVar *dlg = new CEditOneFVar();

	dlg->m_VarVal1 = node->child_scales[idx];
	dlg->m_Var1.Format("Child Parameter");
	dlg->m_Desc.Format("The Child Parameter somehow affects the way the tree is drawn");
	
	int result = dlg->DoModal();

	if (result == IDOK)
	{
		node->child_scales[idx] = dlg->m_VarVal1;
	}

	if (dlg) delete dlg;
}
