#include "CGPLFile.h"
#include "ObjectTree.h"
#include "resource.h"

class CIni: public CGplFile
{
   public:
	CIni():CGplFile(t_ini)
	{
	}

	CString GetDefaultExtension()
	{
		return CString("ini");
	}

    virtual BOOL Read(const char *filename);
	virtual BOOL Read(FILE *fp);

	virtual void LoadTree(HTREEITEM parent,CObjectTree *tree)
	{
		CString buffer;
	    if (dataLoaded) buffer.Format("Ini File %s",filename);
		else buffer.Format("Could not load Ini File %s",filename);
		int id = dataLoaded ? IDB_FILE : IDB_FILE_ERR;
		HTREEITEM camerap = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(id));
	}


	void GetSectionString(LPCSTR section,LPCSTR topic,CString &answer)
	{
		int nsize=256;
		char buff[256];
		GetPrivateProfileString(section,topic,"NULL",buff,nsize,filename);
		answer = buff;
	}

	void Explore()
	{	
	}
};

class CTrackIni: public CIni
{
    public:

	CTrackIni()
	{
	}

	BOOL Read(const char *fname)
	{
		return CIni::Read(fname);
	}

	BOOL Read(FILE *fp)
	{
		GetSectionString("track","track_name",track_name);
		GetSectionString("track","track_name_short",track_name_short);
		GetSectionString("track","track_num_turns",track_num_turns);
		GetSectionString("track","track_length",track_length);
		GetSectionString("track","track_altitude",track_altitude);
		return TRUE;
	}

    void AddNode(HTREEITEM parent,CObjectTree *tree,CString fmt,CString var)
	{
	    CString buffer;
		buffer.Format(fmt,var);
		tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
	}

	void LoadTree(HTREEITEM parent,CObjectTree *tree)
	{
		CString buffer;
	    if (dataLoaded) buffer.Format("Ini File %s",filename);
		else buffer.Format("Could not load Ini File %s",filename);
		int id = dataLoaded ? IDB_FILE : IDB_FILE_ERR;
		HTREEITEM inip = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(id));

		if (dataLoaded)
		{
			buffer.Format("Track");
			HTREEITEM trp = tree->insertInfoNode(inip, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_FILE));
			  AddNode(trp,tree,"Track_Name=%s",track_name);
			  AddNode(trp,tree,"Track_Name_Short=%s",track_name_short);
			  AddNode(trp,tree,"Track_Number_Turns=%s",track_num_turns);
			  AddNode(trp,tree,"Track_Length=%s",track_length);
			  AddNode(trp,tree,"Track_Altitude=%s",track_altitude);	
		}
	}

	CString track_name;
	CString track_name_short;
	CString track_num_turns;
	CString track_length;
	CString track_altitude;
};

