// LpView.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "LpView.h"
#include "LpDocument.h"
#include "lp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLpView

IMPLEMENT_DYNCREATE(CLpView, CScrollView)

CLpView::CLpView()
{
	red = new CPen(PS_SOLID,1,RGB(0xFF,0,0));
	blue = new CPen(PS_SOLID,1,RGB(0,0,0xFF));
	green = new CPen(PS_SOLID,1,RGB(0,0xFF,0));
	magenta = new CPen(PS_SOLID,1,RGB(0xFF,0,0xFF));

	showRace = TRUE;
	showMinRace = FALSE;
	showMaxRace = FALSE;
	showPit= FALSE;
	showPass1= FALSE;
	showPass2= FALSE;

	showD1= TRUE;
	showD2= TRUE;
	showD3= TRUE;
	showD4= TRUE;
	showD5= TRUE;
}

CLpView::~CLpView()
{
	delete red;
	delete blue;
	delete green;
	delete magenta;

}


BEGIN_MESSAGE_MAP(CLpView, CScrollView)
	//{{AFX_MSG_MAP(CLpView)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWRACE, OnViewViewlpoptionsShowrace)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWRACE, OnUpdateViewViewlpoptionsShowrace)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWPIT, OnViewViewlpoptionsShowpit)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWPIT, OnUpdateViewViewlpoptionsShowpit)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWPASS2, OnViewViewlpoptionsShowpass2)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWPASS2, OnUpdateViewViewlpoptionsShowpass2)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWPASS1, OnViewViewlpoptionsShowpass1)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWPASS1, OnUpdateViewViewlpoptionsShowpass1)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWMIN, OnViewViewlpoptionsShowmin)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWMIN, OnUpdateViewViewlpoptionsShowmin)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWMAXRACE, OnViewViewlpoptionsShowmaxrace)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWMAXRACE, OnUpdateViewViewlpoptionsShowmaxrace)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWDATA5, OnViewViewlpoptionsShowdata5)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWDATA5, OnUpdateViewViewlpoptionsShowdata5)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWDATA4, OnViewViewlpoptionsShowdata4)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWDATA4, OnUpdateViewViewlpoptionsShowdata4)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWDATA3, OnViewViewlpoptionsShowdata3)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWDATA3, OnUpdateViewViewlpoptionsShowdata3)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWDATA2, OnViewViewlpoptionsShowdata2)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWDATA2, OnUpdateViewViewlpoptionsShowdata2)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWDATA1, OnViewViewlpoptionsShowdata1)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWLPOPTIONS_SHOWDATA1, OnUpdateViewViewlpoptionsShowdata1)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_SHOWALLDATA, OnViewViewlpoptionsShowalldata)
	ON_COMMAND(ID_VIEW_VIEWLPOPTIONS_HIDEALLDATA, OnViewViewlpoptionsHidealldata)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLpView drawing

void CLpView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 1000;
	CDocument* pDoc = GetDocument();
	CLpDocument *pLPDoc = (CLpDocument*)pDoc;

	if (pLPDoc)
	{
	  if (pLPDoc->raceLP)
	  {
	  int num = pLPDoc->raceLP->numberOfRecords;
	  sizeTotal.cx = num;
	  }
	  else
	  {
	  sizeTotal.cx = 1000;
	  }
	}
	
	sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CLpView::DrawLP(CDC *pDC,CLp *lp)
{
	if (lp==NULL) return;

	CRect client;

	GetClientRect(&client);

	int midy = client.top + client.bottom/2;
	pDC->SelectStockObject(ANSI_VAR_FONT);
	pDC->SetBkMode(TRANSPARENT);
	pDC->MoveTo(client.left,midy);
	pDC->LineTo(client.left+lp->numberOfRecords,midy);

	pDC->SelectObject(red);
	pDC->MoveTo(client.left+10,10);
	pDC->LineTo(client.left+30,10);
	pDC->TextOut(client.left+34,7,"Speed");

	pDC->SelectObject(green);
	pDC->MoveTo(client.left+10,30);
	pDC->LineTo(client.left+30,30);
	pDC->TextOut(client.left+34,27,"Position?");

	for(int i=0;i<lp->numberOfRecords;i++)
	{
		if (showD1)
		{
		pDC->SelectObject(red);
		float data1 = lp->records[i].d1;
		data1 *= 50;
		if (i==0 ) pDC->MoveTo(client.left+i,(int)(midy+data1));
		else pDC->LineTo(client.left+i,(int)(midy-data1));
		}
	}

	for( i=0;i<lp->numberOfRecords;i++)
	{
		if (showD2)
		{
		pDC->SelectObject(blue);
		float data2 = lp->records[i].d2;
		data2 *= 500;
		if (i==0 ) pDC->MoveTo(client.left+i,(int)(midy+data2));
		else pDC->LineTo(client.left+i,(int)(midy-data2));
		}
	}

	for( i=0;i<lp->numberOfRecords;i++)
	{
		if (showD3)
		{
		pDC->SelectObject(green);
		float data3 = lp->records[i].d3;
		data3 *= 20;
		if (i==0 ) pDC->MoveTo(client.left+i,(int)(midy+data3));
		else pDC->LineTo(client.left+i,(int)(midy-data3));
		}
	}

	for( i=0;i<lp->numberOfRecords;i++)
	{
		if (showD4)
		{
		pDC->SelectObject(magenta);
		float data4 = lp->records[i].d4;
		data4 *= 1000;
		if (i==0 ) pDC->MoveTo(client.left+i,(int)(midy+data4));
		else pDC->LineTo(client.left+i,(int)(midy-data4));
		}
	}

	for( i=0;i<lp->numberOfRecords;i++)
	{
		if (showD5)
		{
		pDC->SelectObject(magenta);
		int data5 = lp->records[i].d5;
		data5 *= 50;
		if (i==0 ) pDC->MoveTo(client.left+i,midy+data5);
		else pDC->LineTo(client.left+i,midy-data5);
		}
	}
}

void CLpView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
	CRect client;
	CLpDocument *pLPDoc = (CLpDocument*)pDoc;

	GetClientRect(&client);

	int midy = client.top + client.bottom/2;

	pDC->MoveTo(client.left,midy);
	pDC->LineTo(client.right,midy);


	pDC->SelectStockObject(NULL_BRUSH);

	if (showRace) DrawLP(pDC,pLPDoc->raceLP);
	if (showPass1) DrawLP(pDC,pLPDoc->pass1LP);
	if (showPass2) DrawLP(pDC,pLPDoc->pass2LP);
	if (showMinRace) DrawLP(pDC,pLPDoc->minRaceLP);
	if (showMaxRace) DrawLP(pDC,pLPDoc->maxRaceLP);
	if (showPit)  DrawLP(pDC,pLPDoc->pitLP);
	pDC->SelectStockObject(BLACK_PEN);


}

/////////////////////////////////////////////////////////////////////////////
// CLpView diagnostics

#ifdef _DEBUG
void CLpView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CLpView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLpView message handlers

void CLpView::OnViewViewlpoptionsShowrace() 
{
	showRace = !showRace;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowrace(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showRace);
}

void CLpView::OnViewViewlpoptionsShowpit() 
{
	showPit = !showPit;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowpit(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showPit);
}

void CLpView::OnViewViewlpoptionsShowpass2() 
{
	showPass2 = !showPass2;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowpass2(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showPass2);
}

void CLpView::OnViewViewlpoptionsShowpass1() 
{
	showPass1 = !showPass1;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowpass1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showPass1);
}

void CLpView::OnViewViewlpoptionsShowmin() 
{
	showMinRace = !showMinRace;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowmin(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showMinRace);
}

void CLpView::OnViewViewlpoptionsShowmaxrace() 
{
	showMaxRace = !showMaxRace;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowmaxrace(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showMaxRace);
}

void CLpView::OnViewViewlpoptionsShowdata5() 
{
	showD5 = !showD5;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowdata5(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showD5);
}

void CLpView::OnViewViewlpoptionsShowdata4() 
{
	showD4 = !showD4;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowdata4(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showD4);
}

void CLpView::OnViewViewlpoptionsShowdata3() 
{
	showD3 = !showD3;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowdata3(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showD3);
}

void CLpView::OnViewViewlpoptionsShowdata2() 
{
	showD2 = !showD2;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowdata2(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showD2);
}

void CLpView::OnViewViewlpoptionsShowdata1() 
{
	showD1 = !showD1;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnUpdateViewViewlpoptionsShowdata1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(showD1);
}

void CLpView::OnViewViewlpoptionsShowalldata() 
{
	showD1 = TRUE;
	showD2 = TRUE;
	showD3 = TRUE;
	showD4 = TRUE;
	showD5 = TRUE;
	InvalidateRect(NULL,TRUE);
}

void CLpView::OnViewViewlpoptionsHidealldata() 
{
	showD1 = FALSE;
	showD2 = FALSE;
	showD3 = FALSE;
	showD4 = FALSE;
	showD5 = FALSE;
	InvalidateRect(NULL,TRUE);
}
