// MipList.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "MipList.h"
#include "CGPLFile.h"
#include "CMip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMipList dialog


CMipList::CMipList(CDat *datFile,CWnd* pParent /*=NULL*/)
	: CDialog(CMipList::IDD, pParent),datFile(datFile)
{
	//{{AFX_DATA_INIT(CMipList)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMipList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMipList)
	DDX_Control(pDX, IDC_PREVIEW, m_Preview);
	DDX_Control(pDX, IDC_MIPS, m_MipList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMipList, CDialog)
	//{{AFX_MSG_MAP(CMipList)
	ON_WM_DRAWITEM()
	ON_LBN_SELCHANGE(IDC_MIPS, OnSelchangeMips)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMipList message handlers

void CMipList::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if (nIDCtl == IDC_PREVIEW)
	{
		int selectedItem = m_MipList.GetCurSel();
		
		CBitmap bmp,*poldbmp;
	    CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
        CRect rcItem(lpDrawItemStruct->rcItem);
        
        // Save dc state
        int nSavedDC = pDC->SaveDC();
		
		pDC->FillRect(rcItem, &CBrush(::GetSysColor(COLOR_WINDOW)));
		pDC->SetBkColor(::GetSysColor(COLOR_WINDOW));

		if (selectedItem == LB_ERR) return;
		CMip *file = (CMip*)m_MipList.GetItemData(selectedItem);

		if (!file->dataLoaded) 
			file->GetFile();

		CDC memdc;
	   
        // Create a compatible memory DC
        memdc.CreateCompatibleDC( pDC );
 
	     // Select the bitmap into the DC
        
		if (file)
		{
		int nWidth = file->bitmapData.ImageWidth();
	    int nHeight= file->bitmapData.ImageHeight();
	    file->bitmapData.CreateDIB(bmp);
		poldbmp    = memdc.SelectObject(&bmp);
		pDC->StretchBlt( 0,0, (int)nWidth, (int)nHeight, &memdc, 0,0 ,nWidth, nHeight,SRCCOPY );
	    memdc.SelectObject( &poldbmp );
		
		}
		else
		{
		pDC->TextOut(10,10,"Cannot Load Mip File");
		}

		// Restore dc
        pDC->RestoreDC( nSavedDC );
	}
	//CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

BOOL CMipList::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for(int i=0;i<datFile->files->size();i++)
	 {
		 CGplFile *file = (CGplFile *)datFile->files->elementAt(i);
		 if (file->objtype == t_mip)
		 {
		 int idx = m_MipList.AddString(file->filename);
		 m_MipList.SetItemData(idx,(DWORD)(CMip*)file);
		 }
	 }
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMipList::OnSelchangeMips() 
{
	m_Preview.InvalidateRect(NULL,FALSE);
}
