// MipPreview.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "MipPreview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMipPreview dialog


CMipPreview::CMipPreview(CWnd* pParent /*=NULL*/)
	: CDialog(CMipPreview::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMipPreview)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	scale = 1.0;
}


void CMipPreview::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMipPreview)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMipPreview, CDialog)
	//{{AFX_MSG_MAP(CMipPreview)
	ON_WM_DRAWITEM()
	ON_BN_CLICKED(IDC_MINUS, OnMinus)
	ON_BN_CLICKED(IDCPLUS, OnCplus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMipPreview message handlers

void CMipPreview::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if (nIDCtl == IDC_PREVIEW)
	{
		CBitmap *poldbmp;
	    CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
        CRect rcItem(lpDrawItemStruct->rcItem);
        
        // Save dc state
        int nSavedDC = pDC->SaveDC();
		
		pDC->FillRect(rcItem, &CBrush(::GetSysColor(COLOR_WINDOW)));
		pDC->SetBkColor(::GetSysColor(COLOR_WINDOW));

		CDC memdc;
	   
        // Create a compatible memory DC
        memdc.CreateCompatibleDC( pDC );
 
	     // Select the bitmap into the DC
        poldbmp = memdc.SelectObject(&bmp);

		double newWidth = scale*nWidth;
		double newHeight = scale*nHeight;

	    pDC->StretchBlt( 0,0, (int)newWidth, (int)newHeight, &memdc, 0,0 ,nWidth, nHeight,SRCCOPY );
	    memdc.SelectObject( &poldbmp );
		// Restore dc
        pDC->RestoreDC( nSavedDC );
	}
	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

BOOL CMipPreview::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMipPreview::OnMinus() 
{
	scale = scale * 0.8;
	GetDlgItem(IDC_PREVIEW)->InvalidateRect(NULL,TRUE);
}

void CMipPreview::OnCplus() 
{
	scale = scale * 1.2;
	GetDlgItem(IDC_PREVIEW)->InvalidateRect(NULL,TRUE);
}
