
#include "stdafx.h"
#include "Node.h"

#include "DatView.h"
#include "3DOEditorView.h"

#include "CMip.h"
#include "CSrb.h"
#include "MipError.h"
#include "NodeRepository.h"
#include "EditObjPos.h"
#include "math.h"



#include "EditTwoVar.h"
#include "EditOneVar.h"
#include "DistanceSwitchEdit.h"

#include <gl\glaux.h>
#include <gl\gl.h>
#include <gl\glu.h>

extern void setGLColor(float r,float g,float b);

// 1 Meter = 39.37000
// therefore 1/500 of an inch
// 39.3700 * 500 =
// 19685 per meter

#define TO_METERS(x) ((x)/19685.0f)



int Node::getTextureStringOffset()
{
	Node *textureSelection = getParent();
	BOOL isN2 = getObject()->isN2Version();

	if (isN2)
	{
	 while(textureSelection)
	 {
	   if (textureSelection->type == 5)
	   {
	     NodeSelection *sel = (NodeSelection*)textureSelection;
		 if (sel->mode == 1)
		 {
			return sel->string_offset;
		 }
		 else if (sel->mode == 5)
		 {
		    return sel->string_offset;
		 }		 
	   }
	   textureSelection = textureSelection->getParent();	   
	 }
	}
	else
	{
	 while(textureSelection && textureSelection->type!=5)
	 {
	   textureSelection = textureSelection->getParent();
	 }
	}

	if (textureSelection)
	  return ((Node*)textureSelection)->string_offset;
	
	return -1;
}

static int Code2Count = 0;
static int Code3Count = 0;
static int Code4Count = 0;
static int Code5Count = 0;
static int Code5_1Count = 0;
static int Code5_4Count = 0;
static int Code5_5Count = 0;
static int Code5_8Count = 0;
static int Code5_cCount = 0;
static int Code5_dCount = 0;
static int Code5_11Count = 0;
static int Code5_20Count = 0;
static int Code5_24Count = 0;
static int Code5_2cCount = 0;
static int Code6Count = 0;
static int Code7Count = 0;
static int Code8Count = 0;
static int Code9Count = 0;
static int CodeACount = 0;
static int CodeBCount = 0;
static int CodeCCount = 0;
static int CodeDCount = 0;
static int CodeECount = 0;
static int CodeFCount = 0;
static int Code10Count = 0;
static int Code11Count = 0;
static int Code13Count = 0;
static int Code16Count = 0;
static int Code17Count = 0;
static int Code19Count = 0;
static int Code20Count = 0;
static int Code14Count = 0;
static int Code1CCount = 0;
static int Code1FCount = 0;
static int Code21Count = 0;
static int Code821Count = 0;
static int Code815Count = 0;
static int Code81bCount = 0;
static int Code81cCount = 0;
static int Code81dCount = 0;
static int Code81eCount = 0;
static int Code81fCount = 0;
static int Code820Count = 0;
static int CodeA03Count = 0;

static int Code8001Count = 0;
static int Code8002Count = 0;
static int Code8003Count = 0;
static int Code8004Count = 0;
static int Code8005Count = 0;
static int Code8006Count = 0;
static int Code8007Count = 0;
static int Code8008Count = 0;
static int Code8009Count = 0;
static int Code800ACount = 0;
static int Code800BCount = 0;
static int Code800CCount = 0;
static int Code800DCount = 0;
static int Code800ECount = 0;
static int Code800FCount = 0;
static int Code8010Count = 0;
static int Code8012Count = 0;

void resettotals()
{
	Code2Count = 0;
    Code3Count = 0;
    Code4Count = 0;
    Code5Count = 0;
	Code5_1Count = 0;
	Code5_4Count = 0;
	Code5_5Count = 0;
	Code5_8Count = 0;
	Code5_cCount = 0;
	Code5_dCount = 0;
	Code5_11Count = 0;
	Code5_20Count = 0;
	Code5_24Count = 0;
	Code5_2cCount = 0;
    Code6Count = 0;
    Code7Count = 0;
    Code8Count = 0;
    Code9Count = 0;
    CodeACount = 0;
    CodeBCount = 0;
    CodeCCount = 0;
    CodeDCount = 0;
    CodeECount = 0;
    CodeFCount = 0;
    Code10Count = 0;
    Code11Count = 0;
    Code13Count = 0;
    Code16Count = 0;
     Code17Count = 0;
     Code19Count = 0;
     Code20Count = 0;
     Code14Count = 0;
	 Code1CCount = 0;
     Code1FCount = 0;
     Code21Count = 0;
     Code821Count = 0;
     Code815Count = 0;
     Code81bCount = 0;
     Code81cCount = 0;
     Code81dCount = 0;
     Code81eCount = 0;
     Code81fCount = 0;
     Code820Count = 0;
	 CodeA03Count = 0;

	 Code8001Count = 0;
	 Code8002Count = 0;
	 Code8003Count = 0;
	 Code8004Count = 0;
	 Code8005Count = 0;
	 Code8006Count = 0;
	 Code8007Count = 0;
	 Code8008Count = 0;
	 Code8009Count = 0;
	 Code800ACount = 0;
	 Code800BCount = 0;
	 Code800CCount = 0;
	 Code800DCount = 0;
	 Code800ECount = 0;
	 Code800FCount = 0;
	 Code8010Count = 0;
	 Code8012Count = 0;
}

void totals()
{
	if (Code3Count) cout << "Code 3 " << Code3Count << endl;
	if (Code4Count) cout << "Code 4 " << Code4Count << endl;
	if (Code5Count) cout << "Code 5 " << Code5Count << endl;
	if (Code5_1Count) cout << "Code 5 sub 1 " << Code5_1Count << endl;
	if (Code5_4Count) cout << "Code 5 sub 4 "  << Code5_4Count << endl;
	if (Code5_5Count) cout << "Code 5 sub 5 " << Code5_5Count << endl;
	if (Code5_8Count) cout << "Code 5 sub 8 " << Code5_8Count << endl;
	if (Code5_11Count) cout << "Code 5 sub 11 " << Code5_11Count << endl;
	if (Code5_cCount) cout << "Code 5 sub c " << Code5_cCount << endl;
	if (Code5_dCount) cout << "Code 5 sub d " << Code5_dCount << endl;
	if (Code5_20Count) cout << "Code 5 sub 20 " << Code5_20Count << endl;
	if (Code5_24Count) cout << "Code 5 sub 24 " << Code5_24Count << endl;
	if (Code5_2cCount) cout << "Code 5 sub 2c " << Code5_2cCount << endl;

	if (Code6Count) cout << "Code 6 " << Code6Count << endl;
	if (Code7Count) cout << "Code 7 " << Code7Count << endl;
	if (Code8Count) cout << "Code 8 " << Code8Count << endl;
	if (Code9Count) cout << "Code 9 " << Code9Count << endl;
	if (CodeACount) cout << "Code A " << CodeACount << endl;
	if (CodeBCount) cout << "Code B " << CodeBCount << endl;
	if (CodeCCount) cout << "Code C " << CodeCCount << endl;
	if (CodeDCount) cout << "Code D " << CodeDCount << endl;
	if (CodeECount) cout << "Code E " << CodeECount << endl;
	if (CodeFCount) cout << "Code F " << CodeFCount << endl;
	if (Code10Count) cout << "Code 10 " << Code10Count << endl;
	if (Code11Count) cout << "Code 11 " << Code11Count << endl;
	//cout << "Code 12 " << Code12Count << endl;
	if (Code13Count) cout << "Code 13 " << Code13Count << endl;
	if (Code14Count) cout << "Code 14 " << Code14Count << endl;
	//cout << "Code 15 " << Code15Count << endl;
	if (Code16Count) cout << "Code 16 " << Code16Count << endl;
	if (Code17Count) cout << "Code 17 " << Code17Count << endl;
	//cout << "Code 18 " << Code18Count << endl;
	if (Code19Count) cout << "Code 19 " << Code19Count << endl;
	if (Code1CCount) cout << "Code 1C " << Code1CCount << endl;
	
	if (Code1FCount) cout << "Code 1f " << Code1FCount << endl;
	if (Code20Count) cout << "Code 20 " << Code20Count << endl;
	if (Code21Count) cout << "Code 21 " << Code21Count << endl;
	if (Code815Count) cout << "Code 815 " << Code815Count << endl;
	if (Code81bCount) cout << "Code 81b " << Code81bCount << endl;
	if (Code81cCount) cout << "Code 81c " << Code81cCount << endl;
	if (Code81dCount) cout << "Code 81d " << Code81dCount << endl;
	if (Code81eCount) cout << "Code 81e " << Code81eCount << endl;
	if (Code81fCount) cout << "Code 81f " << Code81fCount << endl;
	if (Code820Count) cout << "Code 820 " << Code820Count << endl;
	if (Code821Count) cout << "Code 821 " << Code821Count << endl;
	if (CodeA03Count) cout << "Code A03 " << CodeA03Count << endl;


	if (Code8001Count) cout << "ICR2/N1 Code 8001 " << Code8001Count << endl;
	if (Code8002Count) cout << "ICR2/N1 Code 8002 " << Code8002Count << endl;
	if (Code8003Count) cout << "ICR2/N1 Code 8003 " << Code8003Count << endl;
	if (Code8004Count) cout << "ICR2/N1 Code 8004 " << Code8004Count << endl;
	if (Code8005Count) cout << "ICR2/N1 Code 8005 " << Code8005Count << endl;
	if (Code8006Count) cout << "ICR2/N1 Code 8006 " << Code8006Count << endl;
	if (Code8007Count) cout << "ICR2/N1 Code 8007 " << Code8007Count << endl;
	if (Code8008Count) cout << "ICR2/N1 Code 8008 " << Code8008Count << endl;
	if (Code8009Count) cout << "ICR2/N1 Code 8009 " << Code8009Count << endl;
	if (Code800ACount) cout << "ICR2/N1 Code 800A " << Code800ACount << endl;
	if (Code800BCount) cout << "ICR2/N1 Code 800B " << Code800BCount << endl;
	if (Code800CCount) cout << "ICR2/N1 Code 800C " << Code800CCount << endl;
	if (Code800DCount) cout << "ICR2/N1 Code 800D " << Code800DCount << endl;
	if (Code800ECount) cout << "ICR2/N1 Code 800E " << Code800ECount << endl;
	if (Code800FCount) cout << "ICR2/N1 Code 800F " << Code800FCount << endl;
	if (Code8010Count) cout << "ICR2/N1 Code 8010 " << Code8010Count << endl;
	if (Code8012Count) cout << "ICR2/N1 Code 8012 " << Code8012Count << endl;
	
	
}


Node * getChildNode(int cmdval,int sectionOffset,Node *parent,FILE *fp,C3do *obj)
{
	switch(cmdval)
	{
	   case 0x2:  Code2Count++;return new NodePolygonN2_FL2(sectionOffset,parent);
	   case 0x3:  Code3Count++;return new NodeSrb(sectionOffset,parent);
	   case 0x04: Code4Count++;return new NodeFour(sectionOffset,parent);
	   case 0x06: Code6Count++;return new NodeSix(sectionOffset,parent);	   
	   case 0x07: Code7Count++;return new NodeSeven(sectionOffset,parent);
	   case 0x08: Code8Count++;return new NodeEight(sectionOffset,parent);		   
	   case 0x09: Code9Count++;return new NodeNine(sectionOffset,parent);	   
	   case 0x0A: CodeACount++;return new NodeA(sectionOffset,parent);
	   case 0x0B: CodeBCount++;return new NodeB(sectionOffset,parent);
	   case 0x0C: CodeCCount++;return new NodeC(sectionOffset,parent);
	   case 0x0D: CodeDCount++;return new NodeD(sectionOffset,parent);
	   case 0x0E: CodeECount++;return new Node3doObject(sectionOffset,parent);
	   case 0x0F: CodeFCount++;return new NodeFifteen(sectionOffset,parent);		
	   case 0x10: Code10Count++;return new NodeTen(sectionOffset,parent);
	   case 0x11: Code11Count++;return new NodeEleven(sectionOffset,parent);
	   case 0x13: Code13Count++;return new Node3doObjectPosition(sectionOffset,parent);
	   //case 0x14: return new UnknownNode(0x14,sectionOffset,parent);
	   case 0x15: Code815Count++;return new NodeLine815(sectionOffset,parent);
	   case 0x16: Code16Count++;return new NodeSixteen(sectionOffset,parent);
	   case 0x17: Code17Count++;return new NodeSeventeen(sectionOffset,parent);
	   
	   case 0x19: Code19Count++;return new NodeNineteen(sectionOffset,parent);	   
	   case 0x1c: Code1CCount++;return new NodePolygonFlat1c(sectionOffset,parent);	   
	   case 0x20: Code20Count++;return new NodePolygonTexture20(sectionOffset,parent);
	   case 0x14: Code14Count++;return new NodeFourteen(sectionOffset,parent);

	   case 0x1F: Code1FCount++;return new NodePolygonTexture1f(sectionOffset,parent);
	   case 0x21: Code21Count++;return new NodePolygonTexture21(sectionOffset,parent);
	   case 0x821:Code820Count++;return new NodePolygonTexture821(sectionOffset,parent);


	   case 0x815:Code815Count++;return new NodeLine815(sectionOffset,parent);
	   case 0x81b:Code81bCount++;return new NodePolygonFlat81b(sectionOffset,parent,0x81b);
	   case 0x81c:Code81cCount++;return new NodePolygonFlat81c(sectionOffset,parent);
	   case 0x81d:Code81dCount++;return new NodePolygonFlat81d(sectionOffset,parent);
	   case 0x81e:Code81eCount++;return new NodePolygonFlat81e(sectionOffset,parent);
	   case 0x81f:Code81fCount++;return new NodePolygonTexture81f(sectionOffset,parent,0x81f);
	   case 0x820:Code820Count++;return new NodePolygonTexture820(sectionOffset,parent);

	   case 0x80000001:Code8001Count++;return new NodePolygonOneICR2(sectionOffset,parent,0x80000001);
	   case 0x80000002:Code8002Count++;return new NodePolygonTwoICR2(sectionOffset,parent,0x80000002);		   
	   //case 0x80000003:Code8003Count++;return new NodeThreeICR2(sectionOffset,parent);
	   case 0x80000004:Code8004Count++;return new NodeFourICR2(sectionOffset,parent);
	   case 0x80000005:Code8005Count++;return new NodeFiveICR2(sectionOffset,parent);	   
	   case 0x80000006:Code8006Count++;return new NodeSixICR2(sectionOffset,parent);
	   case 0x80000007:Code8007Count++;return new NodeSevenICR2(sectionOffset,parent);
	   case 0x80000008:Code8008Count++;return new NodeEightICR2(sectionOffset,parent);
	   case 0x80000009:Code8009Count++;return new NodeNineICR2(sectionOffset,parent);
	   case 0x8000000a:Code800ACount++;return new NodeAICR2(sectionOffset,parent);		   		   
	   case 0x8000000b:Code800BCount++;return new NodeBICR2(sectionOffset,parent);
	   case 0x8000000c:Code800CCount++;return new NodeCICR2(sectionOffset,parent);
	   case 0x8000000d:Code800DCount++;return new NodeDICR2(sectionOffset,parent);	
	   //case 0x8000000e:Code800ECount++;return new NodeEICR2(sectionOffset,parent);
	   case 0x8000000f:Code800FCount++;return new NodeFifteenICR2(sectionOffset,parent);
	   case 0x80000010:Code8010Count++;return new NodeTenICR2(sectionOffset,parent);
	   case 0x80000012:Code8012Count++;return new NodeTwelveICR2(sectionOffset,parent);
		   
	   

	   case 0xa03: CodeA03Count++; return new NodeA03(sectionOffset,parent);
	   //case 0xa03: return new NodeNine(sectionOffset,parent,0xA);
	   case 0x5:
		   {
		   Code5Count++;
		   int offset = ReadPCDWord(fp);
		   int subcommand = ReadPCDWord(fp);
		   switch(subcommand)
		   {
 		      case 0x1: 
 		          Code5_1Count++; return new NodeSelection1(sectionOffset,parent,offset);			  
		      case 0x4: 
 		         Code5_4Count++; return new NodeSelection4(sectionOffset,parent,offset);
			  case 0x5: 
 		         Code5_5Count++;return new NodeSelection5(sectionOffset,parent,offset);
			  case 0x08: 
				 Code5_8Count++;return new NodeSelection8(sectionOffset,parent,offset);
			  case 0x20: 
			     Code5_20Count++;return new NodeSelection20(sectionOffset,parent,offset);
			  case 0x24: 
				 Code5_24Count++;return new NodeSelection24(sectionOffset,parent,offset);
			  case 0x2c: 
				 Code5_2cCount++;return new NodeSelection2c(sectionOffset,parent,offset);
			  case 0x0c: 
			     Code5_cCount++;return new NodeSelection0c(sectionOffset,parent,offset);
			  case 0x0d: 
			     Code5_dCount++;return new NodeSelection0d(sectionOffset,parent,offset);
			 case 0x11:
				 Code5_11Count++;return new NodeSelection17(sectionOffset,parent,offset);
		      default:
				  CString msg;
				  msg.Format("Unknown (5) Sub Command %x (%d)",subcommand,subcommand);
				  AfxMessageBox(msg);
				  break;
		   }
		   break;
		   }
		case 0x501: 
 		         return new NodeSelection1(sectionOffset,parent,0);			  
		case 0x504: 
 		         return new NodeSelection4(sectionOffset,parent,0);
		case 0x505: 
 		         return new NodeSelection5(sectionOffset,parent,0);
		//case 0x508: 
		//		 return new UnknownNode(0x0508,sectionOffset,parent);
		//case 0x524: 
		//		 return new UnknownNode(0x0524,sectionOffset,parent);
		//case 0x52c: 
		//		 return new UnknownNode(0x052c,sectionOffset,parent);
		//case 0x50c: 
		//		 return new UnknownNode(0x050c,sectionOffset,parent);
		//case 0x511:
		//		 return new NodeSelection17(sectionOffset,parent,0);
	   default:
		   CString msg;
		   int foff = ftell(fp);
		   msg.Format("Unknown Command %x %x (Dec=%d)",foff,cmdval,cmdval);
		   cerr << msg << endl;
		   //xMessageBox(msg);
		   throw new C3doErrorException(msg);
		   break;
	}
	return NULL;
}

Node * getChildType(int sectionOffset,Node *parent,FILE *fp,C3do *object)
{
	int foff = ftell(fp);
	//int foff = object->trackBufferPos;
	Node *Oldptr;
	if (parent)
	{
	  Oldptr = parent->getObject()->theNodeRepository.FindNode(foff);
	}
	else
	{
	  Oldptr = object->theNodeRepository.FindNode(foff);
	}

	if (Oldptr == NULL)
	{
	 int cmdval = 0;
	 
	 if (parent)
	    cmdval = parent->getCommandVal(fp);
	 else
		cmdval = Node::getCommandValObj(fp,object);

	 Node *ptr = getChildNode(cmdval,sectionOffset,parent,fp,object);
	 
	 if (ptr)
	 {
	   if (parent) {
		 ptr->object = parent->object;
	   }
	   else
	   {
		 ptr->object = object;
	   }

	   ptr->nodeOffset = foff-ptr->getOffset();

	   if (parent)
	   {
	     object->theNodeRepository.addNode(ptr,foff);
	   }
	   else
	   {
		 object->theNodeRepository.addNode(ptr,foff);
	   }
	   ptr->Read(fp);
	 }
	 return ptr;
	}
	else
	{	  
	  //Node *ptr = parent->getObject()->theNodeRepository.GetNode(idx);	  
	  //ptr->refCount++;
	  Oldptr->refCount++; 
	  return Oldptr;
	}
}




// replace existing node with new node
BOOL Node::ReplaceNode(Node *in,Node *replace)
{
	//find the children[i] that point to in
	Node *mother = in->getParent();

	for(int i=0;i<mother->size();i++)
	{
		if (mother->children[i] == in)
		{
			//found my child
			//delete mother->children[i];
			mother->children[i] = replace;
			return TRUE;
		}
	}
	CString msg;
	msg.Format("Failed to replace node could not location (%s)",in->toString());
	AfxMessageBox(msg);
	return FALSE;
}











void Node::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
   {
	   //if (drawn) return;
	   if (depth == -1) depth = GetDepth();
	   if (depth < 50)
	   {
	    for(int i=0;i<numberOfChildren;i++)
	    {
		   if (children && children[i])
		   {			   
			   children[i]->DrawGL(hdc,object,doview,currentTexture);
			   //children[i]->drawn = TRUE;
		   }
	    }
	   }
   }

void NodeNine::Read(FILE *fp)
   {
		C3do *obj = getObject();
		//obj->trackBufferPos = ftell(fp);
	    numberOfChildren = 0;
		if (object->getVersion() == t_N2)
	    {
		 number1        = ReadPCDWord(fp);
		 number2        = ReadPCDWord(fp);
		 number3        = ReadPCDWord(fp);
		 number4        = ReadPCDWord(fp);
		 number5        = ReadPCDWord(fp);
		}
		else
		{
	     number1        = ReadPCDWord(fp);
		}
		offset1        = ReadPCDWord(fp);
		offset2        = ReadPCDWord(fp);
        offset3        = ReadPCDWord(fp);
		
		numberOfChildren = 3;
	    children = (Node**)malloc(3*sizeof(Node*));
		
		//int count=0;
		int toff = ftell(fp);
		//int toff = obj->trackBufferPos;
	   	if (offset1 != -1)
		{
		 fseek(fp,getOffset()+offset1,SEEK_SET);
		 //obj->trackBufferPos = getOffset()+offset1;
	     children[0]       = getChildType(sectionOffset,this,fp,obj);
		 //if (children[0]) children[0]->Read(fp);
		}
		else
		{
		  children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 != -1)
		{
		 fseek(fp,getOffset()+offset2,SEEK_SET);
		 //obj->trackBufferPos = getOffset()+offset2;
	     children[1]       = getChildType(sectionOffset,this,fp,obj);
		 //if (children[1]) children[1]->Read(fp);
		}
		else
		{
		  children[1] = new EmptyNode(sectionOffset,this);
		}
		if (offset3 != -1)
		{
		 fseek(fp,getOffset()+offset3,SEEK_SET);
		 //obj->trackBufferPos = getOffset()+offset3;
	     children[2]       = getChildType(sectionOffset,this,fp,obj);
		}
		else
		{
		  children[2] = new EmptyNode(sectionOffset,this);
		}
		
		fseek(fp,toff,SEEK_SET);
		//obj->trackBufferPos = toff;
   }


int NodePtr::Write(FILE *fp,int secOffset)
{
	   if (pointToNode)
	   {
		  if (pointToNode->written == FALSE)
		  {
			 //int foff = ftell(fp);
			 //pointToNode->written = TRUE;
		     //pointToNode->writingOffset = pointToNode->Write(fp,secOffset);	
			 //pointToNode->writingOffset;
			 //writingOffset = pointToNode->writingOffset;
			 //return writingOffset;
			 return -1;
		  }
		  else
		  {
			 return pointToNode->writingOffset;
		  }
	   }
	   return -2;
}

int NodePtr::WriteSpecial(FILE *fp,int secOffset)
{
	   if (pointToNode)
	   {
		  if (pointToNode->written == FALSE)
		  {
			 int foff = ftell(fp);
			 pointToNode->written = TRUE;
		     pointToNode->writingOffset = pointToNode->Write(fp,secOffset);	
			 writingOffset = pointToNode->writingOffset;
			 return writingOffset;
		  }
		  else
		  {
			 return pointToNode->writingOffset;
		  }
	   }
	   return -2;
}

void NodeSix::Read(FILE *fp)
{
	   number1 = number2 = number3 = number4 = number5 = 0;


	   //object->trackBufferPos = ftell(fp);

	   if (object->getVersion() == t_N2)
	    {
		 number1        = ReadPCDWord(fp);
		 number2        = ReadPCDWord(fp);
		 number3        = ReadPCDWord(fp);
		 number4        = ReadPCDWord(fp);
		 number5        = ReadPCDWord(fp);
		}
	    else
	    {
	     number1        = ReadPCDWord(fp);
		}
		numberOfChildren = 1;
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		
		int toff = ftell(fp);	   	   
		//int toff = object->trackBufferPos;
		for(int i=0;i<numberOfChildren;i++)
		{
		 int child_offset  = ReadPCDWord(fp);
		 if (child_offset != -1)
		 {
		 int lftoff = ftell(fp);
	     //int lftoff = object->trackBufferPos;
	     fseek(fp,getOffset()+child_offset,SEEK_SET);
		 //object->trackBufferPos = getOffset()+child_offset;
	     children[i]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,lftoff,SEEK_SET);
		 //object->trackBufferPos = lftoff;
		 }
		 else
		 {
			 children[i] = new EmptyNode(sectionOffset,this);
		 }
		}
		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;
   }

int NodeSeventeen::Write(FILE *fp,int secOffset)
{
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x17);
	   WritePCDWord(fp,numNumbers);
	  
	   for(int i=0;i<numNumbers;i++)
	   {
		 WritePCDWord(fp,numbers[i]);
	   }
	   return foff;
}

void NodeSeventeen::Read(FILE *fp)
{
	    numNumbers  = ReadPCDWord(fp);
	    numbers = new int[numNumbers];
		//int toff = ftell(fp);
		//int toff = object->trackBufferPos;
		numberOfChildren = 0;

		for(int i=0;i<numNumbers;i++)
		{
		 numbers[i]  = ReadPCDWord(fp);
		}
}


void NodeB::Read(FILE *fp)
{
	    numberOfChildren = 0;
		if (object->getVersion() == t_N2)
	    {
		   number1           = ReadPCDWord(fp);
		   number2           = ReadPCDWord(fp);
		   number3           = ReadPCDWord(fp);
		   number4           = ReadPCDWord(fp);
		   number5           = ReadPCDWord(fp);
		}
		else
		{
		   number1           = ReadPCDWord(fp);
		}
		offset1          = ReadPCDWord(fp);		
		offset2          = ReadPCDWord(fp);
        
		numberOfChildren = 2;
	
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		
		int toff = ftell(fp);
		//int toff = object->trackBufferPos;
	   	if (offset1 != -1)
		{
		 fseek(fp,getOffset()+offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset1;
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		}
		else
		{
		 children[0]       = new EmptyNode(sectionOffset,this); 
		}

		if (offset2 != -1)
		{
		 fseek(fp,getOffset()+offset2,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset2;
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		}
		else
		{
		 children[1]       = new EmptyNode(sectionOffset,this); 
		}

		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;

}

#define DEGVAL(x) (((float)x)*(180.0f/2147483648.0f))
#define VALDEG(x) (((float)x)*(2147483648.0f/180.0f))


int NodeD::Write(FILE *fp,int secOffset)
{
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x0d);

	   double d1 = info.x;
	   double d2 = info.y;
	   double d3 = info.z;
	   double d4 = info.a;
	   double d5 = info.b;
	   double d6 = info.c;
	   double d7 = info.scale;

	   if (object->getVersion() == t_N2)
	   {
		   d1 *= 19685.0;
		   d2 *= 19685.0;
		   d3 *= 19685.0;
		   d4 = VALDEG(d4);
		   d5 = VALDEG(d5);
		   d6 = VALDEG(d6);
		   WritePCDWord(fp,(int)d1);
		   WritePCDWord(fp,(int)d2);
	       WritePCDWord(fp,(int)d3);
	       WritePCDWord(fp,(int)d4);
	       WritePCDWord(fp,(int)d5);
	       WritePCDWord(fp,(int)d6);
	       WritePCDWord(fp,(int)d7);
	   }
	   else
	   {
		   WritePCFloat(fp,(float)d1);
	       WritePCFloat(fp,(float)d2);
	       WritePCFloat(fp,(float)d3);
	       WritePCFloat(fp,(float)d4);
	       WritePCFloat(fp,(float)d5);
	       WritePCFloat(fp,(float)d6);
	       WritePCFloat(fp,(float)d7);
	   }
	   
	   
	   WritePCDWord(fp,offset1);
	   written = TRUE;
	   return foff;
}

void NodeD::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   //if (drawn) return;
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;

	   GLdouble wx,wy,wz;
	   GLdouble ax,ay,az;

	   wx = info.x;
	   wy = info.y;
	   wz = info.z;

	   ax = info.b;
	   ay = info.c;
	   az = info.a;

	   if (view->GetDocument()->showSubObjectLocations)
	   {
	   glPointSize(5.0f);
	   setGLColor(1.0f,0.0f,1.0f);
	   glBegin(GL_POINTS);  
	   glVertex3d(wx,wy,wz);
	   glEnd();
	   glPointSize(1.0f);
	   }
	   glPushMatrix();
	   glTranslated(wx,wy,wz);
	   glRotatef((float)ax,1.0f,0.0f,0.0f);
	   glRotatef((float)ay,0.0f,1.0f,0.0f);
	   glRotatef((float)az,0.0f,0.0f,1.0f);
	   

	   Node::DrawGL(hdc,object,doview,currentTexture);
			   
	   glPopMatrix();
}

BOOL NodeD::Edit()
{
	CEditObjPos *dlg = new CEditObjPos();

	dlg->m_X = info.x;
	dlg->m_Y = info.y;
	dlg->m_Z = info.z;
	dlg->m_A = info.a;
	dlg->m_B = info.b;
	dlg->m_C = info.c;
	dlg->m_Scale = info.scale;

	int result = dlg->DoModal();

	if (result == IDOK)
	{
		info.x = dlg->m_X;
		info.y = dlg->m_Y;
		info.z = dlg->m_Z;
		info.a = dlg->m_A;
		info.b = dlg->m_B;
		info.c = dlg->m_C;
		info.scale = dlg->m_Scale;
	}

	if (dlg) delete dlg;
	return TRUE;
}

void NodeD::Read(FILE *fp)
{
	    numberOfChildren = 0;
		if (object->getVersion() == t_N2)
	    {
		 info.x        = ((float)ReadPCDWord(fp))/19685.0f;
		 info.y        = ((float)ReadPCDWord(fp))/19685.0f;
		 info.z        = ((float)ReadPCDWord(fp))/19685.0f;
		
		 info.a        = DEGVAL(ReadPCDWord(fp));
		 info.b        = DEGVAL(ReadPCDWord(fp));
		 info.c        = DEGVAL(ReadPCDWord(fp));
		 info.scale        = (float)ReadPCDWord(fp);
		}
		else
		{
	     info.x        = ReadPCFloat(fp);
		 info.y         = ReadPCFloat(fp);
		 info.z         = ReadPCFloat(fp);
		 info.a        = ReadPCFloat(fp);
		 info.b        = ReadPCFloat(fp);
		 info.c        = ReadPCFloat(fp);
		 info.scale        = ReadPCFloat(fp);
		}
		offset1        = ReadPCDWord(fp);
		if (offset1 !=-1)  numberOfChildren++;
		
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		
		int count=0;
		int toff = ftell(fp);
		//int toff = object->trackBufferPos;
	   	if (offset1 != -1)
		{
		 fseek(fp,getOffset()+offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset1;
	     children[count]       = getChildType(sectionOffset,this,fp,object);
		}
		else
		{
		 children[count] = new EmptyNode(sectionOffset,this);
		}
		count++;

		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;
   }


float NodeD::getX() 
{
	return info.x;
}

float NodeD::getY()
{
	return info.y;
}
 
float NodeD::getZ() 
{
	return info.z;
}

float NodeD::getRotX() 
{
	return info.c;
}

float NodeD::getRotY() 
{
	return info.b;
}

float NodeD::getRotZ() 
{
	return info.a;
}

BOOL NodeEleven::Edit()
{
	CDistanceSwitchEdit *dlg = new CDistanceSwitchEdit(this);

	int result = dlg->DoModal();

	delete dlg;
	return (result == IDOK) ? TRUE : FALSE;
}

void NodeEleven::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   //if (drawn) return;
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   // draw only one of your children!
	   if (depth == -1) depth = GetDepth();

	   BOOL isN2 = getObject()->isN2Version();

	   if (depth < 50)
	   {
		if (view->GetDocument()->drawDistance >= 0)
		{
		  //int idx = numberOfChildren-1;
		  //if (children[idx]) children[idx]->DrawGL(hdc,object,doview,currentTexture);
		  for(int i=0;i<numberOfChildren;i++)
		  {
		  
		   double distMeters = child_scales[i];
		   
		   if (isN2){
			   distMeters = TO_METERS(child_scales[i]);
		   }

		   if (child_scales[i] >= view->GetDocument()->drawDistance)
		   {
		     if (children[i]) children[i]->DrawGL(hdc,object,doview,currentTexture);
		   }
		  }
		}
		 else if (view->GetDocument()->drawDistance == -1)
		 {
		  int idx = numberOfChildren-1;
		  if (children[idx]) children[idx]->DrawGL(hdc,object,doview,currentTexture);
		 }
		 else if (view->GetDocument()->drawDistance == -2)
		 {
		  Node::DrawGL(hdc,object,doview,currentTexture);
		 }
	   }
}

void NodeSeven::Read(FILE *fp)
   {
		if (object->getVersion() == t_N2)
	    {
		  number1           = ReadPCDWord(fp);
		  number2           = ReadPCDWord(fp);
		  number3           = ReadPCDWord(fp);
		  number4           = ReadPCDWord(fp);
		  number5           = ReadPCDWord(fp);
		}
		else
		{
	      number1        = ReadPCDWord(fp);
		}
	    numberOfChildren = 2;
	    
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		
		int toff = ftell(fp);
	   	//int toff = object->trackBufferPos;   
		for(int i=0;i<numberOfChildren;i++)
		{
		 int child_offset  = ReadPCDWord(fp);
		 
		 if (child_offset && child_offset!=-1)
		 {
		     int ltoff = ftell(fp);
			 //int ltoff = object->trackBufferPos;
	         fseek(fp,getOffset()+child_offset,SEEK_SET);
			 //object->trackBufferPos = getOffset()+child_offset;
	         children[i]       = getChildType(sectionOffset,this,fp,object);
		     fseek(fp,ltoff,SEEK_SET);
			 //object->trackBufferPos = ltoff;
		 }
		 else
		 {
			 children[i] = new EmptyNode(sectionOffset,this);
		 }
		}
		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;
   }

int NodeNine::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   if (children[1]->writingOffset!=-1){
	     offset2=children[1]->writingOffset-getOffset();
	   }
	   else {
		 offset2 = -1;
	   }
	   if (children[2]->writingOffset!=-1){
	     offset3=children[2]->writingOffset-getOffset();
	   }
	   else {
		 offset3 = -1;
	   }
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x9);
	   WritePCDWord(fp,number1);
	   if (object->getVersion() == t_N2)
	   {
		   WritePCDWord(fp,number2);
		   WritePCDWord(fp,number3);
		   WritePCDWord(fp,number4);
		   WritePCDWord(fp,number5);
	   }
	   WritePCDWord(fp,offset1);
	   WritePCDWord(fp,offset2);
	   WritePCDWord(fp,offset3);
	   return foff;
   }

int NodeB::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   if (children[1]->writingOffset!=-1){
	     offset2=children[1]->writingOffset-getOffset();
	   }
	   else {
		 offset2 = -1;
	   }
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x0b);
	   WritePCDWord(fp,number1);
	   if (object->getVersion() == t_N2)
	   {
		   WritePCDWord(fp,number2);
		   WritePCDWord(fp,number3);
		   WritePCDWord(fp,number4);
		   WritePCDWord(fp,number5);
	   }
	   WritePCDWord(fp,offset1);
	   WritePCDWord(fp,offset2);
	   return foff;
   }


int NodeSix::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   int offset1;

	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x6);
	   WritePCDWord(fp,number1);
	   if (object->getVersion() == t_N2)
	   {
		   WritePCDWord(fp,number2);
		   WritePCDWord(fp,number3);
		   WritePCDWord(fp,number4);
		   WritePCDWord(fp,number5);
	   }
	   WritePCDWord(fp,offset1);
	   return foff;
   }

int NodeLine815::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   if (object->getVersion() == t_N2)
	   {
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x15);
	   WritePCDWord(fp,0);
	   WritePCDWord(fp,number);
	   WritePCDWord(fp,numberofVerticies);
	   for(int i=0;i<numberofVerticies;i++)
	   {
	     WritePCDWord(fp,v[i]);
	   }
	   return foff; 
	   }
	   else
	   {
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x815);
	   WritePCDWord(fp,number);
	   WritePCDWord(fp,v[0]);
	   WritePCDWord(fp,v[1]);
	   return foff; 
	   }
   }


int NodeSeven::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x7);
	   if (object->getVersion() == t_N2)
	   {
		 WritePCDWord(fp,number1);	 
		 WritePCDWord(fp,number2);	 
		 WritePCDWord(fp,number3);	 
		 WritePCDWord(fp,number4);	 
		 WritePCDWord(fp,number5);	 
	   }
	   else
	   {
		 WritePCDWord(fp,number1);
	   }
	   //WritePCDWord(fp,numberOfChildren);

	   for(int i=0;i<numberOfChildren;i++)
	   {
		   int offset1;
		   if (children[i]->writingOffset!=-1){
	        offset1=children[i]->writingOffset-getOffset();
	       }
	       else {
		    offset1 = -1;
	      }	   
		  WritePCDWord(fp,offset1);
	   }
	   return foff;
   }

void NodeC::Read(FILE *fp)
   {
	    int child_offset1        = ReadPCDWord(fp);
	    numberOfChildren         = ReadPCDWord(fp)+1;
	    children = (Node**)malloc((numberOfChildren)*sizeof(Node*));
		
		int toff = ftell(fp);	   	   
		//int toff = object->trackBufferPos;

		if (child_offset1 && child_offset1!=-1)
		{
		 int ltoff = ftell(fp);
		 //int ltoff = object->trackBufferPos;
	     fseek(fp,getOffset()+child_offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+child_offset1;
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		 //object->trackBufferPos = ltoff;
		}
		else
		{
			 children[0] = new EmptyNode(sectionOffset,this);
		}

		for(int i=1;i<numberOfChildren;i++)
		{
		 int child_offset  = ReadPCDWord(fp);
		 
		 if (child_offset && child_offset!=-1)
		 {
		 int ltoff = ftell(fp);
	     //int ltoff = object->trackBufferPos;
	     fseek(fp,getOffset()+child_offset,SEEK_SET);
		 //object->trackBufferPos = getOffset()+child_offset;
	     children[i]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		 //object->trackBufferPos = ltoff;
		 }
		 else
		 {
			 children[i] = new EmptyNode(sectionOffset,this);
		 }
		}
		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;
   }

int NodeC::Write(FILE *fp,int secOffset) 
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   int foff = ftell(fp);
	   
	   sendCommandVal(fp,0xC);
	   int offset1;
	   if (children[0]->writingOffset!=-1){
	        offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		    offset1 = -1;
	   }	   
	   WritePCDWord(fp,offset1);
	   WritePCDWord(fp,(numberOfChildren-1));

	   for(int i=1;i<numberOfChildren;i++)
	   {
		   int offset1;
		   if (children[i]->writingOffset!=-1){
	        offset1=children[i]->writingOffset-getOffset();
	       }
	       else {
		    offset1 = -1;
	      }	   
		  WritePCDWord(fp,offset1);
	   }
	   return foff;
   }

void NodeEleven::Read(FILE *fp)
   {
	    number1        = ReadPCDWord(fp);
		number2        = ReadPCDWord(fp);
		number3        = ReadPCDWord(fp);
		numberOfChildren        = ReadPCDWord(fp);
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		child_scales = new float[numberOfChildren];


		int toff = ftell(fp);
	   	//int toff = object->trackBufferPos;   
		for(int i=0;i<numberOfChildren;i++)
		{
	    // can't do this the second time without
		// having first put the file pointer to the right spot
		 if (object->getVersion() == t_N2)
		 {
		   child_scales[i]   = (float)ReadPCDWord(fp);
		 }
		 else
		 {
		   child_scales[i]   = ReadPCFloat(fp);
		 }
		 int child_offset  = ReadPCDWord(fp);
		 if (child_offset != -1)
		 {
		 int ltoff = ftell(fp);
		 //int ltoff = object->trackBufferPos;
	     fseek(fp,getOffset()+child_offset,SEEK_SET);
		 //object->trackBufferPos = getOffset()+child_offset;
	     children[i]       = getChildType(sectionOffset,this,fp,object);
		 //if (children[i]) children[i]->Read(fp);
		 fseek(fp,ltoff,SEEK_SET);
		 //object->trackBufferPos = ltoff;
		 }
		 else
		 {
			 children[i] = new EmptyNode(sectionOffset,getParent());
		 }
		}
		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;
   }

   int NodeEleven::Write(FILE *fp, int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x11);
	   WritePCDWord(fp,number1);
	   WritePCDWord(fp,number2);
	   WritePCDWord(fp,number3);
	   WritePCDWord(fp,numberOfChildren);

	   for(int i=0;i<numberOfChildren;i++)
	   {
		   int offset1;
		   if (children[i]->writingOffset!=-1){
	        offset1=children[i]->writingOffset-getOffset();
	       }
	       else {
		    offset1 = -1;
	      }
		  	
		  if (object->getVersion() == t_N2)
		  {
		   WritePCDWord(fp,(int)child_scales[i]);
		  }
		  else
		  {
		   WritePCFloat(fp,child_scales[i]);
		  }
		  WritePCDWord(fp,offset1);
	   }
	   return foff;
   }

CString NodeEleven::toString()
{
       CString buffer;
	   buffer.Format("Distance Switch Flavor=%d Children=%d Number1=%d Number2=%d Number3=%d ",type,numberOfChildren,number1,number2,number3);
	   for(int i=0;i<numberOfChildren;i++)
	   {
		   CString str;
		   if (object->getVersion() == t_N2)
		   {
		     str.Format("([%d]=%d)",i,(int)child_scales[i]);
		   }
		   else
		   {
			 str.Format("([%d]=%2.2f)",i,child_scales[i]);
		   }
		   buffer += str;
	   }
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;
}

void NodeA::Read(FILE *fp)
   {
	    numberOfChildren = 0;
		if (object->getVersion() == t_N2)
	    {
		 number1        = ReadPCDWord(fp);
		 number2        = ReadPCDWord(fp);
		 number3        = ReadPCDWord(fp);
		 number4        = ReadPCDWord(fp);
		 number5        = ReadPCDWord(fp);
		}
		else
		{
	     number1        = ReadPCDWord(fp);
		}
		offset1        = ReadPCDWord(fp);
		offset2        = ReadPCDWord(fp);
        offset3        = ReadPCDWord(fp);
		
		numberOfChildren = 3;
	    children = (Node**)malloc(3*sizeof(Node*));
		
		
		int toff = ftell(fp);
		//int toff = object->trackBufferPos;
	   	if (offset1 != -1)
		{
		 fseek(fp,getOffset()+offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset1;
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 
		}
		else
		{
		  children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 != -1)
		{
		 fseek(fp,getOffset()+offset2,SEEK_SET);
		//	object->trackBufferPos = getOffset()+offset2;
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		 
		}
		else
		{
		  children[1] = new EmptyNode(sectionOffset,this);
		}
		if (offset3 != -1)
		{
		 fseek(fp,getOffset()+offset3,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset3;
	     children[2]       = getChildType(sectionOffset,this,fp,object);
		 
		}
		else
		{
		  children[2] = new EmptyNode(sectionOffset,this);
		}

		fseek(fp,toff,SEEK_SET);
		//object->trackBufferPos = toff;
 }

int NodeA::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   if (children[1]->writingOffset!=-1){
	     offset2=children[1]->writingOffset-getOffset();
	   }
	   else {
		 offset2 = -1;
	   }
	   if (children[2]->writingOffset!=-1){
	     offset3=children[2]->writingOffset-getOffset();
	   }
	   else {
		 offset3 = -1;
	   }
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0xA);
	   WritePCDWord(fp,number1);
	   if (object->getVersion() == t_N2)
	   {
		   WritePCDWord(fp,number2);
		   WritePCDWord(fp,number3);
		   WritePCDWord(fp,number4);
		   WritePCDWord(fp,number5);
	   }
	   WritePCDWord(fp,offset1);
	   WritePCDWord(fp,offset2);
	   WritePCDWord(fp,offset3);
	   return foff;
}



BOOL Node::Init()
{
	return FALSE;
}

void Node::ClearDrawnStatus()
{
	   drawn=FALSE;
	   for(int i=0;i<numberOfChildren;i++)
	   {		   
		   if (children[i])
		   {
			   children[i]->drawn=FALSE;
			   children[i]->ClearDrawnStatus();			   
		   }
	   }
}

void Node::DeleteNode(Node *ptr)
{
     //if (ptr)
     //{
	 // if (ptr->refCount<=1) 
	 // {
		  delete ptr;
	//	  ptr = NULL;
	 // }
	 // else ptr->refCount--;
	 //}
}

Node::~Node()
{
	   for(int i=0;i<numberOfChildren;i++)
	   {
	   	   if (children[i])
		   {
			   if (children[i]->type == 0xFFFF) 
			   {
					//DeleteNode(children[i]);
				    //delete children[i];
					//children[i] = NULL;
			   }
		   }
	   }
	   if (numberOfChildren)
	   {
	    delete[] children;
		numberOfChildren = 0;
	   }
}


void NodeEight::Read(FILE *fp)
{
	  if (getObject()->isN2Version())
	  {
		  ReadN2(fp);
	  }
	  else
	  {
		  ReadGPL(fp);
	  }
}

void NodeEight::ReadGPL(FILE *fp)
{
	    numberOfChildren = 0;

		//fread(&info,1,sizeof(t_FlavourEight),fp);
		number1 = ReadPCDWord(fp);
		offset1 = ReadPCDWord(fp);
		offset2 = ReadPCDWord(fp);
		offset3 = ReadPCDWord(fp);
		offset4 = ReadPCDWord(fp);

		numberOfChildren = 4;
		
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		
	   	if (offset1 != -1)
		{
		 fseek(fp,getOffset()+offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset1;
	     children[0]       = getChildType(sectionOffset,this,fp,object);

		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 != -1)
		{
		 fseek(fp,getOffset()+offset2,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset2;
	     children[1]       = getChildType(sectionOffset,this,fp,object);

		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}

		if (offset3 != -1)
		{
		 fseek(fp,getOffset()+offset3,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset3;
	     children[2]       = getChildType(sectionOffset,this,fp,object);

		}
		else
		{
		 children[2] = new EmptyNode(sectionOffset,this);
		}

		if (offset4 != -1)
		{
		 fseek(fp,getOffset()+offset4,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset4;
	     children[3]       = getChildType(sectionOffset,this,fp,object);

		}
		else
		{
		 children[3] = new EmptyNode(sectionOffset,this);
		}
}


int NodeEight::Write(FILE *fp,int secoffset)
{
	  if (getObject()->isN2Version())
	  {
		  return WriteN2(fp,secoffset);
	  }
	  else
	  {
		  return WriteGPL(fp,secoffset);
	  }
}

int NodeEight::WriteGPL(FILE *fp,int secOffset)
{
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   if (children[1]->writingOffset!=-1){
	     offset2=children[1]->writingOffset-getOffset();
	   }
	   else {
		 offset2 = -1;
	   }
	   if (children[2]->writingOffset!=-1){
	     offset3=children[2]->writingOffset-getOffset();
	   }
	   else {
		 offset3 = -1;
	   }
	   if (children[3]->writingOffset!=-1){
	     offset4=children[3]->writingOffset-getOffset();
	   }
	   else {
		 offset4 = -1;
	   }
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x8);
	   //fwrite(&info,1,sizeof(t_FlavourEight),fp);
	   WritePCDWord(fp,number1);
	   WritePCDWord(fp,offset1);
	   WritePCDWord(fp,offset2);
	   WritePCDWord(fp,offset3);
	   WritePCDWord(fp,offset4);
	   return foff;
   }


void NodeEight::ReadN2(FILE *fp)
{
	    numberOfChildren = 0;

		//fread(&info,1,sizeof(t_FlavourEight),fp);
		number1 = ReadPCDWord(fp);
		number2 = ReadPCDWord(fp);
		number3 = ReadPCDWord(fp);
		number4 = ReadPCDWord(fp);
		number5 = ReadPCDWord(fp);
		//number6 = ReadPCDWord(fp);
		offset1 = ReadPCDWord(fp);
		offset2 = ReadPCDWord(fp);
		offset3 = ReadPCDWord(fp);
		offset4 = ReadPCDWord(fp);

		numberOfChildren = 4;
		
	    children = (Node**)malloc(numberOfChildren*sizeof(Node*));
		
	   	if (offset1 != -1)
		{
		 fseek(fp,getOffset()+offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset1;
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 //if (children[0]) children[0]->Read(fp);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 != -1)
		{
		 fseek(fp,getOffset()+offset2,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset2;
	     children[1]       = getChildType(sectionOffset,this,fp,object);

		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}

		if (offset3 != -1)
		{
		 fseek(fp,getOffset()+offset3,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset3;
	     children[2]       = getChildType(sectionOffset,this,fp,object);

		}
		else
		{
		 children[2] = new EmptyNode(sectionOffset,this);
		}
		if (offset4 != -1)
		{
		 fseek(fp,getOffset()+offset4,SEEK_SET);
		 //object->trackBufferPos = getOffset()+offset4;
	     children[3]       = getChildType(sectionOffset,this,fp,object);
	
		}
		else
		{
		 children[3] = new EmptyNode(sectionOffset,this);
		}
}

int NodeEight::WriteN2(FILE *fp,int secOffset)
{
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);
	   if (children[0]->writingOffset!=-1){
	     offset1=children[0]->writingOffset-getOffset();
	   }
	   else {
		 offset1 = -1;
	   }
	   if (children[1]->writingOffset!=-1){
	     offset2=children[1]->writingOffset-getOffset();
	   }
	   else {
		 offset2 = -1;
	   }
	   if (children[2]->writingOffset!=-1){
	    offset3=children[2]->writingOffset-getOffset();
	   }
	   else {
		 offset3 = -1;
	   }
	   if (children[3]->writingOffset!=-1){
	     offset4=children[3]->writingOffset-getOffset();
	   }
	   else {
		 offset4 = -1;
	   }
	   
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0x8);
	   WritePCDWord(fp,number1);
	   WritePCDWord(fp,number2);
	   WritePCDWord(fp,number3);
	   WritePCDWord(fp,number4);
	   WritePCDWord(fp,number5);
	   //WritePCDWord(fp,number6);
	   WritePCDWord(fp,offset1);
	   WritePCDWord(fp,offset2);
	   WritePCDWord(fp,offset3);
	   WritePCDWord(fp,offset4);
	   return foff;
   }

void GLDrawLine(Point3D *a,Point3D *b)
{
	setGLColor(1.0,0.0,0.0);
	glBegin(GL_LINE);	
	glVertex3d(a->getX(),a->getY(),a->getZ());
	glVertex3d(b->getX(),b->getY(),b->getZ());
	glEnd();
	setGLColor(0.0,0.0,0.0);
}

#define PI 3.14159265

void DrawGLPlane(CPlanes *plane,float normalSize,float r=1.0f,float g=0.0f,float b=0.0f)
{
    double A = plane->getA();  
	double B = plane->getB();
	double C = plane->getC();
	double D = plane->getD();

	GLdouble x1,y1,z1,ang1,dis1;
	GLdouble x2,y2,z2,ang2,dis2;
	GLdouble x3,y3,z3;

	glPushMatrix();
    x1=A*-D; y1=B*-D; z1=C*-D; 
	//ignoring y 
	ang1=atan2(z1,x1); 
	dis1=sqrt((x1*x1)+(z1*z1)); 
	x2=dis1; 
	y2=y1; 
	z2=0; 

	//ignoring z (which is now zero) 
	ang2=atan2(y2,x2); 
	dis2=sqrt((x2*x2)+(y2*y2)); 
	x3=dis2; 
	y3=0; 
	z3=0; 

	glColor3d(r,g,b);
	glBegin(GL_LINES);

	glVertex3d(A*-D, B*-D, C*-D);
	glVertex3d((A*-D)+A,(B*-D)+B,(C*-D)+C); 
	//glVertex3d(A,B,C); 
	glEnd();
	
	setGLColor(r,g,b);

	//and rotate around the y axis by angle 1 
	glRotated(-(ang1*180.0/PI), 0.0,1.0,0.0); 
	//and rotate around the z axis by angle 2 		
	glRotated((ang2*180.0/PI), 0.0,0.0,1.0); 
	//now take four 2d points in yz plane: 
	glBegin(GL_POLYGON); 

			
	glVertex3d(x3,normalSize,normalSize); 
	glVertex3d(x3,normalSize,-normalSize); 
	glVertex3d(x3,-normalSize,-normalSize); 
	glVertex3d(x3,-normalSize,normalSize); 
	glEnd(); 

	// line(a*-d, b*-d, c*-d)-((a*-d)+a,(b*-d)+b,(c*-d)+c) 
	
				
	glPopMatrix();
}

#define NORMAL_SCALE 5000.0

void NodeSix::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   int planeNumber = number1;
	   if (view->GetDocument()->showPlanes){
		  if (object->isGPLVersion())
		  {
		   if (number1 >=0 && number1 <= object->numPlanes)
		   {
		     CPlanes *plane = object->Plans[number1];
		     DrawGLPlane(plane,view->GetDocument()->normalSize);
		   }
		  }
		  else if (object->isN2Version())
		  {
		   glColor3d(0.0,0.0,1.0);
		   glPointSize(5.0);
		   glBegin(GL_POINTS);
		   double gl1 = TO_METERS(((double)number1/NORMAL_SCALE));
		   double gl2 = TO_METERS(((double)number2/NORMAL_SCALE));
		   double gl3 = TO_METERS(((double)number3/NORMAL_SCALE));
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glBegin(GL_LINES);
		   glVertex3d(0,0,0);
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glPointSize(1.0);
		  }
	   }
	   Node::DrawGL(hdc,object,doview,currentTexture);
}

void NodeSeven::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   int planeNumber = number1;
	   if (view->GetDocument()->showPlanes){
		  if (object->isGPLVersion())
		  {
		  if (number1 >=0 && number1 <= object->numPlanes)
		   {
		     CPlanes *plane = object->Plans[number1];
		     DrawGLPlane(plane,view->GetDocument()->normalSize);
		   }
		  }
		  else if (object->isN2Version())
		  {
		   glColor3d(0.0,0.0,1.0);
		   glPointSize(5.0);
		   glBegin(GL_POINTS);
		   double gl1 = TO_METERS(((double)number1/NORMAL_SCALE));
		   double gl2 = TO_METERS(((double)number2/NORMAL_SCALE));
		   double gl3 = TO_METERS(((double)number3/NORMAL_SCALE));
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glBegin(GL_LINES);
		   glVertex3d(0,0,0);
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glPointSize(1.0);
		  }
	   }
	   Node::DrawGL(hdc,object,doview,currentTexture);
}

void NodeEight::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   int planeNumber = number1;
	   if (view->GetDocument()->showPlanes){
		  if (object->isGPLVersion())
		  {
		   if (planeNumber >=0 && planeNumber <= object->numPlanes)
		   {
		     CPlanes *plane = object->Plans[planeNumber];
		     DrawGLPlane(plane,view->GetDocument()->normalSize);
		   }
		  }
		  else if (object->isN2Version())
		  {
		   glColor3d(0.0,0.0,1.0);
		   glPointSize(5.0);
		   glBegin(GL_POINTS);
		   double gl1 = TO_METERS(((double)number1/NORMAL_SCALE));
		   double gl2 = TO_METERS(((double)number2/NORMAL_SCALE));
		   double gl3 = TO_METERS(((double)number3/NORMAL_SCALE));
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glBegin(GL_LINES);
		   glVertex3d(0,0,0);
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glPointSize(1.0);
		  }
	   }
	   Node::DrawGL(hdc,object,doview,currentTexture);
}

void NodeNine::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   int planeNumber = number1;
	   if (view->GetDocument()->showPlanes){
		  if (object->isGPLVersion())
		  {
		   if (planeNumber >=0 && planeNumber <= object->numPlanes)
		   {
		     CPlanes *plane = object->Plans[planeNumber];
		     DrawGLPlane(plane,view->GetDocument()->normalSize);
		   }
		  }
		  else if (object->isN2Version())
		  {
		   glColor3d(0.0,0.0,1.0);
		   glPointSize(5.0);
		   glBegin(GL_POINTS);
		   double gl1 = TO_METERS(((double)number1/NORMAL_SCALE));
		   double gl2 = TO_METERS(((double)number2/NORMAL_SCALE));
		   double gl3 = TO_METERS(((double)number3/NORMAL_SCALE));
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glBegin(GL_LINES);
		   glVertex3d(0,0,0);
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glPointSize(1.0);
		  }
	   }
	   Node::DrawGL(hdc,object,doview,currentTexture);
}

void NodeA::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   int planeNumber = number1;
	   if (view->GetDocument()->showPlanes){
		  if (object->isGPLVersion())
		  {
		  if (planeNumber >=0 && planeNumber <= object->numPlanes)
		   {
		     CPlanes *plane = object->Plans[planeNumber];
		     DrawGLPlane(plane,view->GetDocument()->normalSize);
		   }
		  else if (object->isN2Version())
		  {
		   glColor3d(0.0,0.0,1.0);
		   glPointSize(5.0);
		   glBegin(GL_POINTS);
		   double gl1 = TO_METERS(((double)number1/NORMAL_SCALE));
		   double gl2 = TO_METERS(((double)number2/NORMAL_SCALE));
		   double gl3 = TO_METERS(((double)number3/NORMAL_SCALE));
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glBegin(GL_LINES);
		   glVertex3d(0,0,0);
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glPointSize(1.0);
		  }
		  }
	   }
	   Node::DrawGL(hdc,object,doview,currentTexture);
}

void NodeB::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	   int planeNumber = number1;
	   if (view->GetDocument()->showPlanes){
		  if (object->isGPLVersion())
		  {
		   if (planeNumber >=0 && planeNumber <= object->numPlanes)
		   {
		     CPlanes *plane = object->Plans[planeNumber];
		     DrawGLPlane(plane,view->GetDocument()->normalSize);
		   }
		  }
		  else if (object->isN2Version())
		  {
		   glColor3d(0.0,0.0,1.0);
		   glPointSize(5.0);
		   glBegin(GL_POINTS);
		   double gl1 = TO_METERS(((double)number1/NORMAL_SCALE));
		   double gl2 = TO_METERS(((double)number2/NORMAL_SCALE));
		   double gl3 = TO_METERS(((double)number3/NORMAL_SCALE));
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glBegin(GL_LINES);
		   glVertex3d(0,0,0);
		   glVertex3d(gl1,gl2,gl3);
		   glEnd();
		   glPointSize(1.0);
		  }
	   }
	   Node::DrawGL(hdc,object,doview,currentTexture);
}

BOOL NodeTen::Init()
{
	number = 1;
	entries       = new DataValue[number];
	entries[0].data = 0;
	return TRUE;
}

CString NodeSix::toString()
{
       CString buffer;
	   if (getObject()->isN2Version())
		buffer.Format("Flavor=%d Children=%d plane_number=%d %d %d %d %d",type,numberOfChildren,number1,number2,number3,number4,number5);
       else
	    buffer.Format("Flavor=%d Children=%d plane_number=%d",type,numberOfChildren,number1);
	   //if (getObject()->showOffset)
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;	   
}

void Node::addChild(Node *node)
{
	numberOfChildren++;	
	if (children)
	{
	  children = (Node**)realloc(children,numberOfChildren*sizeof(Node*));
	}
	else
	{
	  children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	}
	children[numberOfChildren-1]=node;
}

void Node::ExpandToRoot(CObjectTree *tree)
{
	Node *t = this;
	Node *par = t->getParent();
	if (par)
		par->ExpandToRoot(tree);

	tree->m_ObjectTree.Expand(t->treeNode,TVE_EXPAND);
}

CString Node::Export()
{
	return CString("No Export");
}

void Node::ExportData(ostream &out)
{
		out << Export() << endl;

		for(int i=0;i<numberOfChildren;i++)
		{
		  if (children[i])
		  {
			  children[i]->ExportData(out);
		  }
		}
}











