#include "stdafx.h"
#include "Node.h"

#include "DatView.h"
#include "3DOEditorView.h"

#include "EditObjPos.h"
#include "EditTwoVar.h"
#include "EditOneVar.h"

#include "MipError.h"

#include <gl\glaux.h>
#include <gl\gl.h>
#include <gl\glu.h>


#define NUM_CHILD 6

void NodeFifteen::Read(FILE *fp)
{
       C3do *object = getObject();

	   if (object->getVersion() == t_N2)
	   {
		   memset(&info,0,sizeof(info));
		   info.number1 = ReadPCDWord(fp);
		   info.number2 = ReadPCDWord(fp);
		   info.number3 = ReadPCDWord(fp);
		   info.number4 = ReadPCDWord(fp);
		   numberOfChildren = 0;
	   }
	   else
	   {
	   object->SeenANodeFifteen=TRUE;
	   fread(&info,1,sizeof(t_FlavourFifteen),fp);
	   //OffsetRefs[0] = FALSE;
	   //OffsetRefs[1] = FALSE;
	   //OffsetRefs[2] = FALSE;
	   //OffsetRefs[3] = FALSE;
	   //OffsetRefs[4] = FALSE;

	   //numberOfChildren = FLAVOR_FIFTEEN_NODES+info.numItem;
	   numberOfChildren = NUM_CHILD+info.numItem;
	   //numberOfChildren = info.numItem;
	   children = (Node**)malloc(numberOfChildren*sizeof(Node*));

	   int toff = ftell(fp);
	   //int toff = object->trackBufferPos;
	   
	   if (info.offset6 != -1 )
	   {
	   fseek(fp,getOffset()+info.offset6,SEEK_SET);
	   //object->trackBufferPos = getOffset()+info.offset6;
	   children[0] = getChildType(sectionOffset,this,fp,object);
	   }
	   else
	   {
	   children[0] = new EmptyNode(sectionOffset,getParent());
	   }

	   if (info.offset1 != -1 )
	   {
	     fseek(fp,getOffset()+info.offset1,SEEK_SET);
		 //object->trackBufferPos = getOffset()+info.offset1;
	     children[1] = getChildType(sectionOffset,this,fp,object);
	   }
	   else
	   {
		 children[1]= new EmptyNode(sectionOffset,getParent());
	   }

	   
	   if (info.offset2 != -1 )
	   {
	     fseek(fp,getOffset()+info.offset2,SEEK_SET);
		 //  object->trackBufferPos = getOffset()+info.offset2;
	     children[2] = getChildType(sectionOffset,this,fp,object);
	   }
	   else
	   {
	     children[2] = new EmptyNode(sectionOffset,getParent());
	   }

	   if (info.offset3 != -1 )
	   {
	   fseek(fp,getOffset()+info.offset3,SEEK_SET);
		//object->trackBufferPos = getOffset()+info.offset3;
	   children[3] = getChildType(sectionOffset,this,fp,object);
	   }
	   else
	   {
	   children[3] = new EmptyNode(sectionOffset,getParent());
	   }

	   if (info.offset4 != -1 )
	   {
	   fseek(fp,getOffset()+info.offset4,SEEK_SET);
		//object->trackBufferPos = getOffset()+info.offset4;
	   children[4] = getChildType(sectionOffset,this,fp,object);
	   }
	   else
	   {
	   children[4] = new EmptyNode(sectionOffset,getParent());
	   }

	   if (info.offset5 != -1 )
	   {
	   fseek(fp,getOffset()+info.offset5,SEEK_SET);
		//object->trackBufferPos = getOffset()+info.offset5;
	   children[5] = getChildType(sectionOffset,this,fp,object);
	   }
	   else
	   {
	   children[5] = new EmptyNode(sectionOffset,getParent());
	   }

	   

	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;
	   child_info = new t_FlavourFifteenChild[info.numItem];
	   fread(child_info,info.numItem,sizeof(t_FlavourFifteenChild),fp);

	    for(int i=0;i<info.numItem;i++)
		{
	     fseek(fp,getOffset()+child_info[i].offset,SEEK_SET);
		 //object->trackBufferPos = getOffset()+child_info[i].offset;
	     //children[FLAVOR_FIFTEEN_NODES+i] = getChildType(sectionOffset,this,fp);       	   
		 children[NUM_CHILD+i] = getChildType(sectionOffset,this,fp,object);       	   
		 //children[i] = getChildType(sectionOffset,this,fp);       	   
		}
	   }
}

int NodeFifteen::Write(FILE *fp,int secOffset)
{
	   sectionOffset = secOffset;

	   if (object->isN2Version())
	   {
		   int foff = ftell(fp);
		   sendCommandVal(fp,0xF);
		   WritePCDWord(fp,info.number1);
		   WritePCDWord(fp,info.number2);
		   WritePCDWord(fp,info.number3);
		   WritePCDWord(fp,info.number4);
		   return foff;
	   }

	   

	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     info.offset6=children[0]->writingOffset-getOffset();
	   }
	   else {
		 info.offset6 = -1;
	   }

	   if (children[1]->writingOffset!=-1){
	     info.offset1=children[1]->writingOffset-getOffset();
	   }
	   else {
		 info.offset1 = -1;
	   }

	   
	   if (children[2]->writingOffset!=-1){
	     info.offset2=children[2]->writingOffset-getOffset();
	   }
	   else {
		 info.offset2 = -1;
	   }
	   if (children[3]->writingOffset!=-1){
	     info.offset3=children[3]->writingOffset-getOffset();
	   }
	   else {
		 info.offset3 = -1;
	   }
	   if (children[4]->writingOffset!=-1){
	     info.offset4=children[4]->writingOffset-getOffset();
	   }
	   else {
		 info.offset4 = -1;
	   }
	   if (children[5]->writingOffset!=-1){
	     info.offset5=children[5]->writingOffset-getOffset();
	   }
	   else {
		 info.offset5 = -1;
	   }

	   for(int i=0;i<info.numItem;i++)
	   {
		 //if (children[FLAVOR_FIFTEEN_NODES+i]->writingOffset!=-1){
		 if (children[NUM_CHILD+i]->writingOffset!=-1){
	        child_info[i].offset=children[NUM_CHILD+i]->writingOffset-getOffset();
		 }
		 else {
			child_info[i].offset = -1;
		 }
	   }
	   
	   int foff = ftell(fp);
	   sendCommandVal(fp,0xF);
	   fwrite(&info,1,sizeof(t_FlavourFifteen),fp);
	   for(i=0;i<info.numItem;i++)
	   {
	     fwrite(child_info,info.numItem,sizeof(t_FlavourFifteenChild),fp);
	   }

	   /*

	   
	   
	   
	   int foffa = ftell(fp);
	   fseek(fp,foff,SEEK_SET);
	   sendCommandVal(fp,0xF);
	   fwrite(&info,1,sizeof(t_FlavourFifteen),fp);
	   for(i=0;i<info.numItem;i++)
	   {
	     fwrite(child_info,info.numItem,sizeof(t_FlavourFifteenChild),fp);
	   }
	   fseek(fp,foffa,SEEK_SET);
	   */
	   return foff;
}

CString NodeFifteen::toString()
{
       CString buffer;
	   //buffer.Format("Flavor=%d num=%d n1=%d n2=%d n3=%d n4=%d n5=%d n6=%d n7=%d n8=%d n9=%d numItem=%d offsets=(%d,%d,%d)",type,info.number1,info.number2,info.number3,info.number4,
	   //	   info.number5,info.number6,info.zero1,info.zero2,info.zero3,info.zero4,info.numItem,info.offset1,info.offset2,info.offset3);
	   buffer.Format("Flavor=%d vp1=%d vp2=%d vp3=%d vp4=%d zeros(%d %d %d %d) numItem=%d offsets=(%x,%x,%x,%x,%x)",type,
		   info.number1,info.number2,info.number3,info.number4,
		   info.zero1,info.zero2,info.zero3,info.zero4,
		   info.numItem,
		   info.offset1,info.offset2,info.offset3,info.offset4,info.offset5,info.offset6);
	   {
		  CString msg;	  
		  msg.Format("[%x] %s ",nodeOffset,buffer);
		  //msg+=getObject()->Plans[info.number1]->toString();
		  return msg;
	   }
	   return buffer;
}

void NodeFifteen::Draw(C3do* object,Display *display,CView *doview)
{
}

extern void DrawGLPlane(CPlanes *plane,float normalSize,float r=0,float g=0,float b=0);


void getXY(CPlanes *p1, CPlanes *p2, double &x,double &y)
{
	double A1 = p1->A.data;
	double B1 = p1->B.data;
	double D1 = p1->D.data;

	double A2 = p2->A.data;
	double B2 = p2->B.data;
	double D2 = p2->D.data;

	y = (-D2+((A2*D1)/A1))/(B2 - ((A2*B1)/A1));
	x = (-D1-(B1*y))/A1;
}

void NodeFifteen::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;

	   if (view->GetDocument()->showFiftenBoxes){
		  if (object->isGPLVersion())
		  {
		  CPlanes *plane1 = object->Plans[info.number1];
		  CPlanes *plane2 = object->Plans[info.number2];
		  CPlanes *plane3 = object->Plans[info.number3];
		  CPlanes *plane4 = object->Plans[info.number4];
		  double x,y;
		  glPointSize(4.0);
		  glColor3d(0.0,1.0,0.0);
		  glBegin(GL_POINTS);
		  getXY(plane1,plane2,x,y);
		  glVertex3d(x,y,0);
		  getXY(plane2,plane3,x,y);
		  glVertex3d(x,y,0);
		  getXY(plane3,plane4,x,y);
		  glVertex3d(x,y,0);
		  getXY(plane4,plane1,x,y);
		  glVertex3d(x,y,0);
		  glEnd();
		  glPointSize(1.0);
		  glBegin(GL_LINE_LOOP);


		  getXY(plane1,plane2,x,y);
		  glVertex3d(x,y,0);
		  getXY(plane2,plane3,x,y);
		  glVertex3d(x,y,0);
		  getXY(plane3,plane4,x,y);
		  glVertex3d(x,y,0);
		  getXY(plane4,plane1,x,y);
		  glVertex3d(x,y,0);
		  
		  glEnd();
		  }
	   }


	   if (view->GetDocument()->showSubObjects)
	   {
		  if (object->isGPLVersion())
		  {
		   for(int i=0;i<info.numItem;i++)
			{
				children[NUM_CHILD+i]->DrawGL(hdc,object,doview,currentTexture);	        
			}
		  }
	   }
}


void NodeFifteen::DisplayNodeAndChildren(ostream &os)
{

	os << "Node 0xF:" <<  nodeOffset << endl;
	os << "\t" << "Parent:=" << getParent()->toString() << endl;
	os << "\t" << "[" << children[0]->nodeOffset << "]" << "Children:=" << children[0]->toString() << endl;
	os << "\t\t" << "Plane:=" << info.number1 << endl;
	os << "\t" << "[" << children[1]->nodeOffset << "]" "Children:=" << children[1]->toString() << endl;
	os << "\t\t" << "Plane:=" << info.number2 << endl;
	os << "\t" << "[" << children[2]->nodeOffset << "]" "Children:=" << children[2]->toString() << endl;
	os << "\t\t" << "Plane:=" << info.number3 << endl;
	os << "\t" << "[" << children[3]->nodeOffset << "]" "Children:=" << children[3]->toString() << endl;
	os << "\t\t" << "Plane:=" << info.number4 << endl;
	os << "End of Node" << endl << endl;
}