#include "stdafx.h"
#include "Node.h"

#include "DatView.h"
#include "3DOEditorView.h"

#include "CMip.h"
#include "CSrb.h"
#include "MipError.h"
#include "NodeRepository.h"
#include "EditObjPos.h"

#define UPDATE_WR_OFFSET(x,y) if (children[y]->writingOffset!=-1){x=children[y]->writingOffset-getOffset();}else { x = -1;}

int NodeTenICR2::Write(FILE *fp,int secOffset) 
{
	int offsetA=-1;
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offsetA,0)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000010);
	WritePCDWord(fp,offsetA);
	WritePCDWord(fp,(numberOfChildren-1));
	for(int i=0;i<(numberOfChildren-1);i++)
	{
		 UPDATE_WR_OFFSET(offsetA,(i+1))
		 WritePCDWord(fp,offsetA);
	}
	return foff;
}

void NodeTenICR2::Read(FILE *fp)
{
	    numberOfChildren = 1;
		int offset1               = ReadPCDWord(fp);
		int numberOfOffsets       = ReadPCDWord(fp);
		int *offsets = new int[numberOfOffsets];
		numberOfChildren+=numberOfOffsets;

		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	
		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		for(int i=0;i<numberOfOffsets;i++)
		{
		 offsets[i] = ReadPCDWord(fp);
		 if (offsets[i] && offsets[i]!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offsets[i],SEEK_SET);
	     children[1+i]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1+i] = new EmptyNode(sectionOffset,this);
		}
		}
}

int NodeFifteenICR2::Write(FILE *fp,int secOffset) 
{
	sectionOffset = secOffset;
	int foff = ftell(fp);
	sendCommandVal(fp,0x8000000f);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);
	WritePCDWord(fp,number3);
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,number6);
	WritePCDWord(fp,offset1);
	return foff;
}


void NodeFifteenICR2::Read(FILE *fp)
{
		 number1               = ReadPCDWord(fp);
		 number2               = ReadPCDWord(fp);
		 number3               = ReadPCDWord(fp);
		 number4               = ReadPCDWord(fp);
		 number5               = ReadPCDWord(fp);
		 number6               = ReadPCDWord(fp);
		


		 offset1               = ReadPCDWord(fp);
	
        string_offset = -offset1;

		numberOfChildren = 0;

		x = (((double)number1)/PSCALE);
		y = (((double)number2)/PSCALE);
		z = (((double)number3)/PSCALE);
}

void NodeFifteenICR2::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;

	   if (!view->GetDocument()->showObjects) return;
	   static BOOL found=TRUE;

	   //if (found==FALSE) return;
	   GLdouble wx,wy,wz;
	   GLdouble ax,ay,az;

	   wx = wy = wz = 0.0;
	   ax = ay = az = 0.0;
	   wx = x;
	   wy = y;
	   wz = z;

	   
	   
	   if (view->GetDocument()->showSubObjectLocations)
	   {
       glPointSize(5.0f);
	   glBegin(GL_POINTS);	   
	   glVertex3d(wx,wy,wz);
	   glEnd();
	   glPointSize(1.0f);
	   }
	   glPushMatrix();
	   glTranslated(wx,wy,wz);
	   //glRotatef((float)ax,1.0f,0.0f,0.0f);
	   //glRotatef((float)ay,0.0f,1.0f,0.0f);
	   //glRotatef((float)az,0.0f,0.0f,1.0f);


	   if (subObject == NULL)
	   {
	    CString name="Unknown";
	    if (string_offset >= 0 && string_offset<getObject()->strs->size())
		{
	    CImageFile *file = (CImageFile*)getObject()->strs->elementAt(string_offset);
	    name = file->filename;
		}
		if (!stricmp(name,"horiz") || !stricmp(name,"sky")) 
		{
		   glPopMatrix();
		   return;
		}
		subObject = object->FindObjectFile(name);
		if (subObject){
		}
        else{
		   cerr << "Failed to load subObject " << name << endl;
		   found=FALSE;
		}
	   }

	   if (subObject)
	   {
		 subObject->GetFile(FALSE);
		 if (subObject->topDrawlocation)
		 {
		   //subObject->topDrawlocation->DrawGL(hdc,subObject,doview,currentTexture);
		   for(int i=0;i<subObject->topDrawlocation->size();i++)
		   {
			  Node * topDraw = (Node*) subObject->topDrawlocation->elementAt(i);
			  topDraw->DrawGL(hdc,subObject,doview,currentTexture);
		   }
		 }
	   }
	   
	   glPopMatrix();
}

CString NodeFifteenICR2::toString()
{
       CString buffer;
	   CString name="Unknown";
	   if (string_offset >= 0 && string_offset<getObject()->strs->size())
	   {
	   CImageFile *file = (CImageFile*)getObject()->strs->elementAt(string_offset);
	   //CString name = getObject()->(string_offset);
	   name = file->filename;
	   }
	   
	   buffer.Format("Flavor=%x SubObject=%d String Name=%s (%d,%d,%d)",type,string_offset,name,number1,number2,number3);
	   //if (getObject()->showOffset)
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;
}


int NodeDICR2::Write(FILE *fp,int secOffset) 
{
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)
	UPDATE_WR_OFFSET(offset2,1)
	UPDATE_WR_OFFSET(offset3,2)
	UPDATE_WR_OFFSET(offset4,3)
	
	
	int foff = ftell(fp);
	sendCommandVal(fp,0x8000000d);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);
	WritePCDWord(fp,offset1);
	WritePCDWord(fp,number3);
	WritePCDWord(fp,offset2);
	WritePCDWord(fp,number4);
	WritePCDWord(fp,offset3);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset4);
	return foff;
}

void NodeDICR2::Read(FILE *fp)
{
		 number1               = ReadPCDWord(fp);
		 number2               = ReadPCDWord(fp);
		 offset1               = ReadPCDWord(fp);
		 number3               = ReadPCDWord(fp);
		 offset2               = ReadPCDWord(fp);
		 number4               = ReadPCDWord(fp);
		 offset3               = ReadPCDWord(fp);
		 number5               = ReadPCDWord(fp);
		 offset4               = ReadPCDWord(fp);
		
		numberOfChildren = 4;
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	

		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 && offset2!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset2,SEEK_SET);
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}

		if (offset3 && offset3!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset3,SEEK_SET);
	     children[2]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[2] = new EmptyNode(sectionOffset,this);
		}

		if (offset4 && offset4!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset4,SEEK_SET);
	     children[3]       = getChildType(sectionOffset,this,fp,object);
		 if (children[3] == this)
		 {
			 children[3] = new EmptyNode(sectionOffset,this);
		 }
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[3] = new EmptyNode(sectionOffset,this);
		}
}



int NodeAICR2::Write(FILE *fp,int secOffset) 
{
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)
	UPDATE_WR_OFFSET(offset2,1)

	int foff = ftell(fp);
	sendCommandVal(fp,0x8000000a);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);	
	WritePCDWord(fp,number3);	
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset1);
	WritePCDWord(fp,offset2);
	return foff;
}

void NodeAICR2::Read(FILE *fp)
{
		
		number1               = ReadPCDWord(fp);
		number2               = ReadPCDWord(fp);		
		number3               = ReadPCDWord(fp);
		number4               = ReadPCDWord(fp);
		number5               = ReadPCDWord(fp);
		offset1               = ReadPCDWord(fp);
		offset2               = ReadPCDWord(fp);
		
		numberOfChildren = 2;
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	
		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 && offset2!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset2,SEEK_SET);
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}



}

void NodeThreeICR2::Read(FILE *fp)
{
}

int NodeSixICR2::Write(FILE *fp,int secOffset) 
{
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)
	UPDATE_WR_OFFSET(offset2,1)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000006);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);	
	WritePCDWord(fp,number3);	
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset1);
	WritePCDWord(fp,offset2);
	return foff;
}

void NodeSixICR2::Read(FILE *fp)
{
	     number1               = ReadPCDWord(fp);
		 number2               = ReadPCDWord(fp);		
		 number3               = ReadPCDWord(fp);
		 number4               = ReadPCDWord(fp);
		 number5               = ReadPCDWord(fp);
		 offset1               = ReadPCDWord(fp);
		 offset2               = ReadPCDWord(fp);
		
		numberOfChildren = 2;
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	
		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 && offset2!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset2,SEEK_SET);
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}

		
}

int NodeEightICR2::Write(FILE *fp,int secOffset) 
{
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)
	UPDATE_WR_OFFSET(offset2,1)
	UPDATE_WR_OFFSET(offset3,2)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000008);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);	
	WritePCDWord(fp,number3);	
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset1);
	WritePCDWord(fp,offset2);
	WritePCDWord(fp,offset3);
	return foff;
}

void NodeEightICR2::Read(FILE *fp)
{
	    int number1               = ReadPCDWord(fp);
		int number2               = ReadPCDWord(fp);		
		int number3               = ReadPCDWord(fp);
		int number4               = ReadPCDWord(fp);
		int number5               = ReadPCDWord(fp);
		int offset1               = ReadPCDWord(fp);
		int offset2               = ReadPCDWord(fp);
		int offset3               = ReadPCDWord(fp);
		
		numberOfChildren = 3;
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	
		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 && offset2!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset2,SEEK_SET);
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}

		if (offset3 && offset3!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset3,SEEK_SET);
	     children[2]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[2] = new EmptyNode(sectionOffset,this);
		}
}

int NodeBICR2::Write(FILE *fp,int secOffset) 
{
	int offsetA;
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);
	int foff = ftell(fp);
	sendCommandVal(fp,0x8000000b);
	WritePCDWord(fp,numberOfChildren);
	for(int i=0;i<numberOfChildren;i++)
	{
		 UPDATE_WR_OFFSET(offsetA,i)
		 WritePCDWord(fp,offsetA);
	}
	return foff;
}

void NodeBICR2::Read(FILE *fp)
{
	    numberOfChildren       = ReadPCDWord(fp);		
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));	
		
		for(int i=0;i<numberOfChildren;i++)
		{
		 int offset1= ReadPCDWord(fp);
		 if (offset1 && offset1!=-1)
		 {
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
		 int cmd       = ReadPCDWord(fp);
		 if (cmd!=0)
		 {
		  fseek(fp,getOffset()+offset1,SEEK_SET);
	      children[i]       = getChildType(sectionOffset,this,fp,object);
		 }
		 else
		 {
		  children[i] = new EmptyNode(sectionOffset,this);
		 }
		  fseek(fp,ltoff,SEEK_SET);
		 }
		 else
		 {
		  children[i] = new EmptyNode(sectionOffset,this);
		 }
		}
}

int NodeNineICR2::Write(FILE *fp,int secOffset) 
{
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)
	UPDATE_WR_OFFSET(offset2,1)
	UPDATE_WR_OFFSET(offset3,2)
	UPDATE_WR_OFFSET(offset4,3)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000009);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);	
	WritePCDWord(fp,number3);	
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset1);
	WritePCDWord(fp,offset2);
	WritePCDWord(fp,offset3);
	WritePCDWord(fp,offset4);
	return foff;
}

void NodeNineICR2::Read(FILE *fp)
{
	     number1               = ReadPCDWord(fp);
		 number2               = ReadPCDWord(fp);		
		 number3               = ReadPCDWord(fp);
		 number4               = ReadPCDWord(fp);
		 number5               = ReadPCDWord(fp);
		 offset1               = ReadPCDWord(fp);
		 offset2               = ReadPCDWord(fp);
		 offset3               = ReadPCDWord(fp);
		 offset4               = ReadPCDWord(fp);
		
		numberOfChildren = 4;
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	
		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}

		if (offset2 && offset2!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset2,SEEK_SET);
	     children[1]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1] = new EmptyNode(sectionOffset,this);
		}

		if (offset3 && offset3!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset3,SEEK_SET);
	     children[2]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[2] = new EmptyNode(sectionOffset,this);
		}

		if (offset4 && offset4!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset4,SEEK_SET);
	     children[3]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[3] = new EmptyNode(sectionOffset,this);
		}
}

void NodeCICR2::Read(FILE *fp)
{
	AfxMessageBox("Node C Read");
}

int NodeSevenICR2::Write(FILE *fp,int secOffset)
{
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)
	UPDATE_WR_OFFSET(offset2,1)
	UPDATE_WR_OFFSET(offset3,2)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000007);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);	
	WritePCDWord(fp,number3);	
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset1);
	WritePCDWord(fp,offset2);
	WritePCDWord(fp,offset3);
	return foff;
   }

int NodeFiveICR2::Write(FILE *fp,int secOffset)
{
    sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000005);
	WritePCDWord(fp,number1);
	WritePCDWord(fp,number2);	
	WritePCDWord(fp,number3);	
	WritePCDWord(fp,number4);
	WritePCDWord(fp,number5);
	WritePCDWord(fp,offset1);

	return foff;
}

void NodeFourICR2::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	   if (number == 45)
	   {
	   CMy3DOEditorView *view = (CMy3DOEditorView*)doview;

	   GLdouble wx,wy,wz;

	   wx = wy = wz = 0;

	   if (!view->GetDocument()->showObjects) return;
	   static BOOL found=TRUE;

	   if (view->GetDocument()->showSubObjectLocations)
	   {
       glPointSize(5.0f);
	   glBegin(GL_POINTS);	   
	   glVertex3d(wx,wy,wz);
	   glEnd();
	   glPointSize(1.0f);
	   }
	   glPushMatrix();
	   
	   if (subObject == NULL)
	   {
	    CString name="Unknown";
	    if (string_offset >= 0 && string_offset<getObject()->strs->size())
		{
	    CImageFile *file = (CImageFile*)getObject()->strs->elementAt(string_offset+1);
	    name = file->filename;
		}
		if (!stricmp(name,"horiz") || !stricmp(name,"sky")) 
		{
		   glPopMatrix();
		   return;
		}
		subObject = object->FindObjectFile(name);
		if (subObject){
		}
        else{
		   cerr << "Failed to load subObject " << name << endl;
		   found=FALSE;
		}
	   }

	   if (subObject)
	   {
		 subObject->GetFile(FALSE);
		 if (subObject->topDrawlocation)
		 {
		   //subObject->topDrawlocation->DrawGL(hdc,subObject,doview,currentTexture);
		   for(int i=0;i<subObject->topDrawlocation->size();i++)
		   {
			  Node * topDraw = (Node*) subObject->topDrawlocation->elementAt(i);
			  topDraw->DrawGL(hdc,subObject,doview,currentTexture);
		   }
		 }
	   }
	   
	   glPopMatrix();
	   }
	   else
	   {
		   Node::DrawGL(hdc,object,doview,currentTexture);
	   }
}

int NodeFourICR2::Write(FILE *fp,int secOffset)
{
	int offset1;
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offset1,0)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000004);
	WritePCDWord(fp,string_offset);
	WritePCDWord(fp,number);	
	WritePCDWord(fp,offset1);
	return foff;
}

//int NodePolygonOneICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodePolygonOneICR2"); return -1;}
//int NodePolygonTwoICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodePolygonTwoICR2"); return -1;}
int NodeThreeICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeThreeICR2"); return -1;}
//int NodeFourICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeFourICR2"); return -1;}
//int NodeFiveICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeFiveICR2"); return -1;}
//int NodeSixICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeSixICR2"); return -1;}
//int NodeSevenICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeSevenICR2"); return -1;}
//int NodeEightICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeEightICR2"); return -1;}
//int NodeNineICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeNineICR2"); return -1;}
//int NodeAICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeAICR2"); return -1;}
//int NodeBICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeBICR2"); return -1;}
int NodeCICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeCICR2"); return -1;}
int NodeEICR2::Write(FILE *fp,int secOffset) {AfxMessageBox("Cannot Write NodeEICR2"); return -1;}

int NodeTwelveICR2::Write(FILE *fp,int secOffset) 
{
	int foff = ftell(fp);
	/*
	int offsetA=-1;
	sectionOffset = secOffset;
	WriteAllChildren(fp,secOffset);

	UPDATE_WR_OFFSET(offsetA,0)

	int foff = ftell(fp);
	sendCommandVal(fp,0x80000010);
	WritePCDWord(fp,offsetA);
	WritePCDWord(fp,(numberOfChildren-1));
	for(int i=0;i<(numberOfChildren-1);i++)
	{
		 UPDATE_WR_OFFSET(offsetA,(i+1))
		 WritePCDWord(fp,offsetA);
	}
	return foff;
	*/
	return foff;
}

void NodeTwelveICR2::Read(FILE *fp)
{
	    numberOfChildren = 1;
		 number1       = ReadPCDWord(fp);
		 number2       = ReadPCDWord(fp);
		 number3       = ReadPCDWord(fp);
		 number4       = ReadPCDWord(fp);
		 number5       = ReadPCDWord(fp);
		 number6       = ReadPCDWord(fp);
		int number7       = ReadPCDWord(fp);
		//int *offsets = new int[numberOfChildren];
		//numberOfChildren+=numberOfOffsets;

		/*
		children = (Node**)malloc(numberOfChildren*sizeof(Node*));
	
		if (offset1 && offset1!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offset1,SEEK_SET);
	     children[0]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[0] = new EmptyNode(sectionOffset,this);
		}
		*/

		/*
		for(int i=0;i<numberOfOffsets;i++)
		{
		 offsets[i] = ReadPCDWord(fp);
		 if (offsets[i] && offsets[i]!=-1)
		{
		 int ltoff = ftell(fp);
	     fseek(fp,getOffset()+offsets[i],SEEK_SET);
	     children[1+i]       = getChildType(sectionOffset,this,fp,object);
		 fseek(fp,ltoff,SEEK_SET);
		}
		else
		{
		 children[1+i] = new EmptyNode(sectionOffset,this);
		}
		}
		*/
}

CString NodeTwelveICR2::toString()
{
       CString buffer;
	   buffer.Format("Flavor=%x Children=%d  %d %d %d",type,numberOfChildren,number1,number2,number3);
	   //if (getObject()->showOffset)
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;
}

CString NodePolygonOneICR2::Export()  
{AfxMessageBox("Cannot Export NodePolygonOneICR2");return CString(" No Export");}
CString NodePolygonTwoICR2::Export()  
{AfxMessageBox("Cannot Export NodePolygonTwoICR2");return CString(" No Export");}
CString NodeThreeICR2::Export()  
{AfxMessageBox("Cannot Export NodeThreeICR2");return CString(" No Export");}
CString NodeFourICR2::Export()  
{AfxMessageBox("Cannot Export NodeFourICR2");return CString(" No Export");}
CString NodeFiveICR2::Export()  
{AfxMessageBox("Cannot Export NodeFiveICR2");return CString(" No Export");}
CString NodeSixICR2::Export()  
{AfxMessageBox("Cannot Export NodeSixICR2");return CString(" No Export");}
CString NodeEightICR2::Export()  
{AfxMessageBox("Cannot Export NodeEightICR2");return CString(" No Export");}
CString NodeSevenICR2::Export()  
{AfxMessageBox("Cannot Export NodeSevenICR2");return CString(" No Export");}
CString NodeNineICR2::Export()  
{AfxMessageBox("Cannot Export NodeNineICR2");return CString(" No Export");}
CString NodeAICR2::Export()  
{AfxMessageBox("Cannot Export NodeAICR2");return CString(" No Export");}
CString NodeBICR2::Export()  
{AfxMessageBox("Cannot Export NodeBICR2");return CString(" No Export");}
CString NodeCICR2::Export()  
{AfxMessageBox("Cannot Export NodeCICR2");return CString(" No Export");}
CString NodeEICR2::Export()  
{AfxMessageBox("Cannot Export NodeEICR2");return CString(" No Export");}



