
#include "stdafx.h"
#include "NodeRepository.h"
#include <iostream.h>
#include "Node.h"
#include "ObjectTree.h"
#include "Observer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


NodeRepository::NodeRepository(): Observer(t_repository)
{
	repository = new CNodeMap(16384);
	treemap = new CTreeMap(10);
}

NodeRepository::~NodeRepository()
{
	RemoveAllNodes();
	if (treemap) {
		delete treemap;
		treemap = NULL;
	}
	if (repository) {
		delete repository;
		repository = NULL;
	}
}

void NodeRepository::RemoveAllNodes()
{
	if (repository)
	{
	 POSITION pos = repository->GetStartPosition();

	 while(pos !=NULL)
	 {
		int key;
		Node *ptr;
		repository->GetNextAssoc(pos,key,ptr);
		delete ptr;
	 }
	}
}

void NodeRepository::LoadTree(HTREEITEM parent,CObjectTree *tree)
{
	

	if (sortRepositoryType == 1)
	{
		CString text2(CString("Flavor 2 (Polygon)") + CString(getTypeNumberStr(0x2)));
		HTREEITEM flav2 = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)text2,TO_ID(IDB_FOLDER));	    
		HTREEITEM flav3 = tree->insertInfoNode(parent, "Flavor 3 (Srb)",TO_ID(IDB_FOLDER));
		HTREEITEM flavA03 = tree->insertInfoNode(parent, "Flavor A03 (Srb)",TO_ID(IDB_FOLDER));
		HTREEITEM flav4 = tree->insertInfoNode(parent, "Flavor 4 (Multi Node Parent)",TO_ID(IDB_FOLDER));
		HTREEITEM flav5 = tree->insertInfoNode(parent, "Flavor 5",TO_ID(IDB_FOLDER));
		HTREEITEM flav6 = tree->insertInfoNode(parent, "Flavor 6",TO_ID(IDB_FOLDER));
		HTREEITEM flav7 = tree->insertInfoNode(parent, "Flavor 7",TO_ID(IDB_FOLDER));
		HTREEITEM flav8 = tree->insertInfoNode(parent, "Flavor 8",TO_ID(IDB_FOLDER));
		HTREEITEM flav9 = tree->insertInfoNode(parent, "Flavor 9",TO_ID(IDB_FOLDER));
		HTREEITEM flavA = tree->insertInfoNode(parent, "Flavor A",TO_ID(IDB_FOLDER));
		HTREEITEM flavB = tree->insertInfoNode(parent, "Flavor B",TO_ID(IDB_FOLDER));
		HTREEITEM flavC = tree->insertInfoNode(parent, "Flavor C",TO_ID(IDB_FOLDER));
		HTREEITEM flavD = tree->insertInfoNode(parent, "Flavor D",TO_ID(IDB_FOLDER));
		HTREEITEM flavE = tree->insertInfoNode(parent, "Flavor E",TO_ID(IDB_FOLDER));
		CString textF(CString("Flavor F ") + CString(getTypeNumberStr(0xF)));
		HTREEITEM flavF = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)textF,TO_ID(IDB_FOLDER));
		HTREEITEM flav10 = tree->insertInfoNode(parent, "Flavor 10",TO_ID(IDB_FOLDER));
		HTREEITEM flav11 = tree->insertInfoNode(parent, "Flavor 11",TO_ID(IDB_FOLDER));
		HTREEITEM flav12 = tree->insertInfoNode(parent, "Flavor 12",TO_ID(IDB_FOLDER));
		HTREEITEM flav13 = tree->insertInfoNode(parent, "Flavor 13",TO_ID(IDB_FOLDER));
		HTREEITEM flav14 = tree->insertInfoNode(parent, "Flavor 14",TO_ID(IDB_FOLDER));
		CString text15(CString("Flavor 15 ") + CString(getTypeNumberStr(0x15)));
		HTREEITEM flav15 = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)text15,TO_ID(IDB_FOLDER));
		HTREEITEM flav16 = tree->insertInfoNode(parent, "Flavor 16",TO_ID(IDB_FOLDER));
		HTREEITEM flav17 = tree->insertInfoNode(parent, "Flavor 17",TO_ID(IDB_FOLDER));
		HTREEITEM flav18 = tree->insertInfoNode(parent, "Flavor 18",TO_ID(IDB_FOLDER));
		HTREEITEM flav19 = tree->insertInfoNode(parent, "Flavor 19",TO_ID(IDB_FOLDER));
		HTREEITEM flav1C = tree->insertInfoNode(parent, "Flavor 1C (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav1F = tree->insertInfoNode(parent, "Flavor 1F (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav20 = tree->insertInfoNode(parent, "Flavor 20 (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav21 = tree->insertInfoNode(parent, "Flavor 21 (Polygon)",TO_ID(IDB_FOLDER));

		HTREEITEM flav815 = tree->insertInfoNode(parent, "Flavor 815 (Line)",TO_ID(IDB_FOLDER));
		HTREEITEM flav81B = tree->insertInfoNode(parent, "Flavor 81B (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav81C = tree->insertInfoNode(parent, "Flavor 81C (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav81D = tree->insertInfoNode(parent, "Flavor 81D (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav81E = tree->insertInfoNode(parent, "Flavor 81E (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav81F = tree->insertInfoNode(parent, "Flavor 81F (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav820 = tree->insertInfoNode(parent, "Flavor 820 (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav821 = tree->insertInfoNode(parent, "Flavor 821 (Polygon)",TO_ID(IDB_FOLDER));

		HTREEITEM flav8001 = tree->insertInfoNode(parent, "Flavor 8000001 (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8002 = tree->insertInfoNode(parent, "Flavor 8000002 (Polygon)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8003 = tree->insertInfoNode(parent, "Flavor 8000003 (pmp (srb?))",TO_ID(IDB_FOLDER));
		HTREEITEM flav8004 = tree->insertInfoNode(parent, "Flavor 8000004 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8005 = tree->insertInfoNode(parent, "Flavor 8000005 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8006 = tree->insertInfoNode(parent, "Flavor 8000006 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8007 = tree->insertInfoNode(parent, "Flavor 8000007 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8008 = tree->insertInfoNode(parent, "Flavor 8000008 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8009 = tree->insertInfoNode(parent, "Flavor 8000009 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav800a = tree->insertInfoNode(parent, "Flavor 800000a (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav800b = tree->insertInfoNode(parent, "Flavor 800000b(Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav800c = tree->insertInfoNode(parent, "Flavor 800000c (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav800d = tree->insertInfoNode(parent, "Flavor 800000d (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav800e = tree->insertInfoNode(parent, "Flavor 800000e (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav800f = tree->insertInfoNode(parent, "Flavor 800000f (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8010 = tree->insertInfoNode(parent, "Flavor 8000010 (Unk)",TO_ID(IDB_FOLDER));
		HTREEITEM flav8012 = tree->insertInfoNode(parent, "Flavor 8000012 (Unk)",TO_ID(IDB_FOLDER));


		treemap->SetAt(0x2,flav2);
		treemap->SetAt(0x3,flav3);
		treemap->SetAt(0xA03,flavA03);
		treemap->SetAt(0x4,flav4);
		treemap->SetAt(0x5,flav5);
		treemap->SetAt(0x6,flav6);
		treemap->SetAt(0x7,flav7);
		treemap->SetAt(0x8,flav8);
		treemap->SetAt(0x9,flav9);
		treemap->SetAt(0xA,flavA);
		treemap->SetAt(0xB,flavB);
		treemap->SetAt(0xC,flavC);
		treemap->SetAt(0xD,flavD);
		treemap->SetAt(0xE,flavE);
		treemap->SetAt(0xF,flavF);
		treemap->SetAt(0x10,flav10);
		treemap->SetAt(0x11,flav11);
		treemap->SetAt(0x12,flav12);
		treemap->SetAt(0x13,flav13);
		treemap->SetAt(0x14,flav14);
		treemap->SetAt(0x15,flav15);
		treemap->SetAt(0x16,flav16);
		treemap->SetAt(0x17,flav17);
		treemap->SetAt(0x18,flav18);
		treemap->SetAt(0x19,flav19);
		treemap->SetAt(0x20,flav20);
		treemap->SetAt(0x1C,flav1C);
		treemap->SetAt(0x1F,flav1F);

		treemap->SetAt(0x815,flav815);
		treemap->SetAt(0x81B,flav81B);
		treemap->SetAt(0x81C,flav81C);
		treemap->SetAt(0x81D,flav81D);
		treemap->SetAt(0x81E,flav81E);
		treemap->SetAt(0x81F,flav81F);
		treemap->SetAt(0x820,flav820);
		treemap->SetAt(0x821,flav821);

		treemap->SetAt(0x80000001,flav8001);
		treemap->SetAt(0x80000002,flav8002);
		treemap->SetAt(0x80000003,flav8003);
		treemap->SetAt(0x80000004,flav8004);
		treemap->SetAt(0x80000005,flav8005);
		treemap->SetAt(0x80000006,flav8006);
		treemap->SetAt(0x80000007,flav8007);
		treemap->SetAt(0x80000008,flav8008);
		treemap->SetAt(0x80000009,flav8009);
		treemap->SetAt(0x8000000a,flav800a);
		treemap->SetAt(0x8000000b,flav800b);
		treemap->SetAt(0x8000000c,flav800c);
		treemap->SetAt(0x8000000d,flav800d);
		treemap->SetAt(0x8000000e,flav800e);
		treemap->SetAt(0x8000000f,flav800f);
		treemap->SetAt(0x80000010,flav8010);
		treemap->SetAt(0x80000012,flav8012);
		
	}

	POSITION pos = repository->GetStartPosition();

	while(pos !=NULL)
	{
		int key;
		Node *ptr;
		repository->GetNextAssoc(pos,key,ptr);
		if (sortRepositoryType == 0)
		{
		HTREEITEM treeNode = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)ptr->toString(),TO_ID(ptr->bitmapid));
	    tree->m_ObjectTree.SetItemData(treeNode,(DWORD)ptr);
		}
		else
		{
			HTREEITEM par;
			if (treemap->Lookup(ptr->type,par))
			{
			 HTREEITEM treeNode = tree->insertInfoNode(par, (LPSTR)(LPCSTR)ptr->toString(),TO_ID(ptr->bitmapid));
			 tree->m_ObjectTree.SetItemData(treeNode,(DWORD)ptr);
			}
			else
			{
				CString msg;
				msg.Format("Node %x could not be place in the tree",ptr->type);
				cerr << msg << endl;
			}
		}
	}
}

int NodeRepository::getTypeNumber(int type)
{
	POSITION pos = repository->GetStartPosition();
	int count = 0;

	while(pos !=NULL)
	{
		int key;
		Node *ptr;
		repository->GetNextAssoc(pos,key,ptr);
		if (ptr->type == type) count++;
	}
	return count;
}

void NodeRepository::Expand(CObjectTree *tree,HTREEITEM node)
{
		   if (subTree){
			   tree->m_ObjectTree.DeleteItem(subTree);
			   LoadTree(node,tree);
			   subTree = NULL;
		   }
}


BOOL NodeRepository::addNode(Node *ptr,int offset)
{
		ptr->refCount++;
	    repository->SetAt(offset,ptr);
		return TRUE;
}


Node* NodeRepository::FindNode(int offset)
{
		Node *ptr;
		if (repository->Lookup(offset,ptr))
		{
			return ptr;
		}
		return NULL;
}


