
#ifndef _INLCUDED_NODE_REFERENCE_
#define _INLCUDED_NODE_REFERENCE_

#include <afxtempl.h>

class Node;
class CObjectTree;
#include "Observer.h"

typedef CMap<int, int, Node*, Node*&> CNodeMap;
typedef CMap<int, int, HTREEITEM, HTREEITEM&> CTreeMap;


class NodeReference: public CObject
{
public:
	  NodeReference()
	  {
		  refCount = 0;
		  offset = -99;
		  nodeptr = NULL;
	  }

	  int refCount;
	  Node * nodeptr;
	  int offset;
};

/*
class CNodeMap
{
public:
	CNodeMap(int initsize);
	~CNodeMap();

	void SetAt(int offset,Node *ptr);
	BOOL Lookup(int offset,Node *ptr);

	NodeReference *entries;
	int mallocedSize;
	int Size;
};
*/

class NodeRepository: public Observer
{
public:
	 NodeRepository();
	 ~NodeRepository();
	 
	 BOOL addNode(Node *ptr,int offset);
	 //int isNode(int offset);
	 //Node* GetNode(int idx)
	 Node* FindNode(int offset);

	 CString getTypeNumberStr(int type)
	 {
		 CString msg;
		 msg.Format("%d",getTypeNumber(type));
		 return msg;
	 }

	 int getTypeNumber(int type);

	 void RemoveAllNodes();

	 void LoadTree(HTREEITEM parent,CObjectTree *tree);

	 void Expand(CObjectTree *tree,HTREEITEM node);

	 HTREEITEM subTree;

	 CNodeMap *repository;
	 CTreeMap *treemap;

	 int sortRepositoryType;
};

#endif