
#ifndef _INLCUDED_NODE_REFERENCE_
#define _INLCUDED_NODE_REFERENCE_

#include <map>

class Node;

typedef map<string, int> NODEMAP;

class NodeReference
{
public:
	  NodeReference()
	  {
		  refCount = 0;
		  offset = -99;
		  nodeptr = NULL;
	  }

	  int refCount;
	  Node * nodeptr;
	  int offset;
};

class NodeRepository
{
public:
	 NodeRepository()
	 {
		numberNodes = 0;
		mallocNodes = 32768;
		repository = (NodeReference *)malloc(mallocNodes*sizeof(NodeReference));
	 }


	 BOOL addNode(Node *ptr,int offset);

	 int isNode(int offset)
	 {
	   for(int i=0;i<numberNodes;i++)
	   {
		  if (repository[i].offset == offset) 
		  {
			  return i;
		  }
	  }
	  return -1;
	 }

	 Node* GetNode(int idx)
	 {
	   return repository[idx].nodeptr;
	 }

	 int mallocNodes;
	 int numberNodes;
	 NodeReference *repository;
	 
};

#endif