#include "stdafx.h"
#include "Node.h"

#include "EditTwoVar.h"
#include "EditOneVar.h"
#include "3DOEditorView.h"


BOOL NodeSelection5::Edit()
{
	CEditTwoVar *dlg = new CEditTwoVar();

	dlg->m_VarVal1 = string_offset;
	dlg->m_VarVal2 = displayClass;
	dlg->m_Var1.Format("String Offset");
	dlg->m_Var2.Format("Display Class");
	dlg->m_Desc.Format("Texture Selection for Polygon\nString offset is ptr to name of mip file");
	
	int result = dlg->DoModal();

	if (result == IDOK)
	{
		string_offset = dlg->m_VarVal1;
		displayClass = dlg->m_VarVal2;
	}

	if (dlg) delete dlg;
	return TRUE;
}


BOOL NodeSelection4::Edit()
{
	CEditOneVar *dlg = new CEditOneVar();

	dlg->m_VarVal1 = displayClass;
	dlg->m_Var1.Format("displayClass");
	dlg->m_Desc.Format("Texture Selection for Polygon\nString offset is ptr to name of mip file");
	
	int result = dlg->DoModal();

	if (result == IDOK)
	{
		displayClass = dlg->m_VarVal1;
	}

	if (dlg) delete dlg;
	return TRUE;
}

CString NodeSelection1::toString()
{
       CString buffer;
	   CString name = getObject()->findStrName(string_offset);
	   buffer.Format("Flavor=%d subtype=%d Children=%d String_offset=%d(%s)",type,1,numberOfChildren,string_offset,name);
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;
}

CString NumToDisplayClass(int cla)
{
	CString msg;
	switch(cla)
	{
		case 0:
			msg.Format("Track Texture");break;
		case 1:
			msg.Format("Terrain Texture");break;
		case 2:
			msg.Format("Walls Texture");break;
		case 3:
			msg.Format("Object/Building");break;
		case 4:
			msg.Format("Car");break;
		case 9:
			msg.Format("Unknown in Object");break;
	    case 10:
			msg.Format("Extra Track Textures (Starting line/Grid)");break;
		case 13:
			msg.Format("Unknown in Car");break;
		case 17:
			msg.Format("Drivers Hands/Unknown in Car");break;
		case 18:
			msg.Format("Unknown in Car");break;
		case 19:
			msg.Format("Driver Texture");break;
		case 20:
			msg.Format("Driving Line");break;
		case 30:
			msg.Format("Fence");break;
		default:
			CString msg;
			msg.Format("Unknown Display Class= %d 0x%x",cla,cla);
			//AfxMessageBox(msg);
			cerr << msg << endl;
	}
	return CString(msg);
}

BOOL Node::DrawDisplayClass(CView *doview,int display_Class)
{
	CMy3DOEditorView *view = (CMy3DOEditorView*)doview;
	switch(display_Class)
	{
		case 0: if (!view->GetDocument()->showRoads) return FALSE;
			break;				
		case 1: if (!view->GetDocument()->showGrass) return FALSE;				
			break;
		case 2: if (!view->GetDocument()->showWalls) return FALSE;				
			break;
		case 3: if (!view->GetDocument()->showSubObjects) return FALSE;
			break;
		case 4: if (!view->GetDocument()->showCar) return FALSE;			
			break;
		case 5: if (!view->GetDocument()->showHorizon) return FALSE;			
			break;
		case 6: if (!view->GetDocument()->showCrowds) return FALSE;				
			break;
		case 7: if (!view->GetDocument()->showClouds) return FALSE;			
			break;
		case 8: if (!view->GetDocument()->showTrees) return FALSE;			
			break;
		case 9: if (!view->GetDocument()->showBillboard) return FALSE;			
			break;
		case 20:
		case 10: if (!view->GetDocument()->showBrakeMarks) return FALSE;			
			break;
		case 11: if (!view->GetDocument()->showVehicles) return FALSE;			
			break;
		case 12: if (!view->GetDocument()->showInfield) return FALSE;			
			break;
		case 15: if (!view->GetDocument()->showPeople) return FALSE;			
			break;
		case 30: if (!view->GetDocument()->showFence) return FALSE;				
			break;
	}
	return TRUE;
}

void NodeSelection4::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	if (DrawDisplayClass(doview,displayClass))
	{
		Node::DrawGL(hdc,object,doview,currentTexture);
	}
}

CString NodeSelection4::toString()
{
       CString buffer;
	   //CString name = getObject()->findStrName(string_offset);
	   CString displayClassStr = NumToDisplayClass(displayClass);
	   buffer.Format("Flavor=%d subtype=%d Children=%d Display Class=%d(%s)",type,4,numberOfChildren,displayClass,displayClassStr);
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;
}

CString NodeSelection5::toString()
{
       CString buffer;
	   CString name = getObject()->findStrName(string_offset);
	   CString displayClassStr = NumToDisplayClass(displayClass);
	   buffer.Format("Flavor=%d subtype=%d Children=%d Display Class=%d(%s) String_offset=%d(%s)",type,5,numberOfChildren,displayClass,displayClassStr,string_offset,name);
	   {
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	   return buffer;
}

NodeSelection0c::NodeSelection0c(int secionOffset,Node *parent,int offset):
Node(secionOffset,parent,0x5),child_offset(offset)
{
}

void NodeSelection0c::Read(FILE *fp)
   {
	   number1 = -1;
	   number2 = -1;
	   number3 = -1;
	   number4 = -1.0;
	   string_offset        = ReadPCDWord(fp);
	   
	   if (string_offset == 10 || string_offset == 30)
	   {
		 number4              = ReadPCFloat(fp);
	   }
	   else
	   {
		 number1              = ReadPCDWord(fp);
		 if (number1 == 0xA || number1 == 5)
		 {
			number4              = ReadPCFloat(fp);
		 }
		 else
		 {
			number2              = ReadPCDWord(fp);
			if (number2 ==0xA)
			{
				number4              = ReadPCFloat(fp);
			}
		 }
	   }
	   
	   

	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

   }

int NodeSelection0c::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     child_offset=children[0]->writingOffset-getOffset();
	   }
	   else {
		 child_offset = -1;
	   }

	   int foff = ftell(fp);
	   sendCommandVal(fp,0x5);
	   WritePCDWord(fp,child_offset);
	   WritePCDWord(fp,0x0c);
	   WritePCDWord(fp,string_offset);
	   if (string_offset== 10 || string_offset == 30)
	   {	     
	     WritePCFloat(fp,number4);
	   }
	   else if (number1 == 0xA || number1 == 5)
	   {
	     WritePCDWord(fp,number1);
		 WritePCFloat(fp,number4);
	   }
	   else if (number2 == 0xA)
	   {
	     WritePCDWord(fp,number1);
		 WritePCDWord(fp,number2);
		 WritePCFloat(fp,number4);
	   }	   
	   return foff;
   }

CString NodeSelection0c::toString()
{
	CString buffer;
	//CString name = getObject()->findStrName(string_offset);
	buffer.Format("Flavor=%d subtype=%d String_Offset=%d Number1=%d Number2=%d Number3=%d Number4=%2.2f",type,0xc,string_offset,number1,number2,number3,number4);
	{
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	 }
	return buffer;
}

NodeSelection0d::NodeSelection0d(int secionOffset,Node *parent,int offset):
Node(secionOffset,parent,0x5),child_offset(offset)
{
}

void NodeSelection0d::Read(FILE *fp)
   {
	   string_offset        = ReadPCDWord(fp);
	   number1              = ReadPCDWord(fp);
	   number2              = ReadPCDWord(fp);
	   number4              = ReadPCFloat(fp);

	   //string_offset = 358;

	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);	   	
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

   }

int NodeSelection0d::Write(FILE *fp,int secOffset)
{
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     child_offset=children[0]->writingOffset-getOffset();
	   }
	   else {
		 child_offset = -1;
	   }

	   int foff = ftell(fp);
	   sendCommandVal(fp,0x5);
	   WritePCDWord(fp,child_offset);
	   WritePCDWord(fp,0x0d);
	   WritePCDWord(fp,string_offset);
	   WritePCDWord(fp,number1);
	   WritePCDWord(fp,number2);
	   WritePCFloat(fp,number4);
	   return foff;
}

CString NodeSelection0d::toString()
{
	CString buffer;
	//CString name = getObject()->findStrName(string_offset);
	buffer.Format("Flavor=%d subtype=%d Children=%d String=%d Number=%d Number1=%d Number2=%d",type,0xd,numberOfChildren,string_offset,number1,number2);
	{
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	return buffer;
}

NodeSelection20::NodeSelection20(int secionOffset,Node *parent,int offset):
Node(secionOffset,parent,0x5),child_offset(offset)
{
}

void NodeSelection20::Read(FILE *fp)
   {
	   string_offset        = ReadPCDWord(fp);
	   //number1              = ReadPCDWord(fp);
	   //number2              = ReadPCDWord(fp);
	   //number3              = ReadPCDWord(fp);

	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

   }

int NodeSelection20::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     child_offset=children[0]->writingOffset-getOffset();
	   }
	   else {
		 child_offset = -1;
	   }

	   int foff = ftell(fp);
	   sendCommandVal(fp,0x5);
	   WritePCDWord(fp,child_offset);
	   WritePCDWord(fp,0x20);
	   WritePCDWord(fp,string_offset);
	   //WritePCDWord(fp,number1);
	   //WritePCDWord(fp,number2);
	   //WritePCDWord(fp,number3);
	   return foff;
   }

CString NodeSelection20::toString()
{
	CString buffer;
	//CString name = getObject()->findStrName(string_offset);
	buffer.Format("Flavor=%d subtype=%d Children=%d String=%d Number=%d Number1=%d Number2=%d Number3=%d",type,0x20,numberOfChildren,string_offset,number1,number2,number3);
	{
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	return buffer;
}

void NodeSelection1::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	Node::DrawGL(hdc,object,doview,string_offset);
}

void NodeSelection5::DrawGL(HDC hdc,C3do* object,CView *doview,int currentTexture)
{
	if (DrawDisplayClass(doview,displayClass))
	{
        Node::DrawGL(hdc,object,doview,string_offset);
	}
}

NodeSelection24::NodeSelection24(int secionOffset,Node *parent,int offset):
Node(secionOffset,parent,0x5),child_offset(offset)
{
}

void NodeSelection24::Read(FILE *fp)
   {
	   string_offset        = ReadPCDWord(fp);
	   number1              = ReadPCDWord(fp);
	   //number2              = ReadPCDWord(fp);

	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);	   	
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos =getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

   }

int NodeSelection24::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     child_offset=children[0]->writingOffset-getOffset();
	   }
	   else {
		 child_offset = -1;
	   }

	   int foff = ftell(fp);
	   sendCommandVal(fp,0x5);
	   WritePCDWord(fp,child_offset);
	   WritePCDWord(fp,0x24);
	   WritePCDWord(fp,string_offset);
	   WritePCDWord(fp,number1);
	   //WritePCDWord(fp,number2);
	   return foff;
   }

CString NodeSelection24::toString()
{
	CString buffer;
	//CString name = getObject()->findStrName(string_offset);
	buffer.Format("Flavor=%d subtype=%d Children=%d String=%d Number=%d Number1=%d Number2=%d",type,0x24,numberOfChildren,string_offset,number1,number2);
	{
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	return buffer;
}

NodeSelection2c::NodeSelection2c(int secionOffset,Node *parent,int offset):
Node(secionOffset,parent,0x5),child_offset(offset)
{
}

void NodeSelection2c::Read(FILE *fp)
   {
	   number1 = -1;
	   number2 = -1;
	   number3 = -1;
	   number4 = -1.0;
	   string_offset        = ReadPCDWord(fp);
	   
	   if (string_offset == 0xA)
	   {
		 number4              = ReadPCFloat(fp);
	   }
	   else
	   {
		 number1              = ReadPCDWord(fp);
		 if (number1 == 0xA)
		 {
			number4              = ReadPCFloat(fp);
		 }
		 else
		 {
			number2              = ReadPCDWord(fp);
			if (number2 ==0xA)
			{
				number4              = ReadPCFloat(fp);
			}
		 }
	   }

	  
	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

   }

int NodeSelection2c::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     child_offset=children[0]->writingOffset-getOffset();
	   }
	   else {
		 child_offset = -1;
	   }

	   int foff = ftell(fp);
	   sendCommandVal(fp,0x5);
	   WritePCDWord(fp,child_offset);
	   WritePCDWord(fp,0x2c);
	   	   WritePCDWord(fp,string_offset);
	   if (string_offset== 0xA)
	   {	     
	     WritePCFloat(fp,number4);
	   }
	   else if (number1 == 0xA)
	   {
	     WritePCDWord(fp,number1);
		 WritePCFloat(fp,number4);
	   }
	   else if (number2 == 0xA)
	   {
	     WritePCDWord(fp,number1);
		 WritePCDWord(fp,number2);
		 WritePCFloat(fp,number4);
	   }
	   return foff;
   }

CString NodeSelection2c::toString()
{
	CString buffer;
	//CString name = getObject()->findStrName(string_offset);
	buffer.Format("Flavor=%d subtype=%d Children=%d Number=%d Number1=%d Number2=%d",type,0x2c,numberOfChildren,string_offset,number1,number2);
	{
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	   }
	return buffer;
}


NodeSelection8::NodeSelection8(int secionOffset,Node *parent,int offset):
Node(secionOffset,parent,0x5),child_offset(offset)
{
}

void NodeSelection8::Read(FILE *fp)
   {
	   number1 = -1;
	   number2 = -1;
	   number3 = -1;
	   number4 = -1.0;
	   string_offset        = ReadPCDWord(fp);
	   
	   if (string_offset == 10 || string_offset == 30)
	   {
		 number4              = ReadPCFloat(fp);
	   }
	   else
	   {
		 number1              = ReadPCDWord(fp);
		 if (number1 == 0xA)
		 {
			number4              = ReadPCFloat(fp);
		 }
		 else
		 {
			number2              = ReadPCDWord(fp);
			if (number2 ==0xA)
			{
				number4              = ReadPCFloat(fp);
			}
		 }
	   }
	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);	   	
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos =getOffset()+child_offset; 
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

   }

int NodeSelection8::Write(FILE *fp,int secOffset)
   {
	   sectionOffset = secOffset;
	   WriteAllChildren(fp,secOffset);

	   if (children[0]->writingOffset!=-1){
	     child_offset=children[0]->writingOffset-getOffset();
	   }
	   else {
		 child_offset = -1;
	   }

	   int foff = ftell(fp);
	   sendCommandVal(fp,0x5);
	   WritePCDWord(fp,child_offset);
	   WritePCDWord(fp,0x08);
	   WritePCDWord(fp,string_offset);
	   if (string_offset== 10 || string_offset == 30)
	   {	     
	     WritePCFloat(fp,number4);
	   }
	   else if (number1 == 0xA)
	   {
	     WritePCDWord(fp,number1);
		 WritePCFloat(fp,number4);
	   }
	   else if (number2 == 0xA)
	   {
	     WritePCDWord(fp,number1);
		 WritePCDWord(fp,number2);
		 WritePCFloat(fp,number4);
	   }
	   return foff;
   }

CString NodeSelection8::toString()
{
	CString buffer;
	//CString name = getObject()->findStrName(string_offset);
	buffer.Format("Flavor=%d subtype=%d String_Offset=%d Number1=%d Number2=%d Number4=%2.2f",type,0x8,string_offset,number1,number2,number4);
	{
		  CString msg;	  
		  msg.Format("[%x] %s",nodeOffset,buffer);
		  return msg;
	 }
	return buffer;
}

void NodeSelection4::Read(FILE *fp)
{
	   //object->trackBufferPos = ftell(fp);
	   displayClass        = ReadPCDWord(fp);
	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);	   	   
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   //if (children[0]) children[0]->Read(fp);
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

}

void NodeSelection5::Read(FILE *fp)
{
	   string_offset       = ReadPCDWord(fp);
	   displayClass        = ReadPCDWord(fp);
	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

}

void NodeSelection1::Read(FILE *fp)
  {
	   string_offset        = ReadPCDWord(fp);
	   numberOfChildren = 1;
	   children = (Node**)malloc(sizeof(Node*));
	   // get the child
       int toff = ftell(fp);	   	   
	   //int toff = object->trackBufferPos;
	   fseek(fp,getOffset()+child_offset,SEEK_SET);
	   //object->trackBufferPos = getOffset()+child_offset;
	   children[0] = getChildType(sectionOffset,this,fp,object);       	   
	   //if (children[0]) children[0]->Read(fp);
	   fseek(fp,toff,SEEK_SET);
	   //object->trackBufferPos = toff;

  }


