
#include "Vector.h"

class ObjCmd: public Observer
{
   public:
	   char desc[256];
	   int offset;

	   ObjCmd(int cmd,int offset,char *des=NULL):cmd(cmd),offset(offset),Observer(t_cmd)
	  {
		args = new Vector("Arg",__LINE__);
		subCmds = new Vector("SubCmds",__LINE__);
		if (des) strcpy(desc,des);
		else strcpy(desc,"Unknown Command");
	  }

	   void setDesc(char *des)
	   {
		  strcpy(desc,des);
	   }

	   void addArg(int val,char *desc)
	   {
		 DataValue *value = new DataValue(val,desc);
		 args->addElement(value);
	   }

	   CString argsString()
	   {
		   CString buffer;
		   for(int i=0;i<args->size();i++)
		   {
			 DataValue *value = (DataValue*)args->elementAt(i);
			 CString msg;
			 msg.Format("%d,",value->data);
			 buffer+=msg;
		   }
		   return buffer;
	   }

	   void LoadTree(HTREEITEM node,CObjectTree *tree)
	   {
		   for(int i=0;i<args->size();i++)
		   {
		   DataValue *val = (DataValue*)args->elementAt(i);
		   CString buffer;
		   buffer.Format("%d (0x%x)  = %s",val->data,val->data,val->desc);
		   tree->insertInfoNode(node, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));	
		   }
	   }

	   void Expand(CObjectTree *tree,HTREEITEM node)
	   {
		   if (subTree){
			   tree->m_ObjectTree.DeleteItem(subTree);
			   LoadTree(node,tree);
			   subTree = NULL;
		   }
	   }

	   Vector *args;
	   Vector *subCmds;

	   int cmd;
};