// CarTree.h : header file
#ifndef _INCLUDED_CCARTREE_H_
#define _INCLUDED_CCARTREE_H_
//
#include "sizecbar.h"

/////////////////////////////////////////////////////////////////////////////
// CCarTree window

#define TO_ID(x) (x-IDB_MIN)

class ThreeDOObject;
class Node;

class CObjectTree : public CSizingControlBar
{
// Construction
public:
	CObjectTree(); 

	HTREEITEM insertInfoNode(HTREEITEM parent, LPSTR title,int bitmap);

	void InsertThreeDOObject(CDocument *doc,ThreeDOObject *object);

	void OnItemexpandingTree(NMHDR* pNMHDR, LRESULT* pResult);

// Attributes
public:

	Node *clipBoardNode;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCarTree)
	//}}AFX_VIRTUAL

	CTreeCtrl m_ObjectTree;

// Implementation
public:
	virtual ~CObjectTree();

	void loadTree();
	void Reposition(CRect rc);
	void LoadImages();

	CImageList* pImageList;
	void Refresh(ThreeDOObject *object);

	void OnDblclkCartree(NMHDR* pNMHDR, LRESULT* pResult);
	void OnclkCartree(NMHDR* pNMHDR, LRESULT* pResult);
	void OnRclickTracktree(NMHDR* pNMHDR, LRESULT* pResult);
	
	void OnOpen();
	void OnEdit();
	void OnInsertPlane();
	void OnTopDrawingTree();
	void OnAddTopDrawingTree();
	void OnSaveFileAsTree();
	void OnOutputTree();
	void OnRenameImageFile();
	void OnRemoveNode();
	void OnInsertNode();
	void OnEditNode();
	void OnInsertPoint();
	void OnInsertString();
	void OnInsertChildNode();
	void OnView3DStats();
	void OnInsertCutNode();
	void OnInsertCopyNode();
	void OnInsertPasteNode();
	void OnInsertSelectPoint();
	void OnExportSubTree();

	// Generated message map functions
protected:
	//{{AFX_MSG(CCarTree)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif