#ifndef OBSERVER_INCLUDE_H
#define OBSERVER_INCLUDE_H

#include "ObjectTree.h"

typedef enum 
{
	t_null,
	t_Image,
	t_cmd,
	t_section,
	t_mip,
	t_srb,
	t_tdo,
	t_cam,
	t_trk,
	t_pbf,
	t_pt,
	t_trkwall,
	t_trktrk,
	t_trkalt,
	t_ini,
	t_lp,
	t_wav,
	t_setup,
	t_tree,
	t_data,
	t_plane,
	t_handle,
	t_normal,
	t_repository,
	t_mi4,
	t_pcx
} e_obtype;

class Observer:public CObject
{
  public:
	  e_obtype objtype;

	  Observer(e_obtype type):objtype(type)
	  {
		  subTree = NULL;
	  }

	  virtual ~Observer()
	  {
		  // test
		  objtype = t_null;
	  }

	  BOOL isA(int type)
	  {
		  return (type == objtype) ? TRUE:FALSE;
	  }

	  BOOL isAFile()
	  {
		  if (isA(t_mip) || isA(t_srb) || isA(t_tdo) || isA(t_cam) || isA(t_trk) || isA(t_pbf) || isA(t_mi4) || isA(t_pcx))
		  {
			  return TRUE;
		  }
		  return FALSE;
	  }

	  virtual void Explore()
	  {
		  AfxMessageBox("Current I Do not know how to show you data on this type");
	  }

	  virtual void Expand(CObjectTree *tree,HTREEITEM node)
	  {
	  }

	  virtual void Select()
	  {
	  }

	  HTREEITEM subTree;
};

#endif