
#include "stdafx.h"
#include "Point3D.h"
#include "PtsEdit.h"

#define PSIZE 2.0f


void Point3D::Draw2D(Display *display)
{
		float x=getX()-display->ofx;
		float y=getY()-display->ofy;

		x = (x*display->getScale());
		y = -1*(y*display->getScale());

		RECT rect;
		rect.top    = y-2.0f;
		rect.left   = x-2.0f;
		rect.bottom = y+2.0f;
		rect.right  = x+2.0f;

		if (tdoCount > 0)
		{
		 display->SelectRedBrush();
		 display->pDC->Rectangle(&rect);
		}
		else
		{
		 display->pDC->SelectStockObject(NULL_BRUSH);
		 display->pDC->Rectangle(&rect);
		}
		
		
}


void Point3D::Draw2DSelected(Display *display)
{
		float x=getX()-display->ofx;
		float y=getY()-display->ofy;

		x = (x*display->getScale());
		y = -1*(y*display->getScale());

		RECT rect;
		rect.top    = y-2.0f;
		rect.left   = x-2.0f;
		rect.bottom = y+2.0f;
		rect.right  = x+2.0f;
		
		display->pDC->SelectStockObject(BLACK_BRUSH);
		display->pDC->Rectangle(&rect);
		
}

BOOL Point3D::isOver(Display *display,CPoint ptA)
{
	float x=getX()-display->ofx;
	float y=getY()-display->ofy;

    x = (x*display->getScale());
	y = -1*(y*display->getScale());

	if (ptA.x > x-3 && ptA.x < x+3)
	{
		if (ptA.y > y-3 && ptA.y < y+3)
		{
			return TRUE;
		}
	}

	return FALSE;
}

void Point3D::setLocation(Display *display,CPoint ptA)
{
    float x = ptA.x/display->getScale();
	float y = -1*ptA.y/display->getScale();

	setX(x+ display->ofx);
	setY(y+ display->ofy);

}


void Point3D::Read(FILE *fp)
{
	  fread(&pt,1,sizeof(t_Point),fp);
}

void Point3D::ReadN2(FILE *fp)
{
	  t_N2Point ptN2;
	  fread(&ptN2,1,sizeof(t_N2Point),fp);
	  pt.x = (((float)ptN2.x)/PSCALE);
	  pt.y = (((float)ptN2.y)/PSCALE);
	  pt.z = (((float)ptN2.z)/PSCALE);
	  pt.unk = (float)ptN2.unk;
}

void Point3D::ReadICR2(FILE *fp,BOOL texture)
{
	  pos = ftell(fp);
	  t_ICR2Point ptN2;
	  fread(&ptN2,1,sizeof(t_ICR2Point),fp);
	  pt.x = (((float)ptN2.x)/PSCALE);
	  pt.y = (((float)ptN2.y)/PSCALE);
	  pt.z = (((float)ptN2.z)/PSCALE);
	  pt.unk = (float)ptN2.unk;
	  if (texture)
	  {
	   u = ptN2.u;
	   v = ptN2.u;
	  }
}

void Point3D::WriteICR2(FILE *fp)
{
	  int pos = ftell(fp);
	  t_ICR2Point ptN2;	  
	  ptN2.x = (int)((pt.x*PSCALE)+0.5f);
	  ptN2.y = (int)((pt.y*PSCALE)+0.5f);
	  ptN2.z = (int)((pt.z*PSCALE)+0.5f);
	  ptN2.unk = (int)pt.unk;
	  if (useTexture)
	  {
	   fwrite(&ptN2,1,sizeof(t_ICR2Point),fp);
	  }
	  else
	  {
	   fwrite(&ptN2,1,sizeof(t_N2Point),fp);
	  }
}


void Point3D::Write(FILE *fp)
{
	  fwrite(&pt,1,sizeof(t_Point),fp);
}

void Point3D::WriteN2(FILE *fp)
{
	  t_N2Point ptN2;
	  ptN2.x = (int)((pt.x*PSCALE)+0.5f);
	  ptN2.y = (int)((pt.y*PSCALE)+0.5f);
	  ptN2.z = (int)((pt.z*PSCALE)+0.5f);
	  ptN2.unk = (int)pt.unk;
	  fwrite(&ptN2,1,sizeof(t_N2Point),fp);
}

void Point3D::Explore(CDocument *pDoc)
{
	CPtsEdit *dlg = new CPtsEdit(this,pDoc);

	dlg->m_X = getX();
	dlg->m_Y = getY();
	dlg->m_Z = getZ();
	dlg->index=idx;
	dlg->m_Index.Format("%d",idx);

	int result = dlg->DoModal();

	if (result == IDOK)
	{
		setX(dlg->m_X);
		setY(dlg->m_Y);
		setZ(dlg->m_Z);
	}
}

C3do *Point3D::getObject()
{
		return object;
}