
#ifndef _INCLUDED_POLYGON_H_
#define _INCLUDED_POLYGON_H_

class CMip;
class C3do;
//#include "C3do.h"

class DOPolygon: public CObject
{
    public:
	int textureidx;
	int strid;
	COLORREF colorref;

	DOPolygon(int color):color(color)
	{
		points = new Vector("Polygon",__LINE__);
		red= (color & 0x00FF0000) >> 16;
		green = (color & 0x0000FF00) >> 8;
		blue=(color & 0x000000FF);
		textures = NULL;
		textureidx = -1;
		colorref =RGB(red,green,blue); 
		textureMip = NULL;
		strid = -1;
	}

	~DOPolygon()
	{
		delete points;
		//if (polygonBrush) delete polygonBrush;
		if (textures) delete textures;
	}

	void addPoint(Point3D *pt)
	{
		points->addElementReference(pt);
	}

	void LoadTree(HTREEITEM parent,CObjectTree *tree, C3do *tdo);
	/*
    {
		if (textureidx == -1 && tdo)
		{
		   if (tdo->strs)
		   {
			 int ssize = tdo->strs->size();
			 for(int i=0;i<ssize;i++)
			 {
			 CImageFile *file = (CImageFile*)tdo->strs->elementAt(i);
			 if (file->offset == strid)
			 {
			  textureidx = i;
			  break;
			 }
		  }
		 }
		}

		if (points)
		{
	     int psize = points->size();
		 CString buffer;
		 buffer.Format("Polygon pts=%d texture=%d color=%X strnum=%d",psize,textureidx,colorref,strid);
		 tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
		}
		
		//for(int i=0;i<psize;i++)
		//{
		//}
	}
	*/

	Vector *points;
	Vector *textures;
	int color;
	int red;
	int green;
	int blue;
	CBrush *polygonBrush;
	POINT npoly[10];
	CMip   *textureMip;
};

class DOLine: public CObject
{
    public:
	
	DOLine()
	{
		points = new Vector("Lines",__LINE__);
	}

	~DOLine()
	{
		delete points;
	}

	void addPoint(Point3D *pt)
	{
		points->addElementReference(pt);
	}

	void LoadTree(HTREEITEM parent,CObjectTree *tree)
    {
	    int psize = points->size();
		CString buffer;
		buffer.Format("Line pts=%d",psize);
		tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));

	}

	Vector *points;
};


#endif