// PtsEdit.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "PtsEdit.h"
#include "Point3D.h"
#include "C3do.h"
#include "3DOEditorDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPtsEdit dialog


CPtsEdit::CPtsEdit(Point3D *pt,CDocument *pDoc,CWnd* pParent /*=NULL*/)
	: pt(pt),pDoc(pDoc),CDialog(CPtsEdit::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPtsEdit)
	m_X = 0.0f;
	m_Y = 0.0f;
	m_Z = 0.0f;
	m_Alias = _T("");
	m_Index = _T("");
	//}}AFX_DATA_INIT
}


void CPtsEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPtsEdit)
	DDX_Text(pDX, IDC_EDIT1, m_X);
	DDX_Text(pDX, IDC_EDIT2, m_Y);
	DDX_Text(pDX, IDC_EDIT3, m_Z);
	DDX_Text(pDX, IDC_ALIAS, m_Alias);
	DDX_Text(pDX, IDC_IDX, m_Index);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPtsEdit, CDialog)
	//{{AFX_MSG_MAP(CPtsEdit)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_EN_CHANGE(IDC_ALIAS, OnChangeAlias)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPtsEdit message handlers

void CPtsEdit::OnButton1() 
{
	UpdateData(TRUE);
	if (pt)
	{
	 pt->setX(m_X);
	 pt->setY(m_Y);
	 pt->setZ(m_Z);
	 if (pDoc) pDoc->UpdateAllViews(NULL);
	}
}

void CPtsEdit::OnButton2() 
{
	UpdateData(TRUE);

	C3do *object = pt->getObject();

	if (object)
	{
		   if (object->pDoc)
		   {
            CMy3DOEditorDoc *pDoc = (CMy3DOEditorDoc *)object->pDoc;
			object->midx = m_X;	
			object->midy = m_Y;	
			object->midz = m_Z;	
			pDoc->UpdateAllViews(NULL);
		   }
	}
}

void CPtsEdit::OnChangeAlias() 
{
	UpdateData(TRUE);
	C3do *object = pt->getObject();
	if (object)
	{
		   if (object->pDoc)
		   {
            CMy3DOEditorDoc *pDoc = (CMy3DOEditorDoc *)object->pDoc;
			if (index >= 0)
			{
			  object->UpdateOrAddAlias(index,(LPSTR)(LPCSTR)m_Alias);
			}
		   }
	}
}
