
#include "stdafx.h"
#include "Section.h"
#include "ImageFile.h"
#include "DataValue.h"

Section::~Section()
{
	if (isPRIM())
	{
		//if (getObject()->primTree) delete getObject()->primTree;
	}
	else if (isHAND())
	{
		 if (getObject()->extras)
		 {
		  
		  for(int i=0;i<getObject()->numHandles;i++)
		  {
			 //delete getObject()->extras[i];
			 delete getObject()->Handles[i];
		  }
		  delete [] getObject()->extras;
		  delete [] getObject()->Handles;
		 }
	}
	else if (isPLAN())
	{
		 if (getObject()->numPlanes)
		 {
	      for(int i=0;i<getObject()->numPlanes;i++)
		  {
			delete getObject()->Plans[i];
		  }
		  delete[] getObject()->Plans;
		 }
	}
	else if (isNORM())
	{
		 if (getObject()->numNormals)
		 {
	      for(int i=0;i<getObject()->numNormals;i++)
		  {
			delete getObject()->Normals[i];
		  }
		  delete[] getObject()->Normals;
		 }
	}
	
}

void Section::LoadSubTree(CObjectTree *tree)
	{
	  if (isXYZ())
	  {
		CString buffer;
		for(int j=0;j<object->numPts;j++)
	    {	     
	     Point3D *pt = (Point3D*)object->ptsArray[j];
		 buffer.Format("[%d] %s",j,pt->toString());
		 HTREEITEM node = tree->insertInfoNode(SectionNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_POINT));
		 tree->m_ObjectTree.SetItemData(node,(DWORD)pt);
	    }
	  }
	  else if (isPERP())
	  {
		CString buffer;
		for(int j=0;j<object->numPts;j++)
	    {	     
	     Point3D *pt = (Point3D*)object->ptsArray[j];
		 buffer.Format("[%d] %s",j,pt->toString());
		 HTREEITEM node = tree->insertInfoNode(SectionNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_POINT));
		 tree->m_ObjectTree.SetItemData(node,(DWORD)pt);
	    }
	  }
	  else if(isSTR())
	  {
		int size = object->strs->size();
	    CString buffer;
		for(int j=0;j<size;j++)
	    {
		  CImageFile *file = (CImageFile*)object->strs->elementAt(j);
		  
		  buffer.Format("(%d) File: %s",file->offset,file->filename);
		  HTREEITEM node = tree->insertInfoNode(SectionNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_FILE));
		  tree->m_ObjectTree.SetItemData(node,(DWORD)file);
		  file->LoadTree(node,tree);
		}
	  }
	  else if(isPRIM())
	  {
		object->GetFile();
		parsePrimTree(fp,SectionNode,tree);
	  }
	  else if(isPLAN())
	  {
		 int size = info.length/4;
		 for(int j=0;j<object->numPlanes;j++)
	     {
		  CString buffer;
		  buffer.Format("Val[%d]: %f %f %f %f",j,object->Plans[j]->A.data,object->Plans[j]->B.data,object->Plans[j]->C.data,object->Plans[j]->D.data);
		  HTREEITEM node = tree->insertInfoNode(SectionNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_UNK));
		  tree->m_ObjectTree.SetItemData(node,(DWORD)(object->Plans[j]));
		 }
	  }	 
	  else if(isNORM())
	  {
		 int size = info.length/4;
		 for(int j=0;j<object->numNormals;j++)
	     {
		  CString buffer;
		  buffer.Format("Val[%d]: %f %f %f %f",j,object->Normals[j]->A.data,object->Normals[j]->B.data,object->Normals[j]->C.data,object->Normals[j]->D.data);
		  HTREEITEM node = tree->insertInfoNode(SectionNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_UNK));
		  tree->m_ObjectTree.SetItemData(node,(DWORD)(object->Normals[j]));
		 }
	  }
	  else if(isHAND())
	  {
		int size = info.length/4;
		 for(int j=0;j<object->numHandles;j++)
	     {
		  CString buffer;
		  int idx = object->Handles[j]->String.getVal();
		  buffer.Format("Val[%d]: String_offset=%d(%s) Offset=%d",j,idx,object->findStrName(idx),object->Handles[j]->Offset.getVal());
		  HTREEITEM node = tree->insertInfoNode(SectionNode, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_UNK));
		  tree->m_ObjectTree.SetItemData(node,(DWORD)(object->Handles[j]));
		 }
	  }
	}

