
#include "stdafx.h"
#include "Setup.h"
#include "stdio.h"
#include "ObjectTree.h"
#include "resource.h"

BOOL CSetup::Read(const char *filename)
{
	FILE *fp = FOPEN(filename,"rb");

	if (fp == NULL)
	{
		return FALSE;
	}
	Read(fp);
	return TRUE;
}

BOOL CSetup::Read(FILE *fp)
{
	if (dataLoaded) return TRUE;
	offset = ftell(fp);
	fread(&Header,1,sizeof(t_Setup_Header),fp);

	fread(&Setup,1,sizeof(t_Setup),fp);	
	return TRUE;
}

BOOL CSetup::Write(FILE *fp)
{
	AfxMessageBox("No Writer for setup");
	return FALSE;
}

void CSetup::LoadTree(HTREEITEM parent,CObjectTree *tree)
{
	GetFile();
	CString buffer;

	buffer.Format("Unk1 %2.2f",Setup.unk1);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

	buffer.Format("Unk2 %2.2f",Setup.unk2);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

	buffer.Format("1st Gear %2.2f",Setup.Gear1);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));
	buffer.Format("2nd Gear %2.2f",Setup.Gear2);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));
	buffer.Format("3rd Gear %2.2f",Setup.Gear3);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));
	buffer.Format("4th Gear %2.2f",Setup.Gear4);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));
	buffer.Format("5th Gear %2.2f",Setup.Gear5);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));
	buffer.Format("6th Gear %2.2f",Setup.Gear6);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));

	buffer.Format("Differential Ratio %2.2f",Setup.DifferentialRatio);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_GEAR));

	buffer.Format("Unk3 %d",Setup.unk3);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk4 %d",Setup.unk4);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk5 %d",Setup.unk5);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk6 %d",Setup.unk6);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk7 %d",Setup.unk7);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk8 %d",Setup.unk8);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk9 %d",Setup.unk9);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk10 %d",Setup.unk10);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Unk11 %d",Setup.unk11);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

	buffer.Format("TirePressureFL %2.2f",Setup.TirePressureFL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("TirePressureFR %2.2f",Setup.TirePressureFR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("TirePressureRL %2.2f",Setup.TirePressureRL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("TirePressureRR %2.2f",Setup.TirePressureRR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));


	buffer.Format("WheelRateFL %2.2f",Setup.WheelRateFL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("WheelRateFR %2.2f",Setup.WheelRateFR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("WheelRateRL %2.2f",Setup.WheelRateRL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("WheelRateRR %2.2f",Setup.WheelRateRR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));


	buffer.Format("BumpFL %2.2f",Setup.BumpFL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("BumpFR %2.2f",Setup.BumpFR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("BumpRL %2.2f",Setup.BumpRL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("BumpRR %2.2f",Setup.BumpRR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));


	buffer.Format("ReBoundFL %2.2f",Setup.ReBoundFL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("ReBoundFR %2.2f",Setup.ReBoundFR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("ReBoundRL %2.2f",Setup.ReBoundRL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("ReBoundRR %2.2f",Setup.ReBoundRR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));



	buffer.Format("CamberFL %2.2f",Setup.CamberFL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("CamberFR %2.2f",Setup.CamberFR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("CamberRL %2.2f",Setup.CamberRL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("CamberRR %2.2f",Setup.CamberRR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));

	buffer.Format("Tire Unk1 %2.2f",Setup.TUnk1);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk2 %2.2f",Setup.TUnk2);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk3 %2.2f",Setup.TUnk3);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk4 %2.2f",Setup.TUnk4);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk5 %2.2f",Setup.TUnk5);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk6 %2.2f",Setup.TUnk6);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk7 %2.2f",Setup.TUnk7);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("Tire Unk8 %2.2f",Setup.TUnk8);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	

	buffer.Format("BumpRubberFL %2.2f",Setup.BumpRubberFL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("BumpRubberFR %2.2f",Setup.BumpRubberFR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("BumpRubberRL %2.2f",Setup.BumpRubberRL);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));
	buffer.Format("BumpRubberRR %2.2f",Setup.BumpRubberRR);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_TYRE));


	buffer.Format("ToeInFront %2.2f",Setup.ToeInFront);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("ToeInRear %2.2f",Setup.ToeInRear);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

	buffer.Format("RollBarFront %2.2f",Setup.RollBarFront);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("RollBarRear %2.2f",Setup.RollBarRear);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

	buffer.Format("RideHeightFront %2.2f",Setup.RideHeightFront);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
	buffer.Format("RideHeightRear %2.2f",Setup.RideHeightRear);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

	buffer.Format("No_Clutches %2.2f",Setup.No_Clutches);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));

    buffer.Format("GallonsFuel %2.2f",Setup.GallonsFuel);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_FUEL));

    buffer.Format("SteeringRatio %2.2f",Setup.SteeringRatio);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_BSTEER));

	buffer.Format("FrontBrakeBias %2.2f",Setup.FrontBrakeBias);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_BRAKE));

	buffer.Format("AssymetricEdit %d",Setup.AssymetricEdit);
	tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_SETUP));
}
