
#include "stdafx.h"
#include "Tool.h"
#include "3DOEditorDoc.h"
#include "3DOEditorView.h"
#include "math.h"

#include <gl\glaux.h>
#include <gl\gl.h>
#include <gl\glu.h>

void SelectPoint(CView *view,UINT nFlags, CPoint point)
{
	CMy3DOEditorView *doview = (CMy3DOEditorView*)view;

	if (nFlags & MK_SHIFT)
	{
	CMy3DOEditorDoc *pDoc = doview->GetDocument();
	GLdouble model[16];
	GLdouble projection[16];
	GLint view[4];
	CRect rect;
	doview->GetClientRect(&rect);
	CDC *pDC = doview->GetDC();
	HDC hdc = pDC->m_hDC;

	glPushMatrix();

	
	glMatrixMode(GL_PROJECTION);
	//((COpenGLView*) view)->OnSize(0,rect.Width(),rect.Height());
	int selectedIdx = -1;
	double selectedDist = 10E8;

	int midy = (rect.top+rect.bottom)/2;
	int midx = (rect.left+rect.right)/2;

	if (pDoc)
	{
	  if (pDoc->object)
	  {
		float scale = 3.0f;
	    doview->getLookPoint();
		glScalef(scale,scale,scale);
	    glTranslated(-pDoc->object->midx,-pDoc->object->midy,-pDoc->object->midz);
		
		
	    glMatrixMode(GL_MODELVIEW);	
	    glGetDoublev(GL_MODELVIEW_MATRIX,model);
	    glGetDoublev(GL_PROJECTION_MATRIX,projection);
	    glGetIntegerv(GL_VIEWPORT,view);
		gluPickMatrix(point.x, point.y, 1, 1, view);

	    for(int i=0;i<pDoc->object->numPts;i++)
		{
	     GLdouble sx,sy,sz;
	     Point3D *pts = pDoc->object->ptsArray[i];
	     GLdouble wx = pts->getX();
	     GLdouble wy = pts->getY();
	     GLdouble wz = pts->getZ();
	     gluProject(wx,wy,wz,model,projection,view,&sx,&sy,&sz);
		 //int winx = (int)(sx-midx);
		 int winy = (int)(sy-midy);
		 int ssx = (int)(sx);
		 int ssy = (midy-winy);
		 double dx = ssx-point.x;
	     double dy = ssy-point.y;
	     double dist = sqrt((dx*dx)+(dy*dy));
	     if (dist < selectedDist)
		 {
		  selectedDist = dist;
		  selectedIdx = i;
		 }
		}
	  }
	}

	if (selectedIdx!=-1)
	{
		CString msg;
		msg.Format("Closest Point %d",selectedIdx);
		pDoc->object->selectedPt = pDoc->object->ptsArray[selectedIdx];
	}
	else
	{
		pDoc->object->selectedPt = NULL;
		
	}	
	glPopMatrix();
	doview->GetDocument()->UpdateAllViews(NULL);
	}
}


void RotateTool::OnLButtonDown(CView *view,UINT nFlags, CPoint point)
{
	SelectPoint(view,nFlags,point);
}

void RotateTool::OnLButtonUp(CView *view,UINT nFlags, CPoint point)
{}

void RotateTool::OnMouseMove(CView *view,UINT nFlags, CPoint point)
{
	CMy3DOEditorView *doview = (CMy3DOEditorView*)view;
	CMy3DOEditorDoc *pDoc = doview->GetDocument();

	if (pDoc)
	{
		if (pDoc->object)
		{
			if (doview->dragging)
			{	  
			float dx = (float)(doview->dragFromPoint.x-point.x)/20.0f;
			float dy = (float)(doview->dragFromPoint.y-point.y)/20.0f;
			if (pDoc->object->selectedPt)
			{
				switch(doview->viewDirection)
				{
					case t_XY:
						pDoc->object->selectedPt->setX(pDoc->object->selectedPt->getX()-dx);
						pDoc->object->selectedPt->setZ(pDoc->object->selectedPt->getZ()+dy);
						//AfxMessageBox("XY");
						break;
					case t_XZ:
						pDoc->object->selectedPt->setY(pDoc->object->selectedPt->getY()+dx);
						pDoc->object->selectedPt->setZ(pDoc->object->selectedPt->getZ()+dy);
						//AfxMessageBox("XZ");
						break;
					case t_YZ:
						pDoc->object->selectedPt->setX(pDoc->object->selectedPt->getX()-dx);
						pDoc->object->selectedPt->setY(pDoc->object->selectedPt->getY()+dy);
						//AfxMessageBox("YZ");
						break;
					case t_XYZ:
						/*
						//AfxMessageBox("XYZ");break;
						if (nFlags & MK_CONTROL)
						{
							pDoc->object->selectedPt->setZ(pDoc->object->selectedPt->getZ()+dy);
						}
						else
						{	
							pDoc->object->selectedPt->setY(pDoc->object->selectedPt->getY()+dx);
							pDoc->object->selectedPt->setX(pDoc->object->selectedPt->getX()+dy);
						}
						*/
						break;
				}
				
				
				doview->GetDocument()->UpdateAllViews(NULL);
			}
			doview->dragFromPoint = point;
			}
		}
	}


	if(((COpenGLView*)view)->m_LeftButtonDown)
	 {
		CSize rotate = ((COpenGLView*)view)->m_LeftDownPos - point;
		((COpenGLView*)view)->m_LeftDownPos = point;
		
		((COpenGLView*)view)->m_xRotate -= rotate.cy;
		if (((COpenGLView*)view)->m_ShiftDown)
		{
		  ((COpenGLView*)view)->m_zRotate -= rotate.cx;
		}
		else
		{
		  ((COpenGLView*)view)->m_yRotate -= rotate.cx;
		}
		doview->InvalidateRect(NULL,FALSE);
	 }

}





void PointTool::OnLButtonDown(CView *view,UINT nFlags, CPoint point)
{
		SelectPoint(view,nFlags,point);
}

void PointTool::OnLButtonUp(CView *view,UINT nFlags, CPoint point)
{}

void PointTool::OnMouseMove(CView *view,UINT nFlags, CPoint point)
{}
