
#ifndef _INCLUDED_TOOLS_H_
#define _INCLUDED_TOOLS_H_

typedef enum { t_RotateTool, t_PointTool } t_ToolType;

class Tool
{
public:
	Tool(t_ToolType type):type(type)
	{}


	virtual void OnLButtonDown(CView *view,UINT nFlags, CPoint point) = 0;
	virtual void OnLButtonUp(CView *view,UINT nFlags, CPoint point) = 0;
	virtual void OnMouseMove(CView *view,UINT nFlags, CPoint point) = 0;

	t_ToolType type;
};


class RotateTool : public Tool
{

	public:
		RotateTool():Tool(t_RotateTool)
		{}


	void OnLButtonDown(CView *view,UINT nFlags, CPoint point);
	void OnLButtonUp(CView *view,UINT nFlags, CPoint point);
	void OnMouseMove(CView *view,UINT nFlags, CPoint point);
};

class PointTool : public Tool
{

	public:
		PointTool():Tool(t_PointTool)
		{}


	void OnLButtonDown(CView *view,UINT nFlags, CPoint point);
	void OnLButtonUp(CView *view,UINT nFlags, CPoint point);
	void OnMouseMove(CView *view,UINT nFlags, CPoint point);
};

#endif