// TrackEdit.cpp : implementation file
//

#include "stdafx.h"
#include "3DOEditor.h"
#include "TrackEdit.h"
#include "Trk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTrackEdit dialog


CTrackEdit::CTrackEdit(CTrk *track,TrackSection *t,CWnd* pParent /*=NULL*/)
	: track(track),t(t),CDialog(CTrackEdit::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTrackEdit)
	m_Type = 0;
	m_Start = 0;
	m_Length = 0;
	m_Orientation = 0;
	m_Unk1 = 0;
	m_Unk3 = 0;
	m_Unk2 = 0;
	m_Unk4 = 0;
	m_Unk5 = 0;
	m_Unk6 = 0;
	m_AltitudesIndex = 0;
	m_WallCount = 0;
	m_WallIndex = 0;
	//}}AFX_DATA_INIT
}


void CTrackEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTrackEdit)
	DDX_Text(pDX, IDC_EDIT1, m_Type);
	DDX_Text(pDX, IDC_EDIT2, m_Start);
	DDX_Text(pDX, IDC_EDIT3, m_Length);
	DDX_Text(pDX, IDC_EDIT4, m_Orientation);
	DDX_Text(pDX, IDC_EDIT5, m_Unk1);
	DDX_Text(pDX, IDC_EDIT7, m_Unk3);
	DDX_Text(pDX, IDC_EDIT6, m_Unk2);
	DDX_Text(pDX, IDC_EDIT8, m_Unk4);
	DDX_Text(pDX, IDC_EDIT9, m_Unk5);
	DDX_Text(pDX, IDC_EDIT10, m_Unk6);
	DDX_Text(pDX, IDC_EDIT11, m_AltitudesIndex);
	DDX_Text(pDX, IDC_EDIT12, m_WallCount);
	DDX_Text(pDX, IDC_EDIT13, m_WallIndex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTrackEdit, CDialog)
	//{{AFX_MSG_MAP(CTrackEdit)
	ON_WM_DRAWITEM()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrackEdit message handlers

void CTrackEdit::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	int wallStart = t->data.wall_index;
	int wallNum   = t->data.wall_count;
	WallSection *walls = &(track->Walls[wallStart]);
	WallSection *walle = &(track->Walls[wallStart+wallNum-1]);

	int dist = walle->data.from-walls->data.from;
	//int width = 
	if (nIDCtl == IDC_PREVIEW)
	{
		CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
        CRect rcItem(lpDrawItemStruct->rcItem);

		// Save dc state
        int nSavedDC = pDC->SaveDC();
		
		pDC->FillRect(rcItem, &CBrush(::GetSysColor(COLOR_WINDOW)));
		pDC->SetBkColor(::GetSysColor(COLOR_WINDOW));

		double scalef = (double)(rcItem.Width()-20)/(double)dist;
		double midx = 10+(rcItem.Width()/2);
		double midy = rcItem.Height()/2;
		double lastsx=0;
		double lastsy=0;

		int he  = t->data.altitudes_index;
		

		for(int i=wallStart;i<wallStart+wallNum;i++)
		{
			int from   = (track->Walls[i].data.from);
			double height = scalef*track->Altitudes[he+i].data.start;
			double wall_height = scalef*track->Walls[i].data.height;

			double sx = midx + (scalef*from);
			double sy = midy-height;

			pDC->MoveTo(sx,sy);
			pDC->LineTo(sx,sy-wall_height);
			if (i > wallStart)
			{
				pDC->MoveTo(lastsx,lastsy);
				pDC->LineTo(sx,sy);
			}
			lastsx = sx;
			lastsy = sy;
		}
        
        

		// Restore dc
        pDC->RestoreDC( nSavedDC );
	}
	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}
