// PitInfo.cpp : implementation file
//

#include "stdafx.h"
#include "3doEditor.h"
#include "DatDocument.h"
#include "TrkInfo.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern LPSTR toBinString(int data,int size);
extern LPSTR toString(int data);
extern LPSTR toString(double data);
extern LPSTR toHexString(int data);

extern int getTrkIcon(TrackSection *section);

/////////////////////////////////////////////////////////////////////////////
// CTrkInfo

IMPLEMENT_DYNCREATE(CTrkInfo, CMyTableView)

CTrkInfo::CTrkInfo()
{
	//trkdlg = new CTrChangeDlg(this);
	
}

CTrkInfo::~CTrkInfo()
{
	//if (trkdlg!=NULL) delete trkdlg;

	//CMy3DOEditorDoc* pDoc = (CMy3DOEditorDoc*)GetDocument();

	//if (pDoc)
	//{
	  //pDoc->pitTable = NULL;
	//}
	
}

#define UPDATE_TABLE_STRING_PTR(a,b,c,d) str =  d;UpdateTableStringPtr(a,b,c,str);free(str);

void CTrkInfo::UpdateInfo(BOOL update)
{
    CDatDocument *pDoc = (CDatDocument*)GetDocument();

    if (pDoc && pDoc->trkFile)
	{
	   CTrk *mytrack = pDoc->trkFile;
	   if (!update)
	   {
	     
		 int colidx=0;
		 EmptyTable();
		 addColumn("Index",50,colidx++);
	     addColumn("Type",50,colidx++);
	     addColumn("Start",50,colidx++);
		 addColumn("Length",50,colidx++);
		 addColumn("Orientation",50,colidx++);
		 addColumn("Unk3",50,colidx++);
		 addColumn("XC",50,colidx++);
		 addColumn("YC",50,colidx++);
		 addColumn("Unk4",50,colidx++);
		 addColumn("Unk5",50,colidx++);
		 addColumn("Unk6",50,colidx++);
		 addColumn("Altitude Index",50,colidx++);
		 addColumn("Wall Count",50,colidx++);
		 addColumn("Wall Index",50,colidx++);
	   }

	   int size = mytrack->Header.sections;
	   for(int i=0;i<size;i++)
	   {
		int tidx = 0;
        TrackSection *t = (TrackSection*)&mytrack->TrackSections[i];
		CString str;
		str.Format("%d",i);
		UpdateTableStringPtr(update,i,tidx++,str,TO_ID(getTrkIcon(t)));
		str.Format("%d",t->data.type);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.start);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.length);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.orientation);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.unk3);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.XC);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.YC);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.unk4);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.unk5);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.unk6);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.altitudes_index);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.wall_count);
		UpdateTableStringPtr(update,i,tidx++,str);
		str.Format("%d",t->data.wall_index);
		UpdateTableStringPtr(update,i,tidx++,str);		
	   }	
	}
	
	//pDoc->pitTable = this;
	//pDoc->SetTitle("Track Info");

	/*
	if (mytrack!=NULL)
	{
		  if (!update)
		  {
		  int colidx=0;
		  EmptyTable();
		  addColumn("Index",50,colidx++);
	      addColumn("Angle",50,colidx++);
	      addColumn("Length",50,colidx++);
		  addColumn("Arc",50,colidx++);
		  addColumn("Height",50,colidx++);

		  addColumn("Gradient (HxL)",50,colidx++);
		  addColumn("Cumlative Gradient",50,colidx++);
		  addColumn("Altitude Delta",50,colidx++);
		  addColumn("Cumlative  Altitude",50,colidx++);

		  addColumn("StAngle",50,colidx++);
		  addColumn("EnAngle",50,colidx++);
	      
		  addColumn("RoadSide",50,colidx++);
		  addColumn("RoadSide (Bin)",100,colidx++);
		  addColumn("Kerb",50,colidx++);
		  addColumn("Kerb (Bin)",100,colidx++);

		  addColumn("Left Bank",50,colidx++);
		  addColumn("Right Bank",50,colidx++);
		  addColumn("Track Left  Width",50,colidx++);		   
		  addColumn("Track Right Width",50,colidx++);

		  addColumn("Length Meters",50,colidx++);
		  addColumn("Length Feet",50,colidx++);
		  addColumn("Cumlative Length",50,colidx++);
		  }
	    

	    
		  if (mytrack->PitlaneSections)
		  {
		   for(int i=0;i<mytrack->PitlaneSections->size();i++)
           {
           TrackSection *t = (TrackSection*)mytrack->PitlaneSections->elementAt(i);

		   int tidx = 0;

		   LPSTR str = toString(i); 
		   UpdateTableStringPtr(update,i,tidx++,str,TO_ID(t->getIcon(TRUE)));
		   free(str);

		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(t->getAngle()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(t->getLength()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(t->getAngle()*t->getLength()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(t->getHeight()));

		   str = toString(t->getHeight()*t->getLength());
		   UpdateTableStringPtr(update,i,tidx++,str);free(str);
		   str = toString(t->getAltitude());
		   UpdateTableStringPtr(update,i,tidx++,str);free(str);
		   str =  toString(t->getAltitudeDelta());
		   UpdateTableStringPtr(update,i,tidx++,str);free(str);

		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(t->getTrueAltitude()));

		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(RadToDeg(t->getStartAngle())));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(RadToDeg(t->getEndAngle())));

		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toHexString(t->getRoadSignData()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toBinString(t->getRoadSignData(),8));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toHexString(t->getKerbData()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toBinString(t->getKerbData(),8));
		   
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++, toString(t->getLeftToBank()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString(t->getRightToBank()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString((int)t->getWidthLeft()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString((int)t->getWidthRight()));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString((int)(LENGTH_TO_KM*t->getTrueLength())));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString((int)(16.0*t->getTrueLength())));
		   UPDATE_TABLE_STRING_PTR(update,i,tidx++,toString((int)(t->track->LengthToPitSectorEnd(t))));
           

           
		   
           }
		  }
	}
	*/
	//CSize size = table->getSize();
	//SetScrollSizes(MM_TEXT, size);
	GetListCtrl().SetColumnWidth(1,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(2,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(3,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(4,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(5,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(6,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(7,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(8,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(9,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(10,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(11,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(12,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(13,LVSCW_AUTOSIZE_USEHEADER);
	GetListCtrl().SetColumnWidth(14,LVSCW_AUTOSIZE_USEHEADER);
}

void CTrkInfo::OnDraw(CDC* pDC)
{	
}






BEGIN_MESSAGE_MAP(CTrkInfo, CMyTableView)
	//{{AFX_MSG_MAP(CTrkInfo)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONUP()
	//ON_COMMAND(ID_EXPORT_TABLE, OnExportTable)
	ON_WM_CREATE()
	ON_WM_KEYDOWN()
	//ON_COMMAND(ID_IMPORT_TABLE, OnImportTable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrkInfo drawing

void CTrkInfo::OnInitialUpdate()
{
	//CMyTableView::OnInitialUpdate();

	//CSize sizeTotal;
	// TODO: calculate the total size of this view
//sizeTotal.cx = sizeTotal.cy = 1000;
	//SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CTrkInfo diagnostics

#ifdef _DEBUG
void CTrkInfo::AssertValid() const
{
	CMyTableView::AssertValid();
}

void CTrkInfo::Dump(CDumpContext& dc) const
{
	CMyTableView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTrkInfo message handlers

BOOL CTrkInfo::OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CMyTableView::OnScroll(nScrollCode, nPos, bDoScroll);
}

BOOL CTrkInfo::OnScrollBy(CSize sizeScroll, BOOL bDoScroll) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CMyTableView::OnScrollBy(sizeScroll, bDoScroll);
}

void CTrkInfo::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int idx         = getTableSectionIndex();	
	
	CMyTableView::OnLButtonDown(nFlags, point);
}

void CTrkInfo::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CDatDocument *pDoc = (CDatDocument*)GetDocument();
	int idx = getTableSectionIndex();

    if (pDoc && pDoc->trkFile)
	{
	CTrk *mytrack = pDoc->trkFile;
	TrackSection *t = (TrackSection*)&mytrack->TrackSections[idx];
	t->Explore();
	}
	   
	
	UpdateInfo(TRUE);

   	CMyTableView::OnLButtonDblClk(nFlags, point);
}

void CTrkInfo::OnSetFocus(CWnd* pOldWnd) 
{
	CMyTableView::OnSetFocus(pOldWnd);
}


void CTrkInfo::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	

	CMyTableView::OnLButtonUp(nFlags, point);
}


BOOL CTrkInfo::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	BOOL res = CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);

	//SetImageList((((CTrackEditorApp*)AfxGetApp())->getSharedImageList()),LVSIL_SMALL);

	return res;
}

int CTrkInfo::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMyTableView::OnCreate(lpCreateStruct) == -1)
		return -1;

	CImageList *pImages = (((CMy3DOEditorApp*)AfxGetApp())->pImageList);

	if (pImages!=NULL)
	{
	  SetImageList(pImages,LVSIL_SMALL);
	  useImages = TRUE;
	}
	else
	{
	  useImages = FALSE;
	  AfxMessageBox("Failed to open Images");
	}

	// TODO: Add your specialized creation code here
	UpdateInfo(FALSE);
	
	return 0;
}

void CTrkInfo::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CPoint pt;

	if (nChar == 13)
	{
	  OnLButtonDblClk(0,pt);
	}
	CMyTableView::OnKeyDown(nChar, nRepCnt, nFlags);
}

#define PITANGLE 1
#define PITLENGTH 2
#define PITHEIGHT 4
#define PITRS     7
#define PITKB     9
#define PITWL     11
#define PITWR     12



