
#include "stdafx.h"
#include "Vector.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define NEW 1

static int VectorsCreated=0;

Vector::Vector(LPCSTR myname,int myline,BOOL add)
{
       dataPtr = NULL;
	   VectorsCreated++;

	   strcpy(name,myname);
	   line = myline;
}

Vector::Vector(Vector *vec)
{
	 VectorsCreated++;
	 int size = vec->size();
	 for(int i=0;i<size;i++)
	 {
		 addElement(vec->elementAt(i));
	 }
}




	
Vector::~Vector()
{
	   VectorsCreated--;
	   removeAllData();
}



void Vector::removeAllElements()
{
       removeAllData();	    
}

void Vector::removeAllData()
{
	   if (dataPtr)
	   {
        v_elm *elm  = dataPtr; 
	    v_elm *next = elm->next;

	    while (elm!=NULL)
	    {
		  next = elm->next;
		  delete elm;
	      elm = next;
	    }
	    dataPtr = NULL;
	   }
}

void Vector::insertAfterElement(CObject *t,CObject *elmInsert)
{
	    
	    if (dataPtr == NULL)
		{
		 v_elm *elm = new v_elm(elmInsert,TRUE);
		 dataPtr = elm;
		}
		else
		{
			v_elm *elm = (v_elm*)dataPtr; 

			while (elm!=NULL)
			{
				//TRACE("elm=0x%x t=0x%x\n",elm,t);
				if (elm->ptr == t)
				{
					//
					//AfxMessageBox("Found Where to Inset!");
					v_elm *p = elm->next;
					//v_elm *q = elm->prev;
					elm->next = new v_elm(elmInsert,TRUE);
					elm->next->next = p;
					elm->next->prev = elm;
					return;
				}
				if (elm->next == NULL) 
					break;
				elm = elm->next;
			}
			// elm should hold next pointer			
			elm->next = new v_elm(elmInsert,TRUE);
			elm->next->prev = elm;
		}
}

void Vector::insertBeforeElement(CObject *t,CObject *elmInsert)
{
	    if (dataPtr == NULL)
		{
		 v_elm *elm = new v_elm(elmInsert,TRUE);
		 dataPtr = elm;
		}
		else
		{
			v_elm *elm = (v_elm*)dataPtr;
			v_elm *prev = elm;

			while (elm!=NULL)
			{				
				if (elm->ptr == t)
				{
					v_elm *p = prev->next;
					prev->next = new v_elm(elmInsert,TRUE);
					prev->next->next = p;
					return;
				}
				if (elm->next == NULL) 
					break;
				prev = elm;
				elm  = elm->next;
				
			}
			elm->next = new v_elm(elmInsert,TRUE);
			elm->next->prev = elm;
		}

}

void Vector::addElementReference(CObject *obj)
{
	    // add only a reference so Vector cannot delete data
	    if (dataPtr == NULL)
		{
		 v_elm *elm = new v_elm(obj,FALSE);
		 dataPtr = elm;
		}
		else
		{
			v_elm *elm = (v_elm*)dataPtr; 

			while (elm!=NULL)
			{
				if (elm->next == NULL) 
					break;
				elm = elm->next;
			}
			// elm should hold next pointer
			elm->next = new v_elm(obj,FALSE);
			elm->next->prev = elm;
		}
}

void Vector::addElement(CObject *obj)
{
	    if (dataPtr == NULL)
		{
		 v_elm *elm = new v_elm(obj,TRUE);
		 dataPtr = elm;
		 elm->prev = elm;
		}
		else
		{
			v_elm *elm = (v_elm*)dataPtr; 

			while (elm!=NULL)
			{
				if (elm->next == NULL) 
					break;
				elm = elm->next;
			}
			// elm should hold next pointer
			elm->next = new v_elm(obj,TRUE);
			elm->next->prev = elm;
		}
}

BOOL Vector::removeElement(CObject *obj)
{
	v_elm *elm = (v_elm*)dataPtr;
	v_elm *next = elm->next;
	v_elm *last = elm;

	if (elm->ptr == obj)
	{
		dataPtr = next;
		delete elm;
		return TRUE;
	}

	while (elm!=NULL)
	{
	   next = elm->next;

	   if (elm->ptr == obj)
	   {
		  last->next = next;
		  if (next!=NULL) next->prev = last;		  
		  delete elm;
		  return TRUE;
	   }
	   last = elm;
	   elm = next;
	}
	return FALSE;

}

BOOL Vector::removeElementRef(CObject *obj)
{
    v_elm *elm = (v_elm*)dataPtr;
	v_elm *next = elm->next;
	v_elm *last = elm;

	if (elm->ptr == obj)
	{
		dataPtr = next;
		//delete elm;
		return TRUE;
	}

	while (elm!=NULL)
	{
	   next = elm->next;

	   if (elm->ptr == obj)
	   {
		  last->next = next;
		  if (next) next->prev = last;		  
		  //delete elm;
		  return TRUE;
	   }
	   last = elm;
	   elm = next;
	}
	return FALSE;
}

int Vector::size()
{
	int count = 0;

	if (dataPtr==NULL) 
		return 0;
	else
	{   
	   v_elm *elm = (v_elm*)dataPtr;
	   while (elm!=NULL)
	   {
		   count++;
		   if (elm->next == NULL) 
						return count;
		   elm = elm->next;
	   }
	   return count;
	}
}

CObject * Vector::firstElement()
{
	//return elementAt(0);
	v_elm *elm = (v_elm*)dataPtr;
	if (elm)
	 return elm->ptr;
	else
	 return NULL;
}

CObject *Vector::lastElement()
{
	//return elementAt(size()-1);

	v_elm *elm = (v_elm*)dataPtr;
	if (elm)
	 return elm->prev->ptr;
	else
	 return NULL;

}

CObject * Vector::elementAt(int idx)
{
	int count=0;
	v_elm *elm = (v_elm*)dataPtr;

	while (elm!=NULL)
	{
		   if (count++ == idx) return elm->ptr;
		   //count++;
		   //if ((elm = elm->next) == NULL)  return NULL;
		   elm = elm->next;
	}
	return NULL;
}

int Vector::findElementIndex(CObject *obj)
{
	int count=0;
	v_elm *elm = (v_elm*)dataPtr;

	while (elm!=NULL)
	{
		   if (obj == elm->ptr) return count;
		   count++;
		   if ((elm = elm->next) == NULL)  return -1;
	}
	return -1;
}

CObject *Vector::previous(CObject *t)
{
	    v_elm *prev=NULL;

	    if (dataPtr == NULL)
		{
		  AfxMessageBox("Cannot find previous item Empty List");
		}
		else
		{
			v_elm *elm = (v_elm*)dataPtr; 

			while (elm!=NULL)
			{
				if (elm->ptr == t)
				{
					if (prev==NULL) 
						return lastElement();
					return prev->ptr;
				}
				if (elm->next == NULL) 
					break;
				prev = elm;
				elm  = elm->next;

			}
		}
		return NULL;
}

CObject *Vector::next(CObject *t)
{
	    v_elm *nextitem=NULL;

	    if (dataPtr == NULL)
		{
		  AfxMessageBox("Cannot find next item Empty List");
		}
		else
		{
			v_elm *elm = (v_elm*)dataPtr;
			nextitem = elm->next;

			while (elm!=NULL)
			{
				if (elm->ptr == t)
				{
					if (nextitem==NULL) 
						return firstElement();
					return nextitem->ptr;
				}
				//if (elm->next == NULL) 
				//	break;
				elm  = elm->next;
				nextitem = elm->next;
			}
		}
		return NULL;
}


Vector * Vector::Copy()
{
	return new Vector(this);
}

