#include "CGPLFile.h"
#include "ObjectTree.h"
#include "resource.h"

#include "mmsystem.h"


class CWav: public CGplFile
{
   public:
	CWav():CGplFile(t_wav)
	{
		data = NULL;
	}

	~CWav()
	{
		free(data);
		data = NULL;
	}

	CString GetDefaultExtension()
	{
		return CString("*.wav");
	}

	BOOL CWav::Read(const char *filename)
    {
	  FILE *fp = FOPEN(filename,"rb");

	  if (fp == NULL)
	  {
		return FALSE;
	  }
	  length = GetFileLength(fp);
	  Read(fp);
	  return TRUE;
    }

    BOOL CWav::Read(FILE *fp)
    {
	  if (dataLoaded) return TRUE;
	  data = (unsigned char*)malloc(length*sizeof(char*));
	  fread(data,1,length,fp);
	  return TRUE;
    }


	void Explore()
	{
		GetFile();
		if (data) PlaySound((LPCSTR)data, NULL, SND_SYNC | SND_MEMORY);
	}

	unsigned char *data;
};