#include "CGPLFile.h"
#include "ObjectTree.h"
#include "resource.h"

typedef struct 
{
	float d1; //speed
	float d2;
	float d3; //position
	float d4;
	int d5;
} t_LPSection;

class CLp: public CGplFile
{
   public:
	CLp():CGplFile(t_lp)
	{
	}

	CString GetDefaultExtension()
	{
		return CString("lp");
	}

    BOOL Read(const char *filename);
	BOOL Read(FILE *fp);
	HTREEITEM lprp;

	void LoadTree(HTREEITEM parent,CObjectTree *tree)
	{
		CString buffer;
	    if (dataLoaded) buffer.Format("Lp File %s",filename);
		else buffer.Format("Could not load Lp File %s",filename);
		int id = dataLoaded ? IDB_FILE : IDB_FILE_ERR;
	    HTREEITEM lpp = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(id));
		tree->m_ObjectTree.SetItemData(lpp,(DWORD)this);
		if (dataLoaded)
		{
		  subTree = tree->insertInfoNode(lpp, "subTree",TO_ID(IDB_OFFSET));
		}		
	}

	void Expand(CObjectTree *tree,HTREEITEM parent)
	{
		if (subTree){
			   tree->m_ObjectTree.DeleteItem(subTree);

			   CString buffer;
			   buffer.Format("Major Version = %d",Major_version);
		       tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
		       buffer.Format("Minor Version = %d",Minor_version);
		       tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
               buffer.Format("Number Of Records = %d",numberOfRecords);
		       lprp = tree->insertInfoNode(parent, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
			   for(int i=0;i<numberOfRecords;i++)
	           {
		         buffer.Format("? %f ?=%f ?=%f ?=%f ?=%d",records[i].d1,records[i].d2,records[i].d3,records[i].d4,records[i].d5);
		         tree->insertInfoNode(lprp, (LPSTR)(LPCSTR)buffer,TO_ID(IDB_OFFSET));
	           }
			   subTree = NULL;
		}
		
	}

	void Explore()
	{
		//((CMy3DOEditorApp*)AfxGetApp())->OnCLpDocumentView(TdoDocument);
	}


	int Major_version;
	int Minor_version;
	int numberOfRecords;

	t_LPSection *records;
};
